#ifdef WIN32
#include <Config-win.h>
#endif
#include <stdio.h>
#ifndef WIN32
#include <sys/time.h>
#endif
#include <time.h>

#include "ExecHandler.h"




ExecHandler::ExecHandler(Database& db)
:SocketHandler()
,m_db(db)
,m_start(time(NULL))
{
}


ExecHandler::~ExecHandler()
{
}


std::string ExecHandler::datetime2httpdate(const std::string& dt)
{
	char slask[8];
	struct tm tp;
	time_t t;
	char *days[] = { "Sun","Mon","Tue","Wed","Thu","Fri","Sat" };
	char *months[] = { "Jan","Feb","Mar","Apr","May","Jun",
	                   "Jul","Aug","Sep","Oct","Nov","Dec" };
	int i;
	char s[40];

/* 1997-12-16 09:50:40 */

	if (dt.size() == 19) // && (int)strlen(dt) == 19)
	{
		slask[4] = 0;
		tp.tm_year = atoi(strncpy(slask,dt.c_str(),4)) - 1900;
		slask[2] = 0;
		i = atoi(strncpy(slask,dt.c_str() + 5,2)) - 1;
		tp.tm_mon = i >= 0 ? i : 0;
		tp.tm_mday = atoi(strncpy(slask,dt.c_str() + 8,2));
		tp.tm_hour = atoi(strncpy(slask,dt.c_str() + 11,2));
		tp.tm_min = atoi(strncpy(slask,dt.c_str() + 14,2));
		tp.tm_sec = atoi(strncpy(slask,dt.c_str() + 17,2));
		tp.tm_wday = 0;
		tp.tm_yday = 0;
		tp.tm_isdst = 0;
		t = mktime(&tp);
		if (t == -1)
		{
//			printf("datetime2httpdate() failed\n");
		}

		sprintf(s,"%s, %02d %s %d %02d:%02d:%02d GMT",
		 days[tp.tm_wday],
		 tp.tm_mday,
		 months[tp.tm_mon],
		 tp.tm_year + 1900,
		 tp.tm_hour,tp.tm_min,tp.tm_sec);
	} 
	else
	{
		*s = 0;
	}
	return s;
}


std::string ExecHandler::GetStart()
{
	struct tm* tp = localtime(&m_start);
	char slask[40];
	sprintf(slask,"%d-%02d-%02d %02d:%02d:%02d",
		tp -> tm_year + 1900,
		tp -> tm_mon + 1,
		tp -> tm_mday,
		tp -> tm_hour,tp -> tm_min,tp -> tm_sec);
	return datetime2httpdate( slask );
}


std::string ExecHandler::GetDate()
{
	time_t t = time(NULL);
	struct tm* tp = localtime(&t);
	char slask[40];
	sprintf(slask,"%d-%02d-%02d %02d:%02d:%02d",
		tp -> tm_year + 1900,
		tp -> tm_mon + 1,
		tp -> tm_mday,
		tp -> tm_hour,tp -> tm_min,tp -> tm_sec);
	return slask;
}


