#ifndef _EXECSOCKET_H
#define _EXECSOCKET_H

#include <SocketHandler.h>
#include <HTTPSocket.h>


class ExecSocket : public HTTPSocket
{
public:
	ExecSocket(SocketHandler& );
	~ExecSocket();

	void OnFirst();
	void OnHeader(const std::string& ,const std::string& );
	void OnHeaderComplete();
	void OnData(const char *,size_t);

	void Exec();

	const std::string& GetHttpDate();

private:
	void header(FILE *,int,const std::string& );
	void Send64(const std::string& str64, const std::string& type);
	int m_content_length;
static	int m_request_count;
	FILE *m_file;
	int m_received;
	std::string m_tmpname;
	int m_request_id;
	// headers
	std::string m_http_cookie;
	std::string m_content_type;
	std::string m_content_length_str;
	std::string m_if_modified_since;
	std::string m_http_date;
};




#endif // _EXECSOCKET_H
