// checks.cpp
/*
Copyright (C) 2001-2004  Anders Hedstrom (grymse@alhem.net)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
#ifdef WIN32
#include <Config-win.h>
static int getpid() { return 0; }
#endif
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <mysql/mysql.h>
#ifndef WIN32
#include <unistd.h>
#endif
#include <libmysqlwrapped.h>
#include <libdbd.h>
#include <string>
#include <libcgi++.h>

#include "dbd.h"
#include "utils.h"
#include "html.h"
#include "gsql.h"
#include "reserved.h"
#include "pages.h"


/*
 * check database, table, field
 */

db::Dbs *check_db(Database& db,Query& qin,Form *form,Cookies *cs,long sel,db::Users *user,short *refresh)
{
	Query *qd = new Query(db);
	db::Dbs *sdb = NULL;
	db::Access *a;
	db::Kommentar *k;
	db::Grplinks *gl;
	char *kommentar = NULL;
	long seldb = sel;
	long l,q;
	long usernum = user -> num;
	long grpnum;
	short ir;		// is_reserved(newname)
	short ok = 0;
	char slask[300];
	char newname[40];
	char sql[1000];
	char description[80];
	char oldname[40];
	char tmp[80];

	// create database
	if (form -> getvalue("createdb",slask,20) && *slask && atoi(slask))
	{
		if (!form -> getvalue("name",newname,40))
			error("name");
		if (!form -> getvalue("description",description,80))
			error("description");
		if (!form -> getvalue("grpnum",slask,20))
			error("grpnum");
		grpnum = atol(slask);
		l = form -> getlength("kommentar");
		kommentar = new char[l + 144];
		form -> getvalue("kommentar",kommentar,l + 144);
		textareain(kommentar);

		ir = is_reserved(newname);
		if (ir)
		{
			sprintf(errstr,"'%s' is a reserved word",newname);
		}
		sprintf(sql,"select num from dbs where name='%s'",db.safestr(newname).c_str());
		l = qd -> get_count(sql);

		if (l)
		{
			sprintf(errstr,"There already exists a database with the name '%s'",newname);
		}
		if (!name_ok(newname))
		{
			sprintf(errstr,"Invalid characters in name '%s'",newname);
		}
		sprintf(sql,"select count(*) from dbs where owner=%ld",user -> num);
		q = qd -> get_count(sql);

		if (q >= user -> maxdbs && !user -> superuser)
		{
			sprintf(errstr,"Allowed number of databases already created");
		}
		if (!ir && !l && name_ok(newname) && (user -> superuser || q < user -> maxdbs))
		{
			bool ok = true;
#ifdef LIVEDB
			// create database
			sprintf(sql,"create database %s",newname);
			if (!qd -> execute(sql))
			{
				strcpy(errstr,qd -> GetError().c_str());
				ok = false;
			}
#endif
			if (ok)
			{
				sdb = new db::Dbs(&db);	// create empty object
				sdb -> owner = usernum;
				sdb -> createdate = datetime(); //strcpy(sdb -> createdate,datetime());
				sdb -> name = newname; //strcpy(sdb -> name,newname);
				sdb -> description = description; //strcpy(sdb -> description,description);
				seldb = sdb -> insert();
				set_cookie(cs,"seldb",seldb);
				delete sdb;
				sdb = NULL;

				a = new db::Access(&db);
				a -> usernum = usernum;
				a -> dbnum = seldb;
				a -> r = 1;		// copy access
				a -> w = 1;
				a -> c = 1;
				a -> d = 1;
				a -> rdata = 1;
				a -> wdata = 1;
				a -> insert();
				delete a;

				gl = new db::Grplinks(&db);
				gl -> usernum = user -> num;
				gl -> grpnum = grpnum;
				gl -> dbnum = seldb;
				gl -> save();
				delete gl;

				if (*kommentar)
				{
					k = new db::Kommentar(&db);
					k -> dbnum = seldb;
					k -> usernum = usernum;
					k -> dateposted = datetime(); //strcpy(k -> dateposted,datetime());
					k -> reason = "Created"; //strcpy(k -> reason,"Created");
					//k -> kommentar = new char[strlen(kommentar) + 1];
					k -> kommentar = kommentar; //strcpy(k -> kommentar,kommentar);
					k -> insert();
					delete k;
				}
				// only refresh frames when operation is OK
				// otherwise the error message will be lost
				*refresh = *refresh + 1;
			} // if (ok)
		}
	}
	if (seldb > 0)
	{
		sprintf(sql,"select num from access where usernum=%ld and dbnum=%ld",user -> num,seldb);
		if (qd -> get_count(sql))
		{
			sdb = new db::Dbs(db,seldb);
		}
		else
		{
			seldb = 0;
		}
	}
	sprintf(sql,"select * from access where usernum=%ld and dbnum=%ld",user -> num,seldb);
	a = new db::Access(&db,sql);

	// change database
	if (sdb && form -> getvalue("changedb",slask,20) && *slask && atoi(slask) && a -> w)
	{
		if (!form -> getvalue("num",slask,20))
			error("num");
		l = atol(slask);
		if (l != sdb -> num)
			error("sdb num mismatch");
		if (!form -> getvalue("name",newname,20))
			error("name");
		if (!form -> getvalue("description",description,80))
			error("description");
		if (!form -> getvalue("grpnum",slask,20))
			error("grpnum");
		grpnum = atol(slask);
		l = form -> getlength("kommentar");
		kommentar = new char[l + 144];
		form -> getvalue("kommentar",kommentar,l + 144);
		textareain(kommentar);

		ir = is_reserved(newname);
		if (ir)
		{
			if (!strcmp(newname,sdb -> name.c_str()))	// no change
			{
				sprintf(warningstr,"'%s' is a reserved word",newname);
				ok++;
			}
			else
			{
				sprintf(errstr,"'%s' is a reserved word",newname);
			}
		}
		sprintf(sql,"select num from dbs where name='%s' and num<>%ld",db.safestr(newname).c_str(),sdb -> num);
		l = qd -> get_count(sql);

		if (l)
		{
			sprintf(errstr,"There already exists a database with the name '%s'",newname);
		}
		if (!name_ok(newname))
		{
			sprintf(errstr,"Invalid characters in name '%s'",newname);
		}
		if ((ok || !ir) && !l && name_ok(newname))
		{
			strcpy(oldname,sdb -> name.c_str());
#ifdef LIVEDB
			// change database
			// mysqldump olddb > tmp
			// mysqladmin create newdb
			// mysql newdb < tmp
			// mysqladmin drop olddb
			if (strcmp(oldname,newname))
			{
				sprintf(tmp,"%smysqldump.%d",tmp_path,getpid());
				sprintf(slask,"%s %s > %s",MYSQLDUMP,oldname,tmp);
				syscall(slask);
				sprintf(sql,"create database %s",newname);
				if (qd -> execute(sql))
				{
					sprintf(slask,"%s %s < %s",MYSQL_program,newname,tmp);
					syscall(slask);
					sprintf(sql,"drop database %s",oldname);
					if (!qd -> execute(sql))
					{
						strcpy(errstr,qd -> GetError().c_str());
						ok = false;
					}
				}
				else
				{
					strcpy(errstr,qd -> GetError().c_str());
					ok = false;
				}
			}
#endif
			if (ok)
			{
				sdb -> changedby = usernum;
				sdb -> changedate = datetime(); //strcpy(sdb -> changedate,datetime());
				sdb -> name = newname; //strcpy(sdb -> name,newname);
				sdb -> description = description; //strcpy(sdb -> description,description);
				sdb -> version++;
				sdb -> update();

				sprintf(sql,"update grplinks set grpnum=%ld where usernum=%ld and dbnum=%ld",grpnum,user -> num,sdb -> num);
				qd -> execute(sql);

				if (*kommentar)
				{
					k = new db::Kommentar(&db);
					k -> dbnum = seldb;
					k -> usernum = usernum;
					k -> dateposted = datetime(); //strcpy(k -> dateposted,datetime());
					k -> reason = "Changed"; //strcpy(k -> reason,"Changed");
					//k -> kommentar = new char[strlen(kommentar) + 1];
					k -> kommentar = kommentar; //strcpy(k -> kommentar,kommentar);
					k -> insert();
					delete k;
				}
				// only refresh frames when operation is OK
				// otherwise the error message will be lost
				*refresh = *refresh + 1;
			}
		}
	}
	// delete database
	if (sdb && form -> getvalue("deletedb",slask,20) && *slask && atoi(slask) && a -> d)
	{
		l = form -> getlength("kommentar");
		kommentar = new char[l + 144];
		form -> getvalue("kommentar",kommentar,l + 144);
		textareain(kommentar);

		sdb -> deleted = !sdb -> deleted;
		sdb -> deletedby = usernum;
		sdb -> deletedate = datetime(); //strcpy(sdb -> deletedate,datetime());
		sdb -> version++;
		sdb -> update();

		if (*kommentar)
		{
			k = new db::Kommentar(&db);
			k -> dbnum = seldb;
			k -> usernum = usernum;
			k -> dateposted = datetime(); //strcpy(k -> dateposted,datetime());
			k -> reason = "Deleted"; //strcpy(k -> reason,"Deleted");
			//k -> kommentar = new char[strlen(kommentar) + 1];
			k -> kommentar = kommentar; //strcpy(k -> kommentar,kommentar);
			k -> insert();
			delete k;
		}
#ifdef LIVEDB
		// delete database
		// TODO:

		if (sdb -> deleted)
		{
		// drop database

		}
		else
		{
		// create and resync?

		}
#endif
		*refresh = *refresh + 1;
	}
// write comment
	if (sdb && form -> getvalue("writedb",slask,20) && *slask && atoi(slask))
	{
		l = form -> getlength("kommentar");
		kommentar = new char[l + 144];
		form -> getvalue("kommentar",kommentar,l + 144);
		textareain(kommentar);

		if (*kommentar)
		{
			k = new db::Kommentar(&db);
			k -> dbnum = seldb;
			k -> usernum = usernum;
			k -> dateposted = datetime(); //strcpy(k -> dateposted,datetime());
			k -> reason = "A comment"; //strcpy(k -> reason,"A comment");
			//k -> kommentar = new char[strlen(kommentar) + 1];
			k -> kommentar = kommentar; //strcpy(k -> kommentar,kommentar);
			k -> insert();
			delete k;
		}
	}
	if (kommentar)
	{
		delete kommentar;
	}
	delete qd;
	delete a;
	return sdb;
}

db::Tbls *check_tbl(Database& db,Query& qin,Form *form,Cookies *cs,db::Dbs *sdb,long sel,db::Users *user,short *refresh)
{
	bool ddebug = false; //true;
if (ddebug) fprintf(out,"check_tbl\n");
fflush(out);
	// live database
	Database livedb("localhost", "root", "", sdb ? sdb -> name : "");
#ifdef WIN32
#else
  SysLog log("livedata");
	livedb.RegErrHandler(&log);
#endif
	Query lq(livedb);
if (ddebug) fprintf(out,"check_tbl: livedb ok\n");
fflush(out);
	//
	Query *qd = new Query(db);
	db::Tbls *stbl = NULL;
	db::Kommentar *k;
	db::Access *a;
	db::Flds *sfld;
	db::Dbs *tempdb;
	db::Indexs *tempindex;
	db::Indexlist *il;
	char *kommentar = NULL;
	long seltbl = sel;
	long l,q;
	long usernum = user -> num;
	long dbnum;
	long olddbnum;
	long tblgrpnum;
	short ir;		// is_reserved(newname)
	short ok = 0;
	char slask[300];
	char newname[40];
	char sql[1000];
	char description[80];
	char oldname[40];

	sprintf(sql,"select * from access where usernum=%ld and dbnum=%ld",user -> num,sdb ? sdb -> num : 0);
	a = new db::Access(&db,sql);
if (ddebug) fprintf(out,"check_tbl: new access ok\n");
fflush(out);

	// create table
	if (sdb && form -> getvalue("createtbl",slask,20) && *slask && atoi(slask) && a -> c)
	{
		if (!form -> getvalue("name",newname,40))
			error("name");
		if (!form -> getvalue("description",description,80))
			error("description");
		if (!form -> getvalue("tblgrpnum",slask,20))
			error("tblgrpnum");
		tblgrpnum = atol(slask);
		l = form -> getlength("kommentar");
		kommentar = new char[l + 144];
		form -> getvalue("kommentar",kommentar,l + 144);
		textareain(kommentar);

		ir = is_reserved(newname);
		if (ir)
		{
			sprintf(errstr,"'%s' is a reserved word",newname);
		}
		sprintf(sql,"select num from tbls where dbnum=%ld and name='%s'",sdb -> num,db.safestr(newname).c_str());
		l = qd -> get_count(sql);

		if (l)
		{
			sprintf(errstr,"Table '%s' already exists in database '%s' (may be deleted)",newname,sdb -> name.c_str());
		}
		if (!name_ok(newname))
		{
			sprintf(errstr,"Invalid characters in name '%s'",newname);
		}
		sprintf(sql,"select count(*) from tbls where owner=%ld",user -> num);
		q = qd -> get_count(sql);

		if (q >= user -> maxtbls && !user -> superuser)
		{
			sprintf(errstr,"Allowed number of tables already created");
		}
		if (!ir && !l && name_ok(newname) && (user -> superuser || q < user -> maxtbls))
		{
			bool ok = true;
#ifdef LIVEDB
			// create table
			// if not autocreatenum, table will be created when first table column
			// are added
			if (user -> flags & UF_AUTOCREATENUM)
			{
				sprintf(sql,"create table %s ( num integer auto_increment not null, primary key(num) )",newname );
				if (!lq.execute(sql))
				{
					strcpy(errstr,lq.GetError().c_str());
					ok = false;
				}
			}
/*
			if (sfld)
			{
				strcpy(description,typestring(sfld));
				sprintf(sql,"create table %s ( %s %s, primary key(%s) )",
					stbl -> name.c_str(),
					sfld -> name.c_str(),
					description,
					sfld -> name.c_str());
				sprintf(slask,"echo \"create table %s ( %s %s, primary key(%s) )\" | %s %s > /dev/null 2>/dev/null",
				 stbl -> name.c_str(),
				 sfld -> name.c_str(),
				 description,
				 sfld -> name.c_str(),
				 MYSQL_program,
				 sdb -> name.c_str());
				syscall(slask);
			}
*/
#endif
			if (ok)
			{
			stbl = new db::Tbls(&db);	// create empty object
			stbl -> dbnum = sdb -> num;
			stbl -> owner = usernum;
			stbl -> createdate = datetime(); //strcpy(stbl -> createdate,datetime());
			stbl -> name = newname; //strcpy(stbl -> name,newname);
			stbl -> description = description; //strcpy(stbl -> description,description);
			stbl -> tblgrpnum = tblgrpnum;
			seltbl = stbl -> insert();
			set_cookie(cs,"seltbl",seltbl);

			sdb -> changedby = usernum;
			sdb -> changedate = datetime(); //strcpy(sdb -> changedate,datetime());
			sdb -> version++;
			sdb -> update();

			// create field "num" if (user -> autocreatenum)
			if (user -> flags & UF_AUTOCREATENUM)
			{
				sfld = new db::Flds(&db);	// create empty object
				sfld -> tblnum = stbl -> num;
				sfld -> owner = usernum;
				sfld -> createdate = datetime(); //strcpy(sfld -> createdate,datetime());
				sfld -> name = "num"; //strcpy(sfld -> name,"num");
				sfld -> description = "autocreated primary key auto_increment field"; //strcpy(sfld -> description,"autocreated primary key auto_increment field");
				sfld -> fieldtype = 2;
				sfld -> fieldstr = "INT"; //strcpy(sfld -> fieldstr,"INT");
				sfld -> fieldflags = FF_AUTO_INCREMENT;
				sfld -> decimallength = 0;
				sfld -> defaultvalue = ""; //*sfld -> defaultvalue = 0;
				sfld -> charlength = 0;
				sfld -> integerlength = 11;
				sfld -> minvalue = 0;
				sfld -> maxvalue = -1;
				//sfld -> options = new char[1];
				sfld -> options = ""; //strcpy(sfld -> options,"");
				sfld -> ptrtotblnum = 0;
				sfld -> ordning = 1;
				set_cookie(cs,"selfld",sfld -> insert());

				tempindex = new db::Indexs(&db);
				tempindex -> tblnum = stbl -> num;
				tempindex -> owner = usernum;
				tempindex -> createdate = datetime(); //strcpy(tempindex -> createdate,datetime());
				tempindex -> description = "autocreated primary key";
				tempindex -> name = "PrimaryKey";
				tempindex -> typ = "PRIMARY";
				tempindex -> save();

				il = new db::Indexlist(&db);
				il -> indexnum = tempindex -> num;
				il -> fldnum = sfld -> num;
				il -> length = -1;
				il -> save();

				delete tempindex;
				delete il;
			}
			else
			{
				sfld = NULL;
			}
			if (*kommentar)
			{
				k = new db::Kommentar(&db);
				k -> tblnum = seltbl;
				k -> usernum = usernum;
				k -> dateposted = datetime();
				k -> reason = "Created";
				//k -> kommentar = new char[strlen(kommentar) + 1];
				k -> kommentar = kommentar; //strcpy(k -> kommentar,kommentar);
				k -> insert();
				delete k;
			}
			delete stbl;
			stbl = NULL;
			if (sfld)
			{
				delete sfld;
				sfld = NULL;
			}
			// only refresh frames when operation is OK
			// otherwise the error message will be lost
			*refresh = *refresh + 1; // refresh frames
			}
		}
	}
	if (seltbl > 0)
	{
		stbl = new db::Tbls(db,seltbl);
		sprintf(sql,"select num from access where usernum=%ld and dbnum=%ld",user -> num,stbl -> dbnum);
		if (!qd -> get_count(sql))
		{
			seltbl = 0;
			delete stbl;
			stbl = NULL;
		}
	}
if (ddebug) fprintf(out,"check_tbl: create table ok\n");
fflush(out);
	// change table
	if (sdb && stbl && form -> getvalue("changetbl",slask,20) && *slask && atoi(slask) && a -> w)
	{
		if (!form -> getvalue("num",slask,20))
			error("num");
		l = atol(slask);
		if (l != stbl -> num)
			error("stbl num mismatch");
		if (!form -> getvalue("name",newname,20))
			error("name");
		if (!form -> getvalue("description",description,80))
			error("description");
		if (!form -> getvalue("dbnum",slask,20))
			error("dbnum");
		dbnum = atol(slask);
		if (!form -> getvalue("tblgrpnum",slask,20))
			error("tblgrpnum");
		tblgrpnum = atol(slask);
		l = form -> getlength("kommentar");
		kommentar = new char[l + 144];
		form -> getvalue("kommentar",kommentar,l + 144);
		textareain(kommentar);

		ir = is_reserved(newname);
		if (ir)
		{
			if (!strcmp(newname,stbl -> name.c_str()))
			{
				sprintf(warningstr,"'%s' is a reserved word",newname);
				ok++;
			}
			else
			{
				sprintf(errstr,"'%s' is a reserved word",newname);
			}
		}
		sprintf(sql,"select num from tbls where dbnum=%ld and name='%s' and num<>%ld",sdb -> num,db.safestr(newname).c_str(),stbl -> num);
		l = qd -> get_count(sql);

		if (l)
		{
			sprintf(errstr,"Table '%s' already exists in database '%s' (may be deleted)",newname,sdb -> name.c_str());
		}
		if (!name_ok(newname))
		{
			sprintf(errstr,"Invalid characters in name '%s'",newname);
		}
		if ((ok || !ir) && !l && name_ok(newname))
		{
			olddbnum = stbl -> dbnum;
			strcpy(oldname,stbl -> name.c_str());

			stbl -> dbnum = dbnum;
			stbl -> changedby = usernum;
			stbl -> changedate = datetime(); //strcpy(stbl -> changedate,datetime());
			stbl -> name = newname; //strcpy(stbl -> name,newname);
			stbl -> description = description; //strcpy(stbl -> description,description);
			stbl -> tblgrpnum = tblgrpnum;
			stbl -> version++;
			stbl -> update();

			sdb -> changedby = usernum;
			sdb -> changedate = datetime();
			sdb -> version++;
			sdb -> update();

			if (*kommentar)
			{
				k = new db::Kommentar(&db);
				k -> tblnum = seltbl;
				k -> usernum = usernum;
				k -> dateposted = datetime();
				k -> reason = "Changed";
				//k -> kommentar = new char[strlen(kommentar) + 1];
				k -> kommentar = kommentar; //strcpy(k -> kommentar,kommentar);
				k -> insert();
				delete k;
			}
#ifdef LIVEDB
			// change table
			// TODO: OK
			// kolla om table flyttats till annan databas
			//  ... mysqldump sdb stbl > tmp
			//  ... mysql drop stbl
			//  ... mysql newdb < tmp
			
			// TODO - inte flytta tabell utan kolumner - den finns ej i livebd - OK
			if (stbl -> dbnum != olddbnum)
			{
				sprintf(sql,"select count(*) from flds where tblnum=%ld",stbl -> num);
				if (qd -> get_count(sql))
				{
					tempdb = new db::Dbs(db,stbl -> dbnum);
					sprintf(slask,"%s %s %s > %stable.%s.sql",
					 MYSQLDUMP,sdb -> name.c_str(),stbl -> name.c_str(),tmp_path,
           stbl -> name.c_str());
					syscall(slask);
					sprintf(slask,"%s %s < %stable.%s.sql",MYSQL_program,
            tempdb -> name.c_str(),tmp_path,stbl -> name.c_str());
					if (!syscall(slask))
					{
						sprintf(slask,"echo \"drop table %s\" | %s %s",stbl -> name.c_str(),MYSQL_program,sdb -> name.c_str());
						syscall(slask);
					}
					delete tempdb;
				}
			}
		// mysql 'alter table ... rename'
			if (strcmp(oldname,newname))
			{
				sprintf(sql,"select count(*) from flds where tblnum=%ld",stbl -> num);
				if (qd -> get_count(sql))
				{
					sprintf(slask,"echo \"alter table %s rename %s\" | %s %s > /dev/null 2>/dev/null",
					 oldname,newname,MYSQL_program,sdb -> name.c_str());
					syscall(slask);
				}
			}
#endif
			*refresh = *refresh + 1;
		}
	}
	// delete table
	if (sdb && stbl && form -> getvalue("deletetbl",slask,20) && *slask && atoi(slask) && a -> d)
	{
		l = form -> getlength("kommentar");
		kommentar = new char[l + 144];
		form -> getvalue("kommentar",kommentar,l + 144);
		textareain(kommentar);

		stbl -> deleted = !stbl -> deleted;
		stbl -> deletedby = usernum;
		stbl -> deletedate = datetime(); //strcpy(stbl -> deletedate,datetime());
		stbl -> version++;
		stbl -> update();

		sdb -> changedby = usernum;
		sdb -> changedate = datetime();
		sdb -> version++;
		sdb -> update();

		if (*kommentar)
		{
			k = new db::Kommentar(&db);
			k -> tblnum = seltbl;
			k -> usernum = usernum;
			k -> dateposted = datetime();
			k -> reason = "Deleted";
			//k -> kommentar = new char[strlen(kommentar) + 1];
			k -> kommentar = kommentar; //strcpy(k -> kommentar,kommentar);
			k -> insert();
			delete k;
		}
#ifdef LIVEDB
		// delete table
		if (stbl -> deleted)
		{
		// TODO: mysqldump sdb stbl > sdb.stbl.backup.sql
		//  mysql drop stbl

		}
		else
		{
		// TODO: mysql sdb < sdb.stbl.backup.sql

		}
#endif
		*refresh = *refresh + 1;
	}
// write comment
	if (sdb && stbl && form -> getvalue("writetbl",slask,20) && *slask && atoi(slask))
	{
		l = form -> getlength("kommentar");
		kommentar = new char[l + 144];
		form -> getvalue("kommentar",kommentar,l + 144);
		textareain(kommentar);

		if (*kommentar)
		{
			k = new db::Kommentar(&db);
			k -> tblnum = seltbl;
			k -> usernum = usernum;
			k -> dateposted = datetime();
			k -> reason = "A comment";
			//k -> kommentar = new char[strlen(kommentar) + 1];
			k -> kommentar = kommentar; //strcpy(k -> kommentar,kommentar);
			k -> insert();
			delete k;
		}
	}
if (ddebug) fprintf(out,"check_tbl: ok\n");
fflush(out);
	if (kommentar)
	{
		delete kommentar;
	}
	delete qd;
	delete a;
	return stbl;
}

db::Flds *check_fld(Database& db,Query& qin,Form *form,Cookies *cs,db::Dbs *sdb,db::Tbls *stbl,long sel,db::Users *user,short *refresh,db::Applications *sapp)
{
	// live database
	Database livedb("localhost", "root", "", sdb ? sdb -> name : "");
#ifdef WIN32
#else
  SysLog log("livedata");
	livedb.RegErrHandler(&log);
#endif
	Query lq(livedb);
	//
	Query q(db);
	Query *qd = new Query(db);
	db::Flds *sfld = NULL;
	db::Kommentar *k;
	db::Access *a;
	db::Flds *tempfld;
	db::Tbls *temptbl;
	char *kommentar = NULL;
	char *sql = new char[500];
	long selfld = sel;
	long l,qq,prevl = 0;
	long usernum = user -> num;
	long tblnum;
	long charlength,minvalue,maxvalue;
	long ptrtotblnum;
	long integerlength;
	long fieldtype;
	long fldnum = 0;
	long oldtblnum;
	long fieldflags;
	long decimallength;
	long numberlength;
	short ordning,prevordning = 0;
	short ir;		// is_reserved(newname)
	short ok = 0;
	short visa_status = 0;
	char slask[300];
	char newname[40];
	char *options = NULL;
	char description[80];
	char oldname[40];
	char fieldstr[40];
	char defaultvalue[40];
	char status[40];

	sprintf(sql,"select * from access where usernum=%ld and dbnum=%ld",user -> num,sdb ? sdb -> num : 0);
	a = new db::Access(&db,sql);

	if (sapp && stbl && !form -> getvalue("createfld",slask,20))
	{
		sprintf(sql,"select checked from apptables where appnum=%ld and tblnum=%ld",sapp -> num,stbl -> num);
		visa_status = qd -> get_count(sql);
	}
	// create field
	if (sdb && stbl && form -> getvalue("createfld",slask,20) && *slask && atoi(slask) && a -> c)
	{
		fieldflags = 0;

		if (!form -> getvalue("name",newname,40))
			error("name");
		if (!form -> getvalue("description",description,80))
			error("description");

// fieldtype 1-char,2-int,3-datetime,4-enum/options,5-ptr
// charlength
// integerlength
// minvalue
// maxvalue
// options
// ptrtotable

		if (!form -> getvalue("fieldtype",slask,20))
			error("fieldtype");
		fieldtype = atol(slask);

		sprintf(slask,"fieldstr%ld",fieldtype);
		form -> getvalue(slask,fieldstr,40);
		switch (fieldtype)
		{
		case 101: // char
			fieldtype = 1;
			strcpy(fieldstr, "CHAR");
			break;
		case 102: // varchar
			fieldtype = 1;
			strcpy(fieldstr, "VARCHAR");
			break;
		}
		if (!form -> getvalue("defaultvalue",defaultvalue,40))
			error("defaultvalue");
		if (!form -> getvalue("numberlength",slask,20))
			error("numberlength");
		numberlength = atol(slask);
		if (!form -> getvalue("decimallength",slask,20))
			error("decimallength");
		decimallength = atol(slask);
		// flags
		if (form -> getvalue("nullok",slask,20) && *slask && atoi(slask))
		{
			fieldflags |= FF_ALLOWNULL;
		}
		if (form -> getvalue("autoincr",slask,20) && *slask && atoi(slask))
		{
			fieldflags |= FF_AUTO_INCREMENT;
		}
		if (form -> getvalue("cvc_binary",slask,20) && *slask && atoi(slask))
		{
			fieldflags |= FF_BINARY;
		}
		if (fieldtype == 2)
		{
			if (form -> getvalue("int_uns",slask,20) && *slask && atoi(slask))
			{
				fieldflags |= FF_UNSIGNED;
			}
			if (form -> getvalue("int_zf",slask,20) && *slask && atoi(slask))
			{
				fieldflags |= FF_ZEROFILL;
			}
		}
		if (fieldtype == 6)
		{
			if (form -> getvalue("num_uns",slask,20) && *slask && atoi(slask))
			{
				fieldflags |= FF_UNSIGNED;
			}
			if (form -> getvalue("num_zf",slask,20) && *slask && atoi(slask))
			{
				fieldflags |= FF_ZEROFILL;
			}
		}
		if (!form -> getvalue("charlength",slask,20))
			error("length");
		charlength = atol(slask);
		if (!strcmp(fieldstr,"CHAR") || !strcmp(fieldstr,"VARCHAR"))
		{
			if (charlength > 255)
			{
				charlength = 255;
				sprintf(errstr,"Max string length for type %s is 255 characters - modified",fieldstr);
			}
		}
		if (!form -> getvalue("integerlength",slask,20))
			error("length");
		integerlength = atol(slask);
		if (!form -> getvalue("minvalue",slask,20))
			error("minvalue");
		minvalue = atol(slask);
		if (!form -> getvalue("maxvalue",slask,20))
			error("maxvalue");
		if (*slask)
		{
			maxvalue = atol(slask);
		}
		else
		{
			maxvalue = -1;
		}
		l = form -> getlength("options");
		options = new char[l + 144];
		if (!form -> getvalue("options",options,l + 144))
			error("options");
		if (!form -> getvalue("ptrtotable",slask,20))
			error("ptrtotable");
		ptrtotblnum = atol(slask);
		if (visa_status)
		{
			if (!form -> getvalue("status",status,40))
				error("status");
		}
		l = form -> getlength("kommentar");
		kommentar = new char[l + 144];
		form -> getvalue("kommentar",kommentar,l + 144);
		textareain(kommentar);

		ir = is_reserved(newname);
		if (ir)
		{
			sprintf(errstr,"'%s' is a reserved word",newname);
		}
		sprintf(sql,"select num from flds where tblnum=%ld and name='%s'",stbl -> num,db.safestr(newname).c_str());
		l = qd -> get_count(sql);

		if (l)
		{
			sprintf(errstr,"Field '%s' already exists in table '%s' (may be deleted)",newname,stbl -> name.c_str());
		}
		if (!name_ok(newname))
		{
			sprintf(errstr,"Invalid characters in name '%s'",newname);
		}
		sprintf(sql,"select count(*) from flds where owner=%ld",user -> num);
		qq = qd -> get_count(sql);

		if (qq >= user -> maxflds && !user -> superuser)
		{
			sprintf(errstr,"Allowed number of fields already created");
		}
		if (!ir && !l && name_ok(newname) && (user -> superuser || qq < user -> maxflds))
		{
			bool ok = true;
			sprintf(sql,"select max(ordning) from flds where tblnum=%ld",stbl -> num);
			ordning = qd -> get_count(sql);

			// create db::Flds object but do not save it before LIVEDB op
			sfld = new db::Flds(&db);	// create empty object
			sfld -> tblnum = stbl -> num;
			sfld -> owner = usernum;
			sfld -> createdate = datetime(); //strcpy(sfld -> createdate,datetime());
			sfld -> name = newname; //strcpy(sfld -> name,newname);
			sfld -> description = description; //strcpy(sfld -> description,description);
			sfld -> fieldtype = fieldtype;
			sfld -> fieldstr = fieldstr; //strcpy(sfld -> fieldstr,fieldstr);
			sfld -> fieldflags = fieldflags;
			sfld -> decimallength = decimallength;
			sfld -> defaultvalue = defaultvalue; //strcpy(sfld -> defaultvalue,defaultvalue);
			sfld -> charlength = charlength;
			sfld -> integerlength = (fieldtype == 2) ? integerlength : numberlength;
			sfld -> minvalue = minvalue;
			sfld -> maxvalue = maxvalue;
			//sfld -> options = new char[strlen(options) + 1];
			sfld -> options = options; //strcpy(sfld -> options,options);
			sfld -> ptrtotblnum = ptrtotblnum;
			sfld -> ordning = ordning + 1;
//			strcpy(sfld -> status,status);
#ifdef LIVEDB
			// create field
			sprintf(sql,"select count(*) from flds where tblnum=%ld",stbl -> num);
			if (!qd -> get_count(sql))
			{
				sprintf(sql,"create table %s ( %s %s )",
					stbl -> name.c_str(),
					newname,
					typestring(sfld));
				if (!lq.execute(sql))
				{
					strcpy(errstr, lq.GetError().c_str());
					ok = false;
				}
/*
				strcpy(description,typestring(sfld));
				sprintf(slask,"echo \"create table %s ( %s %s )\" | %s %s > /dev/null 2>/dev/null",
				 stbl -> name.c_str(),
				 newname,
				 description,
				 MYSQL_program,sdb -> name.c_str());
				syscall(slask);
*/
			}
			else
			{
				sprintf(sql,"alter table %s add column %s %s",
					stbl -> name.c_str(),
					newname,
					typestring(sfld));
				if (!lq.execute(sql))
				{
					strcpy(errstr, lq.GetError().c_str());
					ok = false;
				}
/*
				strcpy(description,typestring(sfld));
				sprintf(slask,"echo \"alter table %s add column %s %s\" | %s %s > /dev/null 2>/dev/null",
				 stbl -> name.c_str(),newname,description,MYSQL_program,sdb -> name.c_str());
				syscall(slask);
*/
			}
#endif
			if (ok)
			{
			if (visa_status)
			{
				sprintf(sql,"update appfields set status='%s' where appnum=%ld and fldnum=%ld",status,sapp -> num,sfld -> num);
				qd -> execute(sql);
			}
			selfld = sfld -> insert();
			set_cookie(cs,"selfld",selfld);

			stbl -> changedby = usernum;
			stbl -> changedate = datetime();
			stbl -> version++;
			stbl -> update();

			sdb -> changedby = usernum;
			sdb -> changedate = datetime();
			sdb -> version++;
			sdb -> update();

			if (*kommentar)
			{
				k = new db::Kommentar(&db);
				k -> fldnum = selfld;
				k -> usernum = usernum;
				k -> dateposted = datetime();
				k -> reason = "Created";
				//k -> kommentar = new char[strlen(kommentar) + 1];
				k -> kommentar = kommentar; //strcpy(k -> kommentar,kommentar);
				k -> insert();
				delete k;
			}
			*refresh = *refresh + 0;
			} // if (ok)
			delete sfld;
			sfld = NULL;
		}
	}
	if (selfld > 0)
	{
		sfld = new db::Flds(db,selfld);
		sprintf(sql,"select dbnum from tbls where num=%ld",sfld -> tblnum);
		l = qd -> get_count(sql);
		sprintf(sql,"select num from access where usernum=%ld and dbnum=%ld",user -> num,l);
		if (!qd -> get_count(sql))
		{
			selfld = 0;
			delete sfld;
			sfld = NULL;
		}
	}
	// change field
	if (sdb && stbl && sfld && form -> getvalue("changefld",slask,20) && *slask && atoi(slask) && a -> w)
	{
		fieldflags = 0;

		if (!form -> getvalue("num",slask,20))
			error("num");
		l = atol(slask);
		if (l != sfld -> num)
			error("sfld num mismatch");
		if (!form -> getvalue("name",newname,20))
			error("name");
		if (!form -> getvalue("description",description,80))
			error("description");
		if (!form -> getvalue("tblnum",slask,20))
			error("tblnum");
		tblnum = atol(slask);

// fieldtype 1-char,2-int,3-datetime,4-enum/options,5-ptr
// charlength
// integerlength
// minvalue
// maxvalue
// options
// ptrtotable

		if (!form -> getvalue("fieldtype",slask,20))
			error("fieldtype");
		fieldtype = atol(slask);

		sprintf(slask,"fieldstr%ld",fieldtype);
		form -> getvalue(slask,fieldstr,40);
		switch (fieldtype)
		{
		case 101: // char
			fieldtype = 1;
			strcpy(fieldstr, "CHAR");
			break;
		case 102: // varchar
			fieldtype = 1;
			strcpy(fieldstr, "VARCHAR");
			break;
		}
		if (!form -> getvalue("defaultvalue",defaultvalue,40))
			error("defaultvalue");
		if (!form -> getvalue("numberlength",slask,20))
			error("numberlength");
		numberlength = atol(slask);
		if (!form -> getvalue("decimallength",slask,20))
			error("decimallength");
		decimallength = atol(slask);
		// flags
		if (form -> getvalue("nullok",slask,20) && *slask && atoi(slask))
		{
			fieldflags |= FF_ALLOWNULL;
		}
		if (form -> getvalue("autoincr",slask,20) && *slask && atoi(slask))
		{
			fieldflags |= FF_AUTO_INCREMENT;
		}
		if (form -> getvalue("cvc_binary",slask,20) && *slask && atoi(slask))
		{
			fieldflags |= FF_BINARY;
		}
		if (fieldtype == 2)
		{
			if (form -> getvalue("int_uns",slask,20) && *slask && atoi(slask))
			{
				fieldflags |= FF_UNSIGNED;
			}
			if (form -> getvalue("int_zf",slask,20) && *slask && atoi(slask))
			{
				fieldflags |= FF_ZEROFILL;
			}
		}
		if (fieldtype == 6)
		{
			if (form -> getvalue("num_uns",slask,20) && *slask && atoi(slask))
			{
				fieldflags |= FF_UNSIGNED;
			}
			if (form -> getvalue("num_zf",slask,20) && *slask && atoi(slask))
			{
				fieldflags |= FF_ZEROFILL;
			}
		}
		if (!form -> getvalue("charlength",slask,20))
			error("length");
		charlength = atol(slask);
		if (!strcmp(fieldstr,"CHAR") || !strcmp(fieldstr,"VARCHAR"))
		{
			if (charlength > 255)
			{
				charlength = 255;
				sprintf(errstr,"Max string length for type %s is 255 characters - modified",fieldstr);
			}
		}
		if (!form -> getvalue("integerlength",slask,20))
			error("length");
		integerlength = atol(slask);
		if (!form -> getvalue("minvalue",slask,20))
			error("minvalue");
		minvalue = atol(slask);
		if (!form -> getvalue("maxvalue",slask,20))
			error("maxvalue");
		if (*slask)
		{
			maxvalue = atol(slask);
		}
		else
		{
			maxvalue = -1;
		}
		l = form -> getlength("options");
		options = new char[l + 144];
		if (!form -> getvalue("options",options,l + 144))
			error("options");
		if (!form -> getvalue("ptrtotable",slask,20))
			error("ptrtotable");
		ptrtotblnum = atol(slask);
		if (visa_status)
		{
			if (!form -> getvalue("status",status,40))
				error("status");
		}
		l = form -> getlength("kommentar");
		kommentar = new char[l + 144];
		form -> getvalue("kommentar",kommentar,l + 144);
		textareain(kommentar);

		ir = is_reserved(newname);
		if (ir)
		{
			if (!strcmp(newname,sfld -> name.c_str()))
			{
				sprintf(warningstr,"'%s' is a reserved word",newname);
				ok++;
			}
			else
			{
				sprintf(errstr,"'%s' is a reserved word",newname);
			}
		}
		sprintf(sql,"select num from flds where tblnum=%ld and name='%s' and num<>%ld",stbl -> num,db.safestr(newname).c_str(),sfld -> num);
		l = qd -> get_count(sql);

		if (l)
		{
			sprintf(errstr,"Field '%s' already exists in table '%s' (may be deleted)",newname,stbl -> name.c_str());
		}
		if (!name_ok(newname))
		{
			sprintf(errstr,"Invalid characters in name '%s'",newname);
		}
		if ((ok || !ir) && !l && name_ok(newname))
		{
			bool ok = true;
			oldtblnum = sfld -> tblnum;
			strcpy(oldname,sfld -> name.c_str());

			sfld -> tblnum = tblnum;
			sfld -> changedby = usernum;
			sfld -> changedate = datetime(); //strcpy(sfld -> changedate,datetime());
			sfld -> name = newname; //strcpy(sfld -> name,newname);
			sfld -> description = description; //strcpy(sfld -> description,description);
			sfld -> fieldtype = fieldtype;
			sfld -> fieldstr = fieldstr; //strcpy(sfld -> fieldstr,fieldstr);
			sfld -> fieldflags = fieldflags;
			sfld -> decimallength = decimallength;
			sfld -> defaultvalue = defaultvalue; //strcpy(sfld -> defaultvalue,defaultvalue);
			sfld -> charlength = charlength;
			sfld -> integerlength = (fieldtype == 2) ? integerlength : numberlength;
			sfld -> minvalue = minvalue;
			sfld -> maxvalue = maxvalue;
			if (strcmp(sfld -> options.c_str(),options))
			{
//				delete sfld -> options;
//				sfld -> options = new char[strlen(options) + 1];
				sfld -> options = options; //strcpy(sfld -> options,options);
			}
			sfld -> ptrtotblnum = ptrtotblnum;
//			strcpy(sfld -> status,status);
#ifdef LIVEDB
			// change field
			// TODO OK:
			// kolla om sfld byter table....
			//  i sa fall
			//  mysql stbl drop column sfld
			//  mysql newtbl add column sfld..
			if (sfld -> tblnum != oldtblnum)
			{
				temptbl = new db::Tbls(db,sfld -> tblnum);
				sprintf(sql,"alter table %s add column %s %s",temptbl -> name.c_str(),newname,typestring(sfld));
/*
				sprintf(slask,"echo \"alter table %s add column %s %s\" | %s %s > /dev/null 2>/dev/null",
				 temptbl -> name.c_str(),newname,typestring(sfld),MYSQL_program,sdb -> name.c_str());
				syscall(slask);
*/
				if (!lq.execute(sql))
				{
					strcpy(errstr, lq.GetError().c_str());
					ok = false;
				}
				else
				{
					sprintf(sql,"alter table %s drop column %s",stbl -> name.c_str(),oldname);
					if (!lq.execute(sql))
					{
						strcpy(errstr, lq.GetError().c_str());
						ok = false;
					}
/*
					sprintf(slask,"echo \"alter table %s drop column %s\" | %s %s > /dev/null 2>/dev/null",
					 stbl -> name.c_str(),oldname,MYSQL_program,sdb -> name.c_str());
					syscall(slask);
*/
				}
				delete temptbl;
			}
			else
			{
				sprintf(sql,"alter table %s change column %s %s %s",
					stbl -> name.c_str(),oldname,newname,typestring(sfld));
				if (!lq.execute(sql))
				{
					strcpy(errstr, lq.GetError().c_str());
					ok = false;
				}
/*
				strcpy(description,typestring(sfld));
				sprintf(slask,"echo \"alter table %s change column %s %s %s\" | %s %s > /dev/null 2>/dev/null",
				 stbl -> name.c_str(),oldname,newname,description,MYSQL_program,sdb -> name.c_str());
				syscall(slask);
*/
			}
#endif
			if (ok)
			{
			if (visa_status)
			{
				sprintf(sql,"update appfields set status='%s' where appnum=%ld and fldnum=%ld",status,sapp -> num,sfld -> num);
				qd -> execute(sql);
			}
			sfld -> version++;
			sfld -> update();

			stbl -> changedby = usernum;
			stbl -> changedate = datetime();
			stbl -> version++;
			stbl -> update();

			sdb -> changedby = usernum;
			sdb -> changedate = datetime();
			sdb -> version++;
			sdb -> update();

			if (*kommentar)
			{
				k = new db::Kommentar(&db);
				k -> fldnum = selfld;
				k -> usernum = usernum;
				k -> dateposted = datetime();
				k -> reason = "Changed";
				//k -> kommentar = new char[strlen(kommentar) + 1];
				k -> kommentar = kommentar; //strcpy(k -> kommentar,kommentar);
				k -> insert();
				delete k;
			}
			*refresh = *refresh + 0;
			} // if (ok)
		}
	}
	// delete field
	if (sdb && stbl && sfld && form -> getvalue("deletefld",slask,20) && *slask && atoi(slask) && a -> d)
	{
		bool ok = true;
		l = form -> getlength("kommentar");
		kommentar = new char[l + 144];
		form -> getvalue("kommentar",kommentar,l + 144);
		textareain(kommentar);

#ifdef LIVEDB
		// delete field
		if (!sfld -> deleted)
		{
			sprintf(sql,"alter table %s drop column %s",stbl -> name.c_str(),sfld -> name.c_str());
			if (!lq.execute(sql))
			{
				strcpy(errstr, lq.GetError().c_str());
				ok = false;
			}
/*
			sprintf(slask,"echo \"alter table %s drop column %s\" | %s %s",
			 stbl -> name.c_str(),sfld -> name.c_str(),MYSQL_program,sdb -> name.c_str());
			syscall(slask);
*/
		}
		else
		{
		// stoppa tillbaka efter fg field
			sprintf(sql,"select num from flds where tblnum=%ld and ordning<%ld order by ordning desc limit 1",
			 stbl -> num,sfld -> ordning);
			l = qd -> get_count(sql);
			if (!l)	// first
			{
				sprintf(sql,"alter table %s add column %s %s first",
					stbl -> name.c_str(),sfld -> name.c_str(),typestring(sfld));
				if (!lq.execute(sql))
				{
					strcpy(errstr, lq.GetError().c_str());
					ok = false;
				}
/*
				strcpy(description,typestring(sfld));
				sprintf(slask,"echo \"alter table %s add column %s %s first\" | %s %s > /dev/null 2>/dev/null",
				 stbl -> name.c_str(),sfld -> name.c_str(),description,MYSQL_program,sdb -> name.c_str());
				syscall(slask);
*/
			}
			else // after
			{
				tempfld = new db::Flds(db,l);
				sprintf(sql,"alter table %s add column %s %s after %s",
					stbl -> name.c_str(),sfld -> name.c_str(),typestring(sfld),tempfld -> name.c_str());
				if (!lq.execute(sql))
				{
					strcpy(errstr, lq.GetError().c_str());
					ok = false;
				}
/*
				strcpy(description,typestring(sfld));
				sprintf(slask,"echo \"alter table %s add column %s %s after %s\" | %s %s > /dev/null 2>/dev/null",
				 stbl -> name.c_str(),sfld -> name.c_str(),description,tempfld -> name.c_str(),MYSQL_program,sdb -> name.c_str());
				syscall(slask);
*/
				delete tempfld;
			}
		}
#endif
		if (ok)
		{
		sfld -> deleted = !sfld -> deleted;
		sfld -> deletedby = usernum;
		sfld -> deletedate = datetime(); //strcpy(sfld -> deletedate,datetime());
		sfld -> version++;
		sfld -> update();

		stbl -> changedby = usernum;
		stbl -> changedate = datetime();
		stbl -> version++;
		stbl -> update();

		sdb -> changedby = usernum;
		sdb -> changedate = datetime();
		sdb -> version++;
		sdb -> update();

		if (*kommentar)
		{
			k = new db::Kommentar(&db);
			k -> fldnum = selfld;
			k -> usernum = usernum;
			k -> dateposted = datetime();
			k -> reason = "Deleted";
			//k -> kommentar = new char[strlen(kommentar) + 1];
			k -> kommentar = kommentar; //strcpy(k -> kommentar,kommentar);
			k -> insert();
			delete k;
		}
		*refresh = *refresh + 0;
		} // if (ok)
	}
// write comment
	if (sdb && stbl && sfld && form -> getvalue("writefld",slask,20) && *slask && atoi(slask))
	{
		l = form -> getlength("kommentar");
		kommentar = new char[l + 144];
		form -> getvalue("kommentar",kommentar,l + 144);
		textareain(kommentar);

		if (*kommentar)
		{
			k = new db::Kommentar(&db);
			k -> fldnum = selfld;
			k -> usernum = usernum;
			k -> dateposted = datetime();
			k -> reason = "A comment";
			//k -> kommentar = new char[strlen(kommentar) + 1];
			k -> kommentar = kommentar; //strcpy(k -> kommentar,kommentar);
			k -> insert();
			delete k;
		}
	}
	bool change_ordning = false; // fldnum has been moved
// up
	if (sdb && stbl && form -> getvalue("up",slask,20) && *slask && (fldnum = atol(slask)) != 0)
	{
// drop column [fldnum]
		sprintf(sql,"select num,ordning from flds where tblnum=%ld order by ordning",stbl -> num);
		q.get_result(sql);
		while (q.fetch_row())
		{
			l = q.getval();
			ordning = q.getval();
			if (l == fldnum)
			{
				sprintf(sql,"update flds set ordning=%d where num=%ld",
				 ordning,prevl);
				qd -> execute(sql);
				sprintf(sql,"update flds set ordning=%d where num=%ld",
				 prevordning,l);
				qd -> execute(sql);
				change_ordning = true;
				break;
			}
			prevl = l;
			prevordning = ordning;
		}
		q.free_result();
	}
// down
	if (sdb && stbl && form -> getvalue("down",slask,20) && *slask && (fldnum = atol(slask)) != 0)
	{
// drop column [fldnum]
		sprintf(sql,"select num,ordning from flds where tblnum=%ld order by ordning",stbl -> num);
		q.get_result(sql);
		while (q.fetch_row())
		{
			l = q.getval();
			ordning = q.getval();
			if (prevl == fldnum)
			{
				sprintf(sql,"update flds set ordning=%d where num=%ld",
				 ordning,prevl);
				qd -> execute(sql);
				sprintf(sql,"update flds set ordning=%d where num=%ld",
				 prevordning,l);
				qd -> execute(sql);
				change_ordning = true;
				break;
			}
			prevl = l;
			prevordning = ordning;
		}
		q.free_result();
	}
	if (change_ordning)
	{
#ifdef LIVEDB
		// TODO
		// this part commented because we do not want to lose data from our livedb
		// redo this in a data-safe way
/*
		db::Sfld tempfld(db,fldnum);
		bool ok = true;
		if (tempfld.num)
		{
			// drop / add
		// delete field
			sprintf(sql,"alter table %s drop column %s",stbl -> name.c_str(),tempfld.name.c_str());
			if (!lq.execute(sql))
			{
				strcpy(errstr, lq.GetError().c_str());
				ok = false;
			}
		// stoppa tillbaka efter fg field
			sprintf(sql,"select num from flds where tblnum=%ld and ordning<%ld order by ordning desc limit 1",
			 stbl -> num,tempfld.ordning);
			l = qd -> get_count(sql);
			if (!l)	// first
			{
				sprintf(sql,"alter table %s add column %s %s first",
					stbl -> name.c_str(),tempfld.name.c_str(),typestring(&tempfld));
				if (!lq.execute(sql))
				{
					strcpy(errstr, lq.GetError().c_str());
					ok = false;
				}
			}
			else // after
			{
				tempfld2 = new db::Flds(db,l);
				sprintf(sql,"alter table %s add column %s %s after %s",
					stbl -> name.c_str(),tempfld.name.c_str(),typestring(&tempfld),tempfld2 -> name.c_str());
				if (!lq.execute(sql))
				{
					strcpy(errstr, lq.GetError().c_str());
					ok = false;
				}
				delete tempfld2;
			}
		}
*/
#endif
	}
	if (kommentar)
	{
		delete kommentar;
	}
	if (options)
	{
		delete options;
	}
	delete sql;
	delete qd;
	delete a;
	return sfld;
}

db::Indexs *check_index(Database& db,Query& qin,Form *form,Cookies *cs,db::Dbs *sdb,db::Tbls *stbl,long sel,db::Users *user,short *refresh,short *ci)
{
	// live database
	Database livedb("localhost", "root", "", sdb ? sdb -> name : "");
#ifdef WIN32
#else
  SysLog log("livedata");
	livedb.RegErrHandler(&log);
#endif
	Query lq(livedb);
	//
	Query q(db);
	Query *qd = new Query(db);
	db::Indexs *sindex = NULL;
	db::Access *a;
	db::Kommentar *k;
	db::Indexlist *il;
	char *kommentar = NULL;
	long selindex = sel;
	long l,qty;
	long usernum = user -> num;
	long fldnum,length;
	short ir;		// is_reserved(newname)
	char slask[300];
	char newname[40];
	char sql[1000];
	char description[80];
	char oldname[40];
	char typ[40];

	sprintf(sql,"select * from access where usernum=%ld and dbnum=%ld",user -> num,sdb ? sdb -> num : 0);
	a = new db::Access(&db,sql);

	// create index
	if (form -> getvalue("createindex",slask,20) && *slask && atoi(slask))
	{
		if (!form -> getvalue("name",newname,40))
			error("name");
		if (!form -> getvalue("description",description,80))
			error("description");
		if (!form -> getvalue("typ",typ,40))
			error("typ");
		if (!form -> getvalue("fldnum",slask,20))
			error("fldnum");
		fldnum = atol(slask);
		if (!form -> getvalue("length",slask,20))
			error("length");
		if (*slask)
		{
			length = atol(slask);
		}
		else
		{
			length = -1;
		}
		l = form -> getlength("kommentar");
		kommentar = new char[l + 144];
		form -> getvalue("kommentar",kommentar,l + 144);
		textareain(kommentar);

		ir = is_reserved(newname);
		if (ir)
		{
			sprintf(errstr,"'%s' is a reserved word",newname);
		}
		sprintf(sql,"select num from indexs where tblnum=%ld and name='%s'",stbl -> num,db.safestr(newname).c_str());
		l = qd -> get_count(sql);

		if (l)
		{
			sprintf(errstr,"There already exists a index with the name '%s'",newname);
		}
		db::Flds field(db, fldnum);
		if (!field.num)
		{
			strcpy(errstr, "Select field");
		}
		if (!*newname)
			strcpy(newname, field.name.c_str());
		if (!name_ok(newname)) // empty name is ok
		{
			sprintf(errstr,"Invalid characters in name '%s'",newname);
		}
		sprintf(sql,"select count(*) from indexs where owner=%ld",user -> num);
		qty = qd -> get_count(sql);

		if (qty >= user -> maxindexs && !user -> superuser)
		{
			sprintf(errstr,"Allowed number of indexes already created");
		}
		if (!ir && !l && name_ok(newname) && (user -> superuser || qty < user -> maxindexs))
		{
			bool ok = true;
#ifdef LIVEDB
			// create index
			sprintf(sql,"alter table %s add %s %s(%s",
				stbl -> name.c_str(),
				typ,
				!strcmp(typ,"PRIMARY") ? "KEY" : newname,
				field.name.c_str());
			if (length != -1)
			{
				sprintf(sql + strlen(sql),"(%d)",length);
			}
			strcat(sql,")");
			if (!lq.execute(sql))
			{
				strcpy(errstr, lq.GetError().c_str());
				ok = false;
			}
#endif
			if (ok)
			{
				sindex = new db::Indexs(&db);	// create empty object
				sindex -> owner = usernum;
				sindex -> createdate = datetime(); //strcpy(sindex -> createdate,datetime());
				sindex -> name = newname; //strcpy(sindex -> name,newname);
				sindex -> description = description; //strcpy(sindex -> description,description);
				sindex -> typ = typ; //strcpy(sindex -> typ,typ);
				sindex -> tblnum = stbl -> num;
				selindex = sindex -> insert();
				set_cookie(cs,"selindex",selindex);

				il = new db::Indexlist(&db);
				il -> indexnum = sindex -> num;
				il -> fldnum = fldnum;
				il -> length = length;
				il -> save();
				delete il;
				delete sindex;
				sindex = NULL;

				if (*kommentar)
				{
					k = new db::Kommentar(&db);
					k -> indexnum = selindex;
					k -> usernum = usernum;
					k -> dateposted = datetime();
					k -> reason = "Created";
					//k -> kommentar = new char[strlen(kommentar) + 1];
					k -> kommentar = kommentar; //strcpy(k -> kommentar,kommentar);
					k -> insert();
					delete k;
				}
				*refresh = *refresh + 0;
			}
		}
	}
	if (selindex > 0)
	{
		sindex = new db::Indexs(db,selindex);
		sprintf(sql,"select dbnum from tbls where num=%ld",sindex -> tblnum);
		l = qd -> get_count(sql);
		sprintf(sql,"select num from access where usernum=%ld and dbnum=%ld",user -> num,l);
		if (!qd -> get_count(sql))
		{
			selindex = 0;
			delete sindex;
			sindex = NULL;
		}
	}
	else
	{
		l = 0;
	}
	// change index
	if (sindex && form -> getvalue("changeindex",slask,20) && *slask && atoi(slask) && a -> w)
	{
		if (!form -> getvalue("num",slask,20))
			error("num");
		l = atol(slask);
		if (l != sindex -> num)
			error("sindex num mismatch");
		if (!form -> getvalue("name",newname,20))
			error("name");
		if (!form -> getvalue("description",description,80))
			error("description");
		if (!form -> getvalue("typ",typ,40))
			error("typ");
		l = form -> getlength("kommentar");
		kommentar = new char[l + 144];
		form -> getvalue("kommentar",kommentar,l + 144);
		textareain(kommentar);

		ir = is_reserved(newname);
		if (ir)
		{
			sprintf(errstr,"'%s' is a reserved word",newname);
		}
		sprintf(sql,"select num from indexs where name='%s' and tblnum=%ld and num<>%ld",db.safestr(newname).c_str(),stbl -> num,sindex -> num);
		l = qd -> get_count(sql);

		if (l)
		{
			sprintf(errstr,"There already exists an index with the name '%s'",newname);
		}
		if (!name_ok(newname))
		{
			sprintf(errstr,"Invalid characters in name '%s'",newname);
		}
		if (!ir && !l && name_ok(newname))
		{
			bool ok = true;
			strcpy(oldname,sindex -> name.c_str());
#ifdef LIVEDB
			// change index
			sprintf(sql,"alter table %s drop index %s",stbl -> name.c_str(),oldname);
			if (!lq.execute(sql))
			{
				strcpy(errstr, lq.GetError().c_str());
				ok = false;
			}
			else
			{
				sprintf(slask,"alter table %s add %s %s(",stbl -> name.c_str(),
					typ,!strcmp(typ,"PRIMARY") ? "KEY" : newname);
				sprintf(sql,"select * from indexlist where indexnum=%ld",sindex -> num);
				qd -> get_result(sql);
				*sql = 0;
				while (qd -> fetch_row())
				{
					db::Indexlist il(&db,qd);
					db::Flds field(db,il.fldnum);
					sprintf(sql + strlen(sql),"%s%s",slask,field.name.c_str());
					if (il.length != -1)
					{
						sprintf(sql + strlen(sql),"(%d)",il.length);
					}
					strcpy(slask,",");
				}
				qd -> free_result();
				strcat(sql,")");
				if (!lq.execute(sql))
				{
					strcpy(errstr, lq.GetError().c_str());
					ok = false;
				}
			}
#endif
			if (ok)
			{
				sindex -> changedby = usernum;
				sindex -> changedate = datetime(); //strcpy(sindex -> changedate,datetime());
				sindex -> name = newname; //strcpy(sindex -> name,newname);
				sindex -> description = description; //strcpy(sindex -> description,description);
				sindex -> typ = typ; //strcpy(sindex -> typ,typ);
				sindex -> version++;
				sindex -> update();

				if (*kommentar)
				{
					k = new db::Kommentar(&db);
					k -> indexnum = selindex;
					k -> usernum = usernum;
					k -> dateposted = datetime();
					k -> reason = "Changed";
					//k -> kommentar = new char[strlen(kommentar) + 1];
					k -> kommentar = kommentar; //strcpy(k -> kommentar,kommentar);
					k -> insert();
					delete k;
				}
				*refresh = *refresh + 0;
			}
		}
	}
	// delete index
	if (sindex && form -> getvalue("deleteindex",slask,20) && *slask && atoi(slask) && a -> d)
	{
		bool ok = true;
		l = form -> getlength("kommentar");
		kommentar = new char[l + 144];
		form -> getvalue("kommentar",kommentar,l + 144);
		textareain(kommentar);
#ifdef LIVEDB
		// delete index
		if (sindex -> deleted) // recreate
		{
			sprintf(slask,"alter table %s add %s %s(",
				stbl -> name.c_str(),
				sindex -> typ.c_str(),
				!strcmp(sindex -> typ.c_str(),"PRIMARY") ? "KEY" : sindex -> name.c_str());
			sprintf(sql,"select * from indexlist where indexnum=%ld",sindex -> num);
			qd -> get_result(sql);
			*sql = 0;
			while (qd -> fetch_row())
			{
				db::Indexlist il(&db,qd);
				db::Flds field(db,il.fldnum);
				sprintf(sql + strlen(sql),"%s%s",slask,field.name.c_str());
				if (il.length != -1)
				{
					sprintf(sql + strlen(sql),"(%d)",il.length);
				}
				strcpy(slask,",");
			}
			qd -> free_result();
			strcat(sql,")");
			if (!lq.execute(sql))
			{
				strcpy(errstr, lq.GetError().c_str());
				ok = false;
			}
		}
		else // drop
		{
			sprintf(sql,"alter table %s drop index %s",stbl -> name.c_str(),sindex -> name.c_str());
			if (!lq.execute(sql))
			{
				strcpy(errstr, lq.GetError().c_str());
				ok = false;
			}
		}
#endif
		if (ok)
		{
			sindex -> deleted = !sindex -> deleted;
			sindex -> deletedby = usernum;
			sindex -> deletedate = datetime(); //strcpy(sindex -> deletedate,datetime());
			sindex -> version++;
			sindex -> update();

			if (*kommentar)
			{
				k = new db::Kommentar(&db);
				k -> indexnum = selindex;
				k -> usernum = usernum;
				k -> dateposted = datetime();
				k -> reason = "Deleted";
				//k -> kommentar = new char[strlen(kommentar) + 1];
				k -> kommentar = kommentar; //strcpy(k -> kommentar,kommentar);
				k -> insert();
				delete k;
			}
			*refresh = *refresh + 0;
		}
	}
// write comment
	if (sindex && form -> getvalue("writeindex",slask,20) && *slask && atoi(slask))
	{
		l = form -> getlength("kommentar");
		kommentar = new char[l + 144];
		form -> getvalue("kommentar",kommentar,l + 144);
		textareain(kommentar);

		if (*kommentar)
		{
			k = new db::Kommentar(&db);
			k -> indexnum = selindex;
			k -> usernum = usernum;
			k -> dateposted = datetime();
			k -> reason = "A comment";
			//k -> kommentar = new char[strlen(kommentar) + 1];
			k -> kommentar = kommentar; //strcpy(k -> kommentar,kommentar);
			k -> insert();
			delete k;
		}
	}
	// changes to indexlist: add / change / delete
	{
		// begin ... ?
	}
// add field
	if (sindex && form -> getvalue("add",slask,20) && *slask)
	{
		if (!form -> getvalue("fldnum",slask,20))
			error("fldnum");
		fldnum = atol(slask);
		if (!form -> getvalue("length",slask,20))
			error("length");
		if (*slask)
		{
			length = atol(slask);
		}
		else
		{
			length = -1;
		}
		il = new db::Indexlist(&db);
		il -> indexnum = sindex -> num;
		il -> fldnum = fldnum;
		il -> length = length;
		il -> save();

		*ci = 1;
	}
// check change indexlist
	if (sindex)
	{
		sprintf(sql,"select num from indexlist where indexnum=%ld",sindex -> num);
		q.get_result(sql);
		while (q.fetch_row())
		{
			l = q.getval();
			sprintf(slask,"change%ld",l);
			if (form -> getvalue(slask,slask,20) && *slask)
			{
				sprintf(slask,"length%ld",l);
				if (!form -> getvalue(slask,slask,20))
					error("length");
				length = atol(slask);
				sprintf(sql,"update indexlist set length=%ld where num=%ld",length,l);
				qd -> execute(sql);
				*ci = 1;
			}
			sprintf(slask,"delete%ld",l);
			if (form -> getvalue(slask,slask,20) && *slask)
			{
				sprintf(sql,"delete from indexlist where num=%ld",l);
				qd -> execute(sql);
				*ci = 1;
			}
		}
		q.free_result();
	}
#ifdef LIVEDB
	if (*ci)
	{
		bool ok = true;
		// change indexlist
		sprintf(sql,"alter table %s drop index %s",stbl -> name.c_str(),sindex -> name.c_str());
		if (!lq.execute(sql))
		{
			strcpy(errstr, lq.GetError().c_str());
			ok = false;
		}
		else
		{
			sprintf(slask,"alter table %s add %s %s(",
				stbl -> name.c_str(),
				sindex -> typ.c_str(),
				!strcmp(sindex -> typ.c_str(),"PRIMARY") ? "KEY" : sindex -> name.c_str());
			sprintf(sql,"select * from indexlist where indexnum=%ld",sindex -> num);
			qd -> get_result(sql);
			*sql = 0;
			while (qd -> fetch_row())
			{
				db::Indexlist il(&db,qd);
				db::Flds field(db,il.fldnum);
				sprintf(sql + strlen(sql),"%s%s",slask,field.name.c_str());
				if (il.length != -1)
				{
					sprintf(sql + strlen(sql),"(%d)",il.length);
				}
				strcpy(slask,",");
			}
			qd -> free_result();
			strcat(sql,")");
			if (!lq.execute(sql))
			{
				strcpy(errstr, lq.GetError().c_str());
				ok = false;
			}
		}
		if (ok)
		{
			// ... commit?
		}
		else
		{
			// ... rollback?
		}
	}
#endif

	if (kommentar)
	{
		delete kommentar;
	}
	delete qd;
	delete a;
	return sindex;
}

db::Applications *check_app(Database& db,Query& qin,Form *form,Cookies *cs,db::Dbs *sdb,long sel,db::Users *user,short *refresh)
{
	Query *qd = new Query(db);
	db::Applications *sapp = NULL;
	db::Kommentar *k;
	db::Access *a;
	char *kommentar = NULL;
	long selapp = sel;
	long l,q;
	long usernum = user -> num;
	long dbnum;
	long olddbnum;
	char slask[300];
	char newname[40];
	char sql[1000];
	char description[80];
	char oldname[40];

	sprintf(sql,"select * from access where usernum=%ld and dbnum=%ld",user -> num,sdb ? sdb -> num : 0);
	a = new db::Access(&db,sql);

	// create application
	if (sdb && form -> getvalue("createapp",slask,20) && *slask && atoi(slask) && a -> c)
	{
		if (!form -> getvalue("name",newname,40))
			error("name");
		if (!form -> getvalue("description",description,80))
			error("description");
		l = form -> getlength("kommentar");
		kommentar = new char[l + 144];
		form -> getvalue("kommentar",kommentar,l + 144);
		textareain(kommentar);

		sprintf(sql,"select num from applications where dbnum=%ld and name='%s'",sdb -> num,db.safestr(newname).c_str());
		l = qd -> get_count(sql);

		if (l)
		{
			sprintf(errstr,"Application '%s' already exists in database '%s' (may be deleted)",newname,sdb -> name.c_str());
		}
		sprintf(sql,"select count(*) from applications where owner=%ld",user -> num);
		q = qd -> get_count(sql);

		if (q >= user -> maxapps && !user -> superuser)
		{
			sprintf(errstr,"Allowed number of applications already created");
		}
		if (!l && (user -> superuser || q < user -> maxapps))
		{
			sapp = new db::Applications(&db);	// create empty object
			sapp -> dbnum = sdb -> num;
			sapp -> owner = usernum;
			sapp -> createdate = datetime(); //strcpy(sapp -> createdate,datetime());
			sapp -> name = newname; //strcpy(sapp -> name,newname);
			sapp -> description = description; //strcpy(sapp -> description,description);
			selapp = sapp -> insert();
			set_cookie(cs,"selapp",selapp);

			sdb -> changedby = usernum;
			sdb -> changedate = datetime();
			sdb -> version++;
			sdb -> update();

			if (*kommentar)
			{
				k = new db::Kommentar(&db);
				k -> appnum = selapp;
				k -> usernum = usernum;
				k -> dateposted = datetime();
				k -> reason = "Created";
				//k -> kommentar = new char[strlen(kommentar) + 1];
				k -> kommentar = kommentar; //strcpy(k -> kommentar,kommentar);
				k -> insert();
				delete k;
			}
			delete sapp;
			sapp = NULL;
			*refresh = *refresh + 1; // refresh frames
		}
	}
	if (selapp > 0)
	{
		sapp = new db::Applications(db,selapp);
		sprintf(sql,"select num from access where usernum=%ld and dbnum=%ld",user -> num,sapp -> dbnum);
		if (!qd -> get_count(sql))
		{
			selapp = 0;
			delete sapp;
			sapp = NULL;
		}
	}
	// change application
	if (sdb && sapp && form -> getvalue("changeapp",slask,20) && *slask && atoi(slask) && a -> w)
	{
		if (!form -> getvalue("num",slask,20))
			error("num");
		l = atol(slask);
		if (l != sapp -> num)
			error("sapp num mismatch");
		if (!form -> getvalue("name",newname,20))
			error("name");
		if (!form -> getvalue("description",description,80))
			error("description");
		if (!form -> getvalue("dbnum",slask,20))
			error("dbnum");
		dbnum = atol(slask);
		l = form -> getlength("kommentar");
		kommentar = new char[l + 144];
		form -> getvalue("kommentar",kommentar,l + 144);
		textareain(kommentar);

		sprintf(sql,"select num from applications where dbnum=%ld and name='%s' and num<>%ld",sdb -> num,db.safestr(newname).c_str(),sapp -> num);
		l = qd -> get_count(sql);

		if (l)
		{
			sprintf(errstr,"Application '%s' already exists in database '%s' (may be deleted)",newname,sdb -> name.c_str());
		}
		if (!l)
		{
			olddbnum = sapp -> dbnum;
			strcpy(oldname,sapp -> name.c_str());

			sapp -> dbnum = dbnum;
			sapp -> changedby = usernum;
			sapp -> changedate = datetime(); //strcpy(sapp -> changedate,datetime());
			sapp -> name = newname; //strcpy(sapp -> name,newname);
			sapp -> description = description; //strcpy(sapp -> description,description);
			sapp -> version++;
			sapp -> update();

			sdb -> changedby = usernum;
			sdb -> changedate = datetime();
			sdb -> version++;
			sdb -> update();

			if (*kommentar)
			{
				k = new db::Kommentar(&db);
				k -> appnum = selapp;
				k -> usernum = usernum;
				k -> dateposted = datetime();
				k -> reason = "Changed";
				//k -> kommentar = new char[strlen(kommentar) + 1];
				k -> kommentar = kommentar; //strcpy(k -> kommentar,kommentar);
				k -> insert();
				delete k;
			}
			*refresh = *refresh + 1;
		}
	}
	// delete application
	if (sdb && sapp && form -> getvalue("deleteapp",slask,20) && *slask && atoi(slask) && a -> d)
	{
		l = form -> getlength("kommentar");
		kommentar = new char[l + 144];
		form -> getvalue("kommentar",kommentar,l + 144);
		textareain(kommentar);

		sapp -> deleted = !sapp -> deleted;
		sapp -> deletedby = usernum;
		sapp -> deletedate = datetime(); //strcpy(sapp -> deletedate,datetime());
		sapp -> version++;
		sapp -> update();

		sdb -> changedby = usernum;
		sdb -> changedate = datetime();
		sdb -> version++;
		sdb -> update();

		if (*kommentar)
		{
			k = new db::Kommentar(&db);
			k -> appnum = selapp;
			k -> usernum = usernum;
			k -> dateposted = datetime();
			k -> reason = "Deleted";
			//k -> kommentar = new char[strlen(kommentar) + 1];
			k -> kommentar = kommentar; //strcpy(k -> kommentar,kommentar);
			k -> insert();
			delete k;
		}
		*refresh = *refresh + 1;
	}
// write comment
	if (sdb && sapp && form -> getvalue("writeapp",slask,20) && *slask && atoi(slask))
	{
		l = form -> getlength("kommentar");
		kommentar = new char[l + 144];
		form -> getvalue("kommentar",kommentar,l + 144);
		textareain(kommentar);

		if (*kommentar)
		{
			k = new db::Kommentar(&db);
			k -> appnum = selapp;
			k -> usernum = usernum;
			k -> dateposted = datetime();
			k -> reason = "A comment";
			//k -> kommentar = new char[strlen(kommentar) + 1];
			k -> kommentar = kommentar; //strcpy(k -> kommentar,kommentar);
			k -> insert();
			delete k;
		}
	}
	if (kommentar)
	{
		delete kommentar;
	}
	delete qd;
	delete a;
	return sapp;
}


