// importsql.cpp
/*
Copyright (C) 2001-2004  Anders Hedstrom (grymse@alhem.net)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
#ifdef WIN32
#include <Config-win.h>
#endif
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <time.h>
#include <mysql/mysql.h>
#include <libmysqlwrapped.h>
#include <libdbd.h>
#include <string>
#include <libcgi++.h>
#include <list>

#include "utils.h"
#include "html.h"
#include "dbd.h"
#include "importsql.h"


static	char prevtable[200];
static	short ok;
static	fields_v fields;


void reg_table(Database *db,db::Dbs *sdb,char *table,long usernum,short insert)
{
	Query *qd = new Query(*db);
	db::Tbls *temptbl = NULL;
	db::Flds *tempfld;
	cgi::Parse *pa;
	char *s;
	long fieldtype;
	long integerlength;
	long charlength;
	long decimallength;
	short ordning = 1;
	char slask[200];
	char options[999];
	char option[200];
	char sql[200];

	if (sdb)
	{
		sprintf(sql,"select num from tbls where dbnum=%ld and name='%s'",sdb -> num,db -> safestr(table).c_str() );
	}
	if (sdb && qd -> get_count(sql))
	{
		fprintf(out,"Table '%s' already exists, ignored\n",table);
	}
	else
	{
		temptbl = new db::Tbls(db);
		temptbl -> dbnum = sdb ? sdb -> num : 0;
		temptbl -> owner = usernum;
		temptbl -> createdate = datetime(); //strcpy(temptbl -> createdate,datetime());
		temptbl -> name = table; //strcpy(temptbl -> name,table);
		if (insert)
		{
			temptbl -> insert();
		}

		for (fields_v::iterator it = fields.begin(); it != fields.end(); it++)
		{
			FIELDS *t = *it;
			pa = new cgi::Parse(t -> typ,"(,)");
			pa -> getword();	// type

	// status enum('gift','sambo','singel') not null,

			fieldtype = integerlength = charlength = 0;
			*options = 0;
			decimallength = 0;

			if (!strncasecmp(t -> typ,"decimal",7))
			{
				fieldtype = 6;
				integerlength = pa -> getvalue();
				decimallength = pa -> getvalue();
			}
			else
			if (!strncasecmp(t -> typ,"enum",4))
			{
				fieldtype = 4;
				// options
				pa -> getword(slask);
				while (*slask == '\'')
				{
					strcpy(option,slask + 1);
					option[strlen(option) - 1] = 0;
					if (*options)
					{
						sprintf(options + strlen(options)," / %s",option);
					}
					else
					{
						strcpy(options,option);
					}
					pa -> getword(slask);
				}
			} 
			else
			if (!strncasecmp(t -> typ,"integer",7))
			{
				t -> typ[3] = 0;
				fieldtype = 2;
				integerlength = 11;
			} 
			else
			if (!strncasecmp(t -> typ,"int",3) || !strncasecmp(t -> typ,"tinyint",7)
			 || !strncasecmp(t -> typ,"smallint",8) || !strncasecmp(t -> typ,"bigint",6) )
			{
				fieldtype = 2;
				integerlength = pa -> getvalue();
			} 
			else
			if (!strncasecmp(t -> typ,"char",4))
			{
				fieldtype = 1;
				charlength = pa -> getvalue();
			} 
			else
			if (!strncasecmp(t -> typ,"varchar",7))
			{
				fieldtype = 1; // %! fixas
				charlength = pa -> getvalue();
			} 
			else
			if (!strcasecmp(t -> typ,"datetime") || !strcasecmp(t -> typ,"date"))
			{
				fieldtype = 3;
			} 
			else
			if (!strcasecmp(t -> typ,"text") || !strcasecmp(t -> typ,"blob") ||
				!strcasecmp(t -> typ,"mediumtext")
			)
			{
				fieldtype = 1; // %! fixas
				charlength = 256; // %! bug
			} 
			else
			{
				fprintf(out,"Unsupported column data type: %s.%s '%s'\n",table,t -> column,t -> typ);
				ok = 0;
			}
			delete pa;

			if (fieldtype)
			{
				tempfld = new db::Flds(db);
				tempfld -> tblnum = temptbl -> num;
				tempfld -> owner = usernum;
				tempfld -> createdate = datetime(); //strcpy(tempfld -> createdate,datetime());
				tempfld -> name = t -> column; //strcpy(tempfld -> name,t -> column);
				tempfld -> fieldtype = (char)fieldtype;
				tempfld -> description = t -> comment; //strcpy(tempfld -> description,t -> comment);

				s = strstr(t -> typ,"(");
				if (s)
				{
					*s = 0;
				}
				tempfld -> fieldstr = t -> typ; //strcpy(tempfld -> fieldstr,t -> typ);
				strupr(tempfld -> fieldstr);

				// TODO:
				// decimallength
				tempfld -> decimallength = decimallength;
				// fieldflags
				// defaultvalue
				tempfld -> integerlength = integerlength;
				tempfld -> charlength = charlength;
				//tempfld -> options = new char[strlen(options) + 1];
				tempfld -> options = options; //strcpy(tempfld -> options,options);
				tempfld -> ordning = ordning++;
				if (insert)
				{
					tempfld -> insert();
				}
				delete tempfld;
			}
		}
	} // table already exists...

	delete temptbl;
	delete qd;
}


FIELDS *reg_column(Database *db,db::Dbs *sdb,char *table,char *name,char *typ,long usernum,short insert)
{
	FIELDS *t;
	char len[200];

	strlwr(name);

//	fprintf(out,"%s.%s %s\n",table,name,typ);
	if (strcmp(table,prevtable))	// ny tabell
	{
		if (*prevtable)
		{
			reg_table(db,sdb,prevtable,usernum,insert);
		}
		while (fields.size())
		{
			fields_v::iterator it = fields.begin();
			FIELDS *p = *it;
			delete p;
			fields.erase(it);
		}
		strcpy(prevtable,table);
	}
	t = new FIELDS;
	t -> num = fields.size(); //listlen(fieldsbase);
	strcpy(t -> column,name);
	strcpy(t -> typ,typ);
	*t -> comment = 0;

// status enum('gift','sambo','singel') not null,

	if (!strncasecmp(typ,"enum",4))
	{
		t -> length = strlen(typ);
		sprintf(t -> ctype,"char[%d]",t -> length);
//fprintf(out," enum ctype '%s'\n",t -> ctype);
	} 
	else
	if (!strncasecmp(typ,"int",3) || 
			!strncasecmp(typ,"bigint",6) || 
			!strncasecmp(typ,"mediumint",9) ||
			!strncasecmp(typ,"tinyint",7) ||
			!strncasecmp(typ,"smallint",8))
	{
		strcpy(t -> ctype,"long");
	} 
	else
	if (!strncasecmp(typ,"char",4))
	{
		strcpy(len,typ + 5);
		len[strlen(len) - 1] = 0;
		t -> length = atoi(len);
//		fprintf(out,"%s length %d\n",typ,t -> length);
		sprintf(t -> ctype,"char[%d]",t -> length + 1);
	} 
	else
	if (!strncasecmp(typ,"varchar",7))
	{
		strcpy(len,typ + 8);
		len[strlen(len) - 1] = 0;
		t -> length = atoi(len);
//		fprintf(out,"%s length %d\n",typ,t -> length);
		sprintf(t -> ctype,"char[%d]",t -> length + 1);
	} 
	else
	if (!strcasecmp(typ,"datetime") || !strcasecmp(typ,"date"))
	{
		strcpy(t -> ctype,"char[40]");
		t -> length = 40;
	} 
	else
	if (!strcasecmp(typ,"text") || !strcasecmp(typ,"mediumtext") )
	{
		strcpy(t -> ctype,"text");
		t -> length = -1;
	} 
	else
	if (!strcasecmp(typ,"blob"))
	{
		strcpy(t -> ctype,"blob");
		t -> length = -1;
	} 
	else
	if (!strncasecmp(typ,"decimal",7))
	{
		strcpy(t -> ctype,"double");
		t -> length = 0;
	}
	else
	{
		fprintf(out,"Unsupported column data type: %s.%s '%s'\n",table,name,typ);
		*t -> ctype = 0;
		t -> length = 0;
		ok = 0;
	}
	fields.push_back(t);
	return t;
}


void import_sql(Database *db,db::Dbs *sdb,long usernum,FILE *fil,short insert)
{
	FIELDS *current = NULL;
	cgi::Parse *pa;
	short state = 0;
	char slask[200];
	char current_table[200];
	char current_column[200];
	char comment[200];

	fgets(slask,200,fil);
	while (!feof(fil))
	{
		slask[strlen(slask) - 1] = 0;
		pa = new cgi::Parse(slask);
		pa -> setbreak(',');
		pa -> disablebreak('(');
		pa -> enablebreak(')');
		pa -> getword(slask);
		while (*slask)
		{
			switch (state)
			{
			case 0:		// wait for 'create'
				if (!strcasecmp(slask,"create"))
				{
					state = 1;
				}
				break;
			case 1:		// wait for 'table'
				if (!strcasecmp(slask,"table"))
				{
					state = 2;
				}
				else
				{
					state = 0;
				}
				break;
			case 2:		// get table name
				strcpy(current_table,slask);
				state = 3;
				break;
			case 3:		// get '('
				if (!strcmp(slask,"("))
				{
					state = 4;
				}
				else
				{
					state = 0;
				}
				break;
			case 4:		// get column name or ')' end of table
				if (!strncmp(slask,"(*",2))
				{
					*comment = 0;
					state = 7;
				} 
				else
				if (!strcasecmp(slask,"primary") ||
						!strcasecmp(slask,"key") ||
						!strcasecmp(slask,"unique") ||
						!strcasecmp(slask,"index"))
				{
					while (*slask)
						pa -> getword(slask);
				} 
				else
				if (*slask == ')' || !strcmp(slask,");"))
				{
					current = NULL;
					state = 0;
				} 
				else
				{
					strcpy(current_column,slask);
					state = 5;
				}
				break;
			case 5:		// get column type
				current = reg_column(db,sdb,current_table,current_column,slask,usernum,insert);
				state = 6;
				break;
			case 6:		// wait for ',' or ')'
				if (*slask == ',')
				{
					state = 4;
				}
				else
				if (*slask == ')')
				{
					current = NULL;
					state = 0;
				}
				break;
			case 7:
				pa -> getword(slask);
				while (strcmp(slask + strlen(slask) - 2,"*)"))
				{
					if (*comment)
					{
						strcat(comment," ");
					}
					strcat(comment,slask);
					pa -> getword(slask);
				}
				if (current)
				{
					strcpy(current -> comment,comment);
				}
				state = 4;
				break;
			}
			pa -> getword(slask);
		}
		delete pa;
		fgets(slask,200,fil);
	}
	fclose(fil);

	if (*prevtable)
	{
		reg_table(db,sdb,prevtable,usernum,insert);
		while (fields.size())
		{
			fields_v::iterator it = fields.begin();
			FIELDS *p = *it;
			delete p;
			fields.erase(it);
		}
		*prevtable = 0;
	}
}


void import(Database& db,const std::string& filename,long usernum)
{
	Query *qd = new Query(db);
	FILE *fil;
	db::Dbs *sdb = NULL;
	db::Access *a = NULL;
	long l;
	char dbname[200];
	char sql[200];

	if ((fil = fopen(filename.c_str(),"rt")) == NULL)
	{
		fprintf(out,"Couldn't open '%s'...\n",filename.c_str());
		return;
	}

	*prevtable = 0;

	strcpy(dbname,filename.c_str());
	dbname[strlen(dbname) - 4] = 0;
	int x = 0;
	for (size_t i = 0; i < strlen(dbname); i++)
		if (dbname[i] == '/')
			x = i + 1;
	if (x)
		memcpy(dbname, dbname + x, strlen(dbname + x) + 1);

	sprintf(sql,"select num from dbs where name='%s' and owner<>%ld",db.safestr(dbname).c_str(),usernum);
	if (qd -> get_count(sql))
	{
		fprintf(out,"Database already exists with another owner - aborted\n");
		fclose(fil);
		return;
	}

	ok = 1;
	import_sql(&db,NULL,usernum,fil,0);

	if (ok)
	{
		sprintf(sql,"select num from dbs where name='%s'",db.safestr(dbname).c_str() );
		l = qd -> get_count(sql);
		if (l)
		{
			sdb = new db::Dbs(db,l);
		}
		else
		{
			sdb = new db::Dbs(&db);
			sdb -> owner = usernum;
			sdb -> createdate = datetime(); //strcpy(sdb -> createdate,datetime());
			sdb -> name = dbname; //strcpy(sdb -> name,slask);
			sdb -> insert();

			a = new db::Access(&db);
			a -> usernum = usernum;
			a -> dbnum = sdb -> num;
			a -> r = 1;
			a -> w = 1;
			a -> c = 1;
			a -> d = 1;
			a -> insert();
		}

		fil = fopen(filename.c_str(),"rt");
		import_sql(&db,sdb,usernum,fil,1);
	} 
	else
	{
		fprintf(out,"\n *** Too many errors, database not imported\n\n");
	}

	delete a;
	delete sdb;
	delete qd;
}


