// pages.cpp
/*
Copyright (C) 2001-2004  Anders Hedstrom (grymse@alhem.net)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
#ifdef WIN32
#include <Config-win.h>
static int getpid() { return 0; }
#endif
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <mysql/mysql.h>
#include <libmysqlwrapped.h>
#include <libdbd.h>
#include <string>
#include <libcgi++.h>

#include "dbd.h"
#include "html.h"
#include "utils.h"
#include "gsql.h"
#include "importsql.h"

#include "pages.h"


/*
 *
 */

void objheader(db::Access *a)
{
	fprintf(out,"<tr>");
	fprintf(out,"<th bgcolor=\"#e0e0e0\" valign=top align=left><font size=-1> Name </font></th>");
	fprintf(out,"<th bgcolor=\"#e0e0e0\" valign=top align=left><font size=-1> Description </font></th>");
	fprintf(out,"<th bgcolor=\"#e0e0e0\" valign=top align=left><font size=-1> Created by </font></th>");
	fprintf(out,"<th bgcolor=\"#e0e0e0\" valign=top align=left><font size=-1> Date </font></th>");
//	if (a -> w)
//		fprintf(out,"<th bgcolor=\"#e0e0e0\" valign=top align=left><font size=-1> Edit </font></th>");
//	if (a -> d)
//		fprintf(out,"<th bgcolor=\"#e0e0e0\" valign=top align=left><font size=-1> Delete </font></th>");
	fprintf(out,"<th bgcolor=\"#e0e0e0\" valign=top align=left><font size=-1> Comments </font></th>");
	fprintf(out,"<th bgcolor=\"#e0e0e0\" valign=top align=left><font size=-1> Write </font></th>");
	fprintf(out,"</tr>");
}


/*
 *
 */

void objpres(Database& db,long num,const std::string& name,
 long owner,const std::string& createdate,
 long changedby,const std::string& changedate,
 long deletedby,const std::string& deletedate,const std::string& typ,db::Users *user,
 const std::string& description,db::Access *a)
{
	Query *qd = new Query(db);
	long qty;
	char sql[200];
	char date[40];

// num,name,owner,createdate,changedby,changedate,deletedby,deletedate

	fprintf(out,"<tr>");
	if (a -> w)
		fprintf(out,"<td class=tab valign=top><font size=-1><a href=\"/cgi-bin/dbd/dbd?sel%s=%ld&change%s=0\">%s</a></font></td>",typ.c_str(),num,typ.c_str(),name.c_str());
	else
		fprintf(out,"<td class=tab valign=top><font size=-1><a href=\"/cgi-bin/dbd/dbd?sel%s=%ld\">%s</a></font></td>",typ.c_str(),num,name.c_str());
	fprintf(out,"<td class=tab valign=top><font size=-1>%s</font></td>",description.c_str());
	fprintf(out,"<td class=tab valign=top align=middle><font size=-1>");
	showuser(db,owner);
	fprintf(out,"</font></td>");
	fprintf(out,"<td class=tab valign=top><font size=-1>%s</font></td>",createdate.c_str());
//	if (a -> w)
//		fprintf(out,"<td class=tab valign=top align=middle><font size=-1>[<a href=\"/cgi-bin/dbd/dbd?change%s=0\">edit</a>]</font></td>",typ);
//	if (a -> d)
//		fprintf(out,"<td class=tab valign=top align=middle><font size=-1>[<a href=\"/cgi-bin/dbd/dbd?delete%s=0\">delete</a>]</font></td>",typ);
	sprintf(sql,"select count(*) from kommentar where %snum=%ld",typ.c_str(),num);
	qty = qd -> get_count(sql);
	sprintf(sql,"select dateposted from kommentar where %snum=%ld order by dateposted desc",typ.c_str(),num);
	strcpy(date,qd -> get_string(sql));
	fprintf(out,"<td class=tab valign=top align=middle><font size=-1><a href=\"/cgi-bin/dbd/dbd?read%s=0\">%ld</a>",typ.c_str(),qty);
	if (strcmp(date,user -> prevdatum.c_str()) > 0)
		fprintf(out," <img src=\"/image/new.gif\" alt=\"New!\">");
	fprintf(out,"</font></td>");
	fprintf(out,"<td class=tab valign=top align=middle><font size=-1>[ <a href=\"/cgi-bin/dbd/dbd?write%s=0\">comment</a> ]</font></td>",typ.c_str());
	fprintf(out,"</tr>");

	if (changedby)
	{
		fprintf(out,"<tr>");
		fprintf(out,"<td valign=top></td><th bgcolor=\"#e0e0e0\" valign=top align=right><font size=-1> Changed by </font></th>");
		fprintf(out,"<td class=tab valign=top align=middle><font size=-1>");
		showuser(db,changedby);
		fprintf(out,"</font></td>");
		fprintf(out,"<td class=tab valign=top><font size=-1>%s</font></td>",changedate.c_str());
		fprintf(out,"</tr>");
	}

	if (deletedby)
	{
		fprintf(out,"<tr>");
		fprintf(out,"<td valign=top></td><th bgcolor=\"#e0e0e0\" valign=top align=right><font size=-1> Deleted by </font></th>");
		fprintf(out,"<td class=tab valign=top align=middle><font size=-1>");
		showuser(db,deletedby);
		fprintf(out,"</font></td>");
		fprintf(out,"<td class=tab valign=top><font size=-1>%s</font></td>",deletedate.c_str());
		fprintf(out,"</tr>");
	}

	delete qd;
}


/*
 * Page 0: main page
 */

void page_0(Database& db,db::Dbs *sdb,db::Tbls *stbl,db::Applications *sapp,db::Flds *sfld,db::Indexs *sindex,db::Users *user,Cookies *cs)
{
	Query q(db),q2(db),q3(db);
	Query *qd = new Query(db);
	db::Flds *tempfld;
	db::Access *a = NULL;
	db::Indexs *tempindex;
	db::Appusers *tempau;
	db::Apptables *tempat;
	db::Appfields *tempaf;
	db::Users *tempuser;
	db::Tbls *temptbl;
	char *sql = new char[500];
	long qk;
	long l;
	int i,j;
	short sd;
	short qty;
	short th;
	short visa_status = 0;
	char slask[200];
	char date[40];

	sprintf(sql,"select * from access where usernum=%ld and dbnum=%ld",user -> num,sdb ? sdb -> num : 0);
	a = new db::Access(&db,sql);

	cs -> getvalue("sd",slask,20);
	sd = atoi(slask);

	header0("",1,cs);
fflush(out);

// Left column

//	printf("<table width=\"100%%\"><tr><td valign=top>");
//	printf("<form action=/cgi-bin/dbd/dbd method=post>");

//	left_frame(db,sdb,stbl,sfld,user,cs);


// End of left column, start of right column
//	printf("</td><td valign=top>");
	fprintf(out,"<table width=\"100%%\">");

// databases
	fprintf(out,"<tr><td%s colspan=8>",sdb ? " class=tab2" : "");

	fprintf(out,"<table width=\"100%%\" cellpadding=0 cellspacing=0><tr><td>");
	if (sdb)
	{
		fprintf(out,"<a href=\"/cgi-bin/dbd/dbd?tof=%d\">",CF_EXPAND_DB);
		if (cookieflags & CF_EXPAND_DB)
			iexpanded();
		else
			inotexpanded();
		fprintf(out,"</a>");
		fprintf(out,"&nbsp;Database: <a href=\"/cgi-bin/dbd/dbd?changedb=0\"><b>%s</b></a>",sdb -> name.c_str());
		if (sdb -> deleted)
			fprintf(out,"&nbsp;&lt;deleted&gt;");
		fprintf(out,"&nbsp;<a href=\"/cgi-bin/dbd/dbd?seldb=0\"><img border=0 src=\"/image/close2.png\" alt=\"Close\"></a>");
	}
	fprintf(out,"</td>");
	fprintf(out,"<td align=right>");
	strcpy(slask,"[\n");
	if (a -> c || 1) // alltid skapa databas
	{
		fprintf(out,"%s<a href=\"/cgi-bin/dbd/dbd?seldb=-1\">create database</a>\n",slask);
		strcpy(slask,"|\n");
	}
	if (sdb && a -> w)
	{
		fprintf(out,"%s<a href=\"/cgi-bin/dbd/dbd?changedb=0\">edit</a>\n",slask);
		strcpy(slask,"|\n");
	}
	if (sdb && a -> d)
	{
		fprintf(out,"%s<a href=\"/cgi-bin/dbd/dbd?deletedb=0\">delete</a>\n",slask);
		strcpy(slask,"|\n");
	}
	if (*slask == '|')
		fprintf(out,"]");
	fprintf(out,"</td></tr></table>");

	fprintf(out,"</td></tr>");

	if (sdb && ((cookieflags & CF_EXPAND_DB) != 0))
	{
		objheader(a);
		objpres(db,sdb -> num,sdb -> name,
		 sdb -> owner,sdb -> createdate,
		 sdb -> changedby,sdb -> changedate,
		 sdb -> deletedby,sdb -> deletedate,"db",user,sdb -> description,a);
//		printf("<tr><td colspan=8>&nbsp;</td></tr>");
	}
fflush(out);


// applications
	if (sdb)
	{
		fprintf(out,"<tr><td%s colspan=8>",sdb && sapp ? " class=tab2" : "");

		fprintf(out,"<table width=\"100%%\" cellpadding=0 cellspacing=0><tr><td>");
		if (sapp)
		{
			fprintf(out,"<a href=\"/cgi-bin/dbd/dbd?tof=%d\">",CF_EXPAND_APP);
			if (cookieflags & CF_EXPAND_APP)
				iexpanded();
			else
				inotexpanded();
			fprintf(out,"</a>\n");
			fprintf(out,"Application: <a href=\"/cgi-bin/dbd/dbd?changeapp=0\"><b>%s</b></a>\n",sapp -> name.c_str());
			if (sapp -> deleted)
				fprintf(out,"&lt;deleted&gt;\n");
			fprintf(out,"<a href=\"/cgi-bin/dbd/dbd?selapp=0\"><img border=0 src=\"/image/close2.png\" alt=\"Close\"></a>");
		}
		fprintf(out,"</td><td align=right>");

		strcpy(slask,"[\n");
		if (a -> c)
		{
			fprintf(out,"%s<a href=\"/cgi-bin/dbd/dbd?selapp=-1\">create application</a>\n",slask);
			strcpy(slask,"|\n");
		}
		if (sapp && a -> w)
		{
			fprintf(out,"%s<a href=\"/cgi-bin/dbd/dbd?changeapp=0\">edit</a>\n",slask);
			strcpy(slask,"|\n");
		}
		if (sapp && a -> d)
		{
			fprintf(out,"%s<a href=\"/cgi-bin/dbd/dbd?deleteapp=0\">delete</a>\n",slask);
			strcpy(slask,"|\n");
		}
		if (*slask == '|')
			fprintf(out,"]");

		fprintf(out,"</td></tr></table>");

		fprintf(out,"</td></tr>");

		if (sapp && ((cookieflags & CF_EXPAND_APP) != 0))
		{
			objheader(a);
			objpres(db,sapp -> num,sapp -> name,
			 sapp -> owner,sapp -> createdate,
			 sapp -> changedby,sapp -> changedate,
			 sapp -> deletedby,sapp -> deletedate,"app",user,sapp -> description,a);
//			printf("<tr><td colspan=8>&nbsp;</td></tr>");
		}
	} // if (sdb)
fflush(out);


// tables
	if (sdb)
	{
		fprintf(out,"<tr><td%s colspan=8>",sdb && stbl ? " class=tab2" : "");

		fprintf(out,"<table width=\"100%%\" cellpadding=0 cellspacing=0><tr><td>");
		if (stbl)
		{
			fprintf(out,"<a href=\"/cgi-bin/dbd/dbd?tof=%d\">",CF_EXPAND_TBL);
			if (cookieflags & CF_EXPAND_TBL)
				iexpanded();
			else
				inotexpanded();
			fprintf(out,"</a>\n");
			fprintf(out,"Table: <a href=\"/cgi-bin/dbd/dbd?changetbl=0\"><b>%s</b></a>\n",stbl -> name.c_str());
			if (stbl -> deleted)
				fprintf(out,"&lt;deleted&gt;\n");
			fprintf(out,"<a href=\"/cgi-bin/dbd/dbd?seltbl=0\"><img border=0 src=\"/image/close2.png\" alt=\"Close\"></a>");
		}
		fprintf(out,"</td><td align=right>");

		strcpy(slask,"[\n");
		if (a -> c)
		{
			fprintf(out,"%s<a href=\"/cgi-bin/dbd/dbd?seltbl=-1\">create table</a>\n",slask);
			strcpy(slask,"|\n");
		}
		if (stbl && a -> w)
		{
			fprintf(out,"%s<a href=\"/cgi-bin/dbd/dbd?changetbl=0\">edit</a>\n",slask);
			strcpy(slask,"|\n");
		}
		if (stbl && a -> d)
		{
			fprintf(out,"%s<a href=\"/cgi-bin/dbd/dbd?deletetbl=0\">delete</a>\n",slask);
			strcpy(slask,"|\n");
		}
		if (*slask == '|')
			fprintf(out,"]");

// TODO: live sync av en enskild tabell
		fprintf(out,"</td></tr></table>");

		fprintf(out,"</td></tr>");

		if (stbl && ((cookieflags & CF_EXPAND_TBL) != 0))
		{
			objheader(a);
			objpres(db,stbl -> num,stbl -> name,
			 stbl -> owner,stbl -> createdate,
			 stbl -> changedby,stbl -> changedate,
			 stbl -> deletedby,stbl -> deletedate,"tbl",user,stbl -> description,a);
//			printf("<tr><td colspan=8>&nbsp;</td></tr>");
		}
	} // if (sdb)
fflush(out);


// tables - application view
	if (sdb && sapp && !stbl)
	{
	// start of main table row
		fprintf(out,"<tr><td colspan=8>");
	// info

	// appusers developer/tester
		fprintf(out,"<h3>Crew (application development)</h3>");
		sprintf(sql,"select num from appusers where appnum=%ld",sapp -> num);
		q.get_result(sql);
		if (q.num_rows())
		{
			fprintf(out,"<center><table width=\"95%%\"><tr><td>");
			fprintf(out,"<table><tr>");
			fprintf(out,"<th bgcolor=\"#e0e0e0\" align=left> Individual </th>");
			fprintf(out,"<th bgcolor=\"#e0e0e0\" align=left> Role </th></tr>");
		}
		while (q.fetch_row())
		{
			tempau = new db::Appusers(db,q.getval());
			fprintf(out,"<tr><td class=tab>");
			showuser(db,tempau -> usernum);
			fprintf(out,"</td><td class=tab>%s</td></tr>",tempau -> status.c_str());
			delete tempau;
		}
		if (q.num_rows())
			fprintf(out,"</table></td></tr></table></center>");
		q.free_result();
fflush(out);

	// form add user + status
		if (a -> w)
		{
			fprintf(out,"<form action=/cgi-bin/dbd/dbd method=post target=rf>");
			fprintf(out,"<input type=hidden name=addappuser value=1>");
			sprintf(sql,"select usernum from access where dbnum=%ld",sdb -> num);
			q.get_result(sql);
			fprintf(out,"<table><td>");
			fprintf(out,"<select name=usernum>");
			while (q.fetch_row())
			{
				l = q.getval();
				sprintf(sql,"select num from appusers where appnum=%ld and usernum=%ld",sapp -> num,l);
				if (!qd -> get_count(sql))
				{
					tempuser = new db::Users(db,l);
					fprintf(out,"<option value=%ld>%s",tempuser -> num,tempuser -> name.c_str());
					delete tempuser;
				}
			}
			q.free_result();
			fprintf(out,"</select>");
			fprintf(out,"</td><td>");
			fprintf(out,"<select name=status><option>Developer");
			fprintf(out,"<option>Tester");
			fprintf(out,"</select>");
			fprintf(out,"</td><td>");
			fprintf(out,"<input type=submit name=submit value=\" Add user \">");
			fprintf(out,"</td></tr></table>");
			fprintf(out,"</form>");
		}
fflush(out);

	// apptables checked
		fprintf(out,"<h3>Tables used by application</h3>");

		fprintf(out,"<form action=/cgi-bin/dbd/dbd method=post target=rf>");
		fprintf(out,"<input type=hidden name=updtableinfo value=1>");
		fprintf(out,"<center><table width=\"95%%\"><tr><td>");
		fprintf(out,"<table><tr>");
		fprintf(out,"<th bgcolor=\"#e0e0e0\" align=left> Used </th>");
		fprintf(out,"<th bgcolor=\"#e0e0e0\" align=left> Implemented </th>");
		fprintf(out,"<th bgcolor=\"#e0e0e0\" align=left> Table </th>");
		fprintf(out,"</tr>");

		// tabeller med tblgrpnum=0
		sprintf(sql,"select num from tbls where dbnum=%ld and tblgrpnum=0 and deleted=0 order by name",sdb -> num);
		q.get_result(sql);
		while (q.fetch_row())
		{
			temptbl = new db::Tbls(db,q.getval());
			sprintf(sql,"select num from apptables where appnum=%ld and tblnum=%ld",sapp -> num,temptbl -> num);
			l = qd -> get_count(sql);
			if (!l)
			{
				tempat = new db::Apptables(&db);
				tempat -> appnum = sapp -> num;
				tempat -> tblnum = temptbl -> num;
				tempat -> save();
			}
			else
			{
				tempat = new db::Apptables(db,l);
			}

			fprintf(out,"<tr><td class=tab align=middle><input type=checkbox name=tblnum%ld%s value=1></td>",temptbl -> num,tempat -> checked ? " CHECKED" : "");
			sprintf(sql,"select count(*) from appfields where appnum=%ld and tblnum=%ld",sapp -> num,temptbl -> num);
			l = qd -> get_count(sql);
			sprintf(sql,"select count(*) from appfields where appnum=%ld and tblnum=%ld and status='Implemented'",sapp -> num,temptbl -> num);
			if (!l)
				fprintf(out,"<td class=tab align=middle> --- </td>");
			else
				fprintf(out,"<td class=tab align=right>%ld %%</td>",100 * qd -> get_count(sql) / l);
			fprintf(out,"<td class=tab><a href=\"/cgi-bin/dbd/dbd?seltbl=%ld\">%s</a></td>",temptbl -> num,temptbl -> name.c_str());
			fprintf(out,"</tr>");

			delete tempat;
			delete temptbl;
		}
		q.free_result();

		// tblgrupper och dess tabeller...
		sprintf(sql,"select num,name from tblgrps where dbnum=%ld",sdb -> num);
		q2.get_result(sql);
		while (q2.fetch_row())
		{
			l = q2.getval();	// tblgrpnum

			sprintf(sql,"select num from tbls where dbnum=%ld and tblgrpnum=%ld and deleted=0 order by name",sdb -> num,l);
			q.get_result(sql);
			if (q.num_rows())
				fprintf(out,"<tr><td class=tab colspan=3><font size=+1><b>%s</b></font></td></tr>",q2.getstr());
			while (q.fetch_row())
			{
				temptbl = new db::Tbls(db,q.getval());
				sprintf(sql,"select num from apptables where appnum=%ld and tblnum=%ld",sapp -> num,temptbl -> num);
				l = qd -> get_count(sql);
				if (!l)
				{
					tempat = new db::Apptables(&db);
					tempat -> appnum = sapp -> num;
					tempat -> tblnum = temptbl -> num;
					tempat -> save();
				}
				else
				{
					tempat = new db::Apptables(db,l);
				}

				fprintf(out,"<tr><td class=tab align=middle><input type=checkbox name=tblnum%ld%s value=1></td>",temptbl -> num,tempat -> checked ? " CHECKED" : "");
				sprintf(sql,"select count(*) from appfields where appnum=%ld and tblnum=%ld",sapp -> num,temptbl -> num);
				l = qd -> get_count(sql);
				sprintf(sql,"select count(*) from appfields where appnum=%ld and tblnum=%ld and status='Implemented'",sapp -> num,temptbl -> num);
				if (!l)
					fprintf(out,"<td class=tab align=middle> --- </td>");
				else
					fprintf(out,"<td class=tab align=right>%ld %%</td>",100 * qd -> get_count(sql) / l);
				fprintf(out,"<td class=tab><a href=\"/cgi-bin/dbd/dbd?seltbl=%ld\">%s</a></td>",temptbl -> num,temptbl -> name.c_str());
				fprintf(out,"</tr>");

				delete tempat;
				delete temptbl;
			}
			q.free_result();
		}
		q2.free_result();

		fprintf(out,"</table></td></tr></table></center>");

	// submit changes to apptables
		fprintf(out,"<input type=submit name=submit value=\" Update table information \">");
		fprintf(out,"</form>");


	// end of main table row
		fprintf(out,"</td></tr>");
	}
	else	// if (sapp)


// fields
	if (stbl)
	{
		fprintf(out,"<tr><td%s colspan=8>",stbl && sfld ? " class=tab2" : "");
		fprintf(out,"<table width=\"100%%\" cellpadding=0 cellspacing=0><tr><td>");
		if (sfld)
		{
			fprintf(out,"<a href=\"/cgi-bin/dbd/dbd?tof=%d\">",CF_EXPAND_FLD);
			if (cookieflags & CF_EXPAND_FLD)
				iexpanded();
			else
				inotexpanded();
			fprintf(out,"</a>\n");
			fprintf(out,"Field: <a href=\"/cgi-bin/dbd/dbd?changefld=0\"><b>%s</b></a>\n",sfld -> name.c_str());
			if (sfld -> deleted)
				fprintf(out,"&lt;deleted&gt;\n");
			fprintf(out,"<a href=\"/cgi-bin/dbd/dbd?selfld=0\"><img border=0 src=\"/image/close2.png\" alt=\"Close\"></a>");
		}
		fprintf(out,"</td><td align=right>");
		strcpy(slask,"[\n");
		if (a -> c)
		{
			fprintf(out,"%s<a href=\"/cgi-bin/dbd/dbd?selfld=-1\">create field</a>\n",slask);
			strcpy(slask,"|\n");
		}
		if (sfld && a -> w)
		{
			fprintf(out,"%s<a href=\"/cgi-bin/dbd/dbd?changefld=0\">edit</a>\n",slask);
			strcpy(slask,"|\n");
		}
		if (sfld && a -> d)
		{
			fprintf(out,"%s<a href=\"/cgi-bin/dbd/dbd?deletefld=0\">delete</a>\n",slask);
			strcpy(slask,"|\n");
		}
		if (*slask == '|')
			fprintf(out,"]");
		fprintf(out,"</td></tr></table>");

		fprintf(out,"</td></tr>");
		if (sfld && ((cookieflags & CF_EXPAND_FLD) != 0))
		{
			objheader(a);
			objpres(db,sfld -> num,sfld -> name,
			 sfld -> owner,sfld -> createdate,
			 sfld -> changedby,sfld -> changedate,
			 sfld -> deletedby,sfld -> deletedate,"fld",user,sfld -> description,a);
//			printf("<tr><td colspan=8>&nbsp;</td></tr>");
		}

	/*
	 * index
	 */
		fprintf(out,"<tr><td%s colspan=8>",sindex ? " class=tab2" : "");
		fprintf(out,"<table width=\"100%%\" cellpadding=0 cellspacing=0><tr><td>");
		if (sindex)
		{
			fprintf(out,"<a href=\"/cgi-bin/dbd/dbd?tof=%d\">",CF_EXPAND_INDEX);
			if (cookieflags & CF_EXPAND_INDEX)
				iexpanded();
			else
				inotexpanded();
			fprintf(out,"</a>\n");
			fprintf(out,"Index: <a href=\"/cgi-bin/dbd/dbd?changeindex=0\"><b>%s</b></a>\n",sindex -> name.c_str());
			if (sindex -> deleted)
				fprintf(out,"&lt;deleted&gt;\n");
			fprintf(out,"<a href=\"/cgi-bin/dbd/dbd?selindex=0\"><img border=0 src=\"/image/close2.png\" alt=\"Close\"></a>");
		}
		fprintf(out,"</td><td align=right>");
		strcpy(slask,"[\n");
		if (a -> c)
		{
			fprintf(out,"%s<a href=\"/cgi-bin/dbd/dbd?selindex=-1\">create index</a>\n",slask);
			strcpy(slask,"|\n");
		}
		if (sindex && a -> w)
		{
			fprintf(out,"%s<a href=\"/cgi-bin/dbd/dbd?changeindex=0\">edit</a>\n",slask);
			strcpy(slask,"|\n");
		}
		if (sindex && a -> d)
		{
			fprintf(out,"%s<a href=\"/cgi-bin/dbd/dbd?deleteindex=0\">delete</a>\n",slask);
			strcpy(slask,"|\n");
		}
		if (*slask == '|')
			fprintf(out,"]");
		fprintf(out,"</td></tr></table>");

		fprintf(out,"</td></tr>");
		if (sindex && ((cookieflags & CF_EXPAND_INDEX) != 0))
		{
			objheader(a);
			objpres(db,sindex -> num,sindex -> name,
			 sindex -> owner,sindex -> createdate,
			 sindex -> changedby,sindex -> changedate,
			 sindex -> deletedby,sindex -> deletedate,"index",user,sindex -> description,a);
//			printf("<tr><td colspan=8>&nbsp;</td></tr>");
		}

	/*
	 * fields/index-tabell
	 */
	 	fprintf(out,"<tr><td colspan=8>");

		if (sapp && stbl)
		{
			sprintf(sql,"select checked from apptables where appnum=%ld and tblnum=%ld",sapp -> num,stbl -> num);
			visa_status = qd -> get_count(sql);
		}

	 	sprintf(sql,"select count(*) from indexs where tblnum=%ld",stbl -> num);
	 	l = qd -> get_count(sql);
		sprintf(sql,"select num from flds where tblnum=%ld %s order by ordning",stbl -> num,sd ? "" : "and deleted=0");
		q.get_result(sql);
		if (l || (qty = q.num_rows()) > 0)
		{
			fprintf(out,"<center><table width=\"95%%\"><tr><td><b>Table: %s</b></td></tr></table>",stbl -> name.c_str());
			fprintf(out,"<table cellpadding=0 cellspacing=0 width=\"95%%\"><tr><td><table><tr>");
			fprintf(out,"<th bgcolor=\"#e0e0e0\" align=left colspan=2><font size=-1> Name </font></th>");
			if (visa_status)
				fprintf(out,"<th bgcolor=\"#e0e0e0\" align=left><font size=-1> Status </font></th>");
			fprintf(out,"<th bgcolor=\"#e0e0e0\" align=left><font size=-1> Description </font></th>");
			fprintf(out,"<th bgcolor=\"#e0e0e0\" align=left><font size=-1> Type </font></th>");
			fprintf(out,"<th bgcolor=\"#e0e0e0\" align=left><font size=-1> Extra </font></th>");
			if (a -> w)
				fprintf(out,"<th bgcolor=\"#e0e0e0\" align=left><font size=-1> Order </font></th>");
		// comments................................
			fprintf(out,"<th bgcolor=\"#e0e0e0\" align=left><font size=-1> Comments </font></th>");
			fprintf(out,"</tr>");
			th = 1;
		}
		else
		{
			th = 0;
		}
		if ((qty = q.num_rows()) > 0)
		{
			i = 0;
			while (q.fetch_row())
			{
				tempfld = new db::Flds(db,q.getval());
				fprintf(out,"<tr>");
				fprintf(out,"<td class=tab valign=top><font size=-1><a href=\"/cgi-bin/dbd/dbd?selfld=%ld\">%s</a></font></td>",tempfld -> num,tempfld -> name.c_str());
				if (a -> w)
					fprintf(out,"<td class=tab align=right valign=top><font size=-1>[<a href=\"/cgi-bin/dbd/dbd?selfld=%ld&changefld=0\">edit</a>]</font></td>",tempfld -> num);
				else
					fprintf(out,"<td class=tab valign=top><font size=-1>");
				fprintf(out,"</font></td>");
				// status
				if (visa_status)
				{
					sprintf(sql,"select num from appfields where appnum=%ld and fldnum=%ld",sapp -> num,tempfld -> num);
					l = qd -> get_count(sql);
					if (!l)
					{
						tempaf = new db::Appfields(&db);
						tempaf -> appnum = sapp -> num;
						tempaf -> fldnum = tempfld -> num;
						tempaf -> status = "Planned"; //strcpy(tempaf -> status,"Planned");
						tempaf -> tblnum = stbl -> num;
						tempaf -> save();
					}
					else
					{
						tempaf = new db::Appfields(db,l);
					}
					strcpy(slask,tempaf -> status.c_str());
					slask[4] = 0;	// Plan / Impl
					if (!strcmp(slask,"Plan"))
						fprintf(out,"<td class=tab valign=top bgcolor=\"#ffff80\" align=middle><font size=-1>%s</font></td>",slask);
					else
					if (!strcmp(slask,"Impl"))
						fprintf(out,"<td class=tab valign=top bgcolor=\"#80ff80\" align=middle><font size=-1>%s</font></td>",slask);
					else // Hold
						fprintf(out,"<td class=tab valign=top bgcolor=\"#ff8080\" align=middle><font size=-1>%s</font></td>",slask);
					delete tempaf;
				}
				fprintf(out,"<td class=tab valign=top><font size=-1>%s</font></td>",tempfld -> description.c_str());

				// type string
				fprintf(out,"<td class=tab valign=top><font size=-1>");
				if (tempfld -> fieldtype == 4)
					fprintf(out,"ENUM ...</td>");
				else
				if (tempfld -> fieldtype == 7)
					fprintf(out,"SET ...</td>");
				else
				if (tempfld -> fieldtype == 5)
					fprintf(out,"ptr to table</td>");
				else
				{
					strcpy(slask,typestring(tempfld));
					for (j = 1; j < (int)strlen(slask); j++)
						if (slask[j] == ' ')
							slask[j] = 0;
					fprintf(out,"%s</td>",slask);
				}
				// extra
				fprintf(out,"<td class=tab valign=top><font size=-1>");
				switch (tempfld -> fieldtype)
				{
				    case 1:
				    	break;
				    case 2:
				    	if (tempfld -> minvalue < tempfld -> maxvalue)
				    		fprintf(out,"%ld .. %ld",tempfld -> minvalue,tempfld -> maxvalue);
				    	break;
				    case 3:
				    	break;
				    case 4:
				    	fprintf(out,"%s",tempfld -> options.c_str());
				    	break;
				    case 5:
				    	sprintf(sql,"select name from tbls where num=%ld",tempfld -> ptrtotblnum);
				    	fprintf(out,"<a href=\"/cgi-bin/dbd/dbd?seltbl=%ld\">%s</a>",tempfld -> ptrtotblnum,qd -> get_string(sql));
				    	break;
				    case 6: // number
				    	break;
				    case 7:
				    	fprintf(out,"%s",tempfld -> options.c_str());
				    	break;
				}
				fprintf(out,"</font></td>");
				fprintf(out,"<td class=tab valign=top><font size=-1>");
				if (a -> w)
				{
					bool up = false;
					if (i++)
					{
						fprintf(out,"<a href=\"/cgi-bin/dbd/dbd?up=%ld\">up</a>",tempfld -> num);
						up = true;
						if (i < qty)
						{
							fprintf(out,"&nbsp;|&nbsp;");
						}
					}
					if (i < qty)
					{
						if (!up)
							fprintf(out,"<div align=\"right\">");
						fprintf(out,"<a href=\"/cgi-bin/dbd/dbd?down=%ld\">down</a>",tempfld -> num);
						if (!up)
							fprintf(out,"</div>");
					}
				}
				else
				{
					i++;
				}
				fprintf(out,"</font></td>");
				// comments................................
				sprintf(sql,"select count(*) from kommentar where fldnum=%ld",tempfld -> num);
				qk = qd -> get_count(sql);
				sprintf(sql,"select dateposted from kommentar where fldnum=%ld order by dateposted desc",tempfld -> num);
				strcpy(date,qd -> get_string(sql));
				fprintf(out,"<td class=tab valign=top align=middle><font size=-1><a href=\"/cgi-bin/dbd/dbd?selfld=%ld&readfld=0\">%ld</a>",tempfld -> num,qk);
				if (strcmp(date,user -> prevdatum.c_str()) > 0)
					fprintf(out," <img src=\"/image/new.gif\" alt=\"New!\">");
				fprintf(out,"</font></td>");
				if (tempfld -> deleted) // deleted
					fprintf(out,"<td class=tab valign=top><font size=-1>&lt;deleted&gt;</font></td>");
				fprintf(out,"</tr>");
				delete tempfld;
			}
		}
		q.free_result();

		/*
		 * indexs
		 */

		sprintf(sql,"select num from indexs where tblnum=%ld%s",stbl -> num,sd ? "" : " and deleted=0");
		q.get_result(sql);
		while (q.fetch_row())
		{
			tempindex = new db::Indexs(db,q.getval());
			fprintf(out,"<tr>");
			// name
			fprintf(out,"<td class=tab valign=top><font size=-1>");

			fprintf(out,"~<a href=\"/cgi-bin/dbd/dbd?selindex=%ld\">%s</a></font></td>",tempindex -> num,tempindex -> name.c_str());
			fprintf(out,"<td class=tab align=right valign=top><font size=-1>");
			fprintf(out,"[<a href=\"/cgi-bin/dbd/dbd?selindex=%ld&changeindex=0\">edit</a>]",tempindex -> num);

			fprintf(out,"</font></td>");
			// status
			if (visa_status)
				fprintf(out,"<td class=tab></td>");
			// description
			fprintf(out,"<td class=tab valign=top><font size=-1>%s</font></td>",tempindex -> description.c_str());
			// type
			fprintf(out,"<td class=tab valign=top><font size=-1>%s</font></td>",tempindex -> typ.c_str());
			// extra
			sprintf(sql,"select flds.name from indexlist,flds where indexnum=%ld and flds.num=fldnum",tempindex -> num);
			q2.get_result(sql);
			*slask = 0;
			fprintf(out,"<td class=tab><font size=-1>");
			while (q2.fetch_row())
			{
				fprintf(out,"%s%s",slask,q2.getstr());
				strcpy(slask,", ");
			}
			q2.free_result();
			fprintf(out,"</td>");
			// order
			fprintf(out,"<td class=tab></td>");
			// comments
			sprintf(sql,"select count(*) from kommentar where indexnum=%ld",tempindex -> num);
			qk = qd -> get_count(sql);
			sprintf(sql,"select dateposted from kommentar where indexnum=%ld order by dateposted desc",tempindex -> num);
			strcpy(date,qd -> get_string(sql));
			fprintf(out,"<td class=tab valign=top align=middle><font size=-1><a href=\"/cgi-bin/dbd/dbd?selindex=%ld&readindex=0\">%ld</a>",tempindex -> num,qk);
			if (strcmp(date,user -> prevdatum.c_str()) > 0)
				fprintf(out," <img src=\"/image/new.gif\" alt=\"New!\">");
			fprintf(out,"</font></td>");
			// deleted
			if (tempindex -> deleted) // deleted
				fprintf(out,"<td class=tab valign=top><font size=-1>&lt;deleted&gt;</font></td>");
			fprintf(out,"</tr>");
			delete tempindex;
		}
		q.free_result();

		if (th)
			fprintf(out,"</table></td></tr></table></center>");

		fprintf(out,"</td></tr>");
	} // if (stbl)

	fprintf(out,"</table>");
//	printf("</form>");
//	printf("</td></tr></table>");
	footer();

	delete sql;
	delete qd;
	delete a;
}


/*
 * create database
 */

void page_1(Database& db,db::Dbs *sdb,db::Tbls *stbl,db::Flds *sfld,db::Users *user,Cookies *cs,char *s,short ok)
{
	Query q(db);
	Query *qd = new Query(db);
	long l;
	char slwr[20];
	char slask[200];
	char sql[200];
// s == 'Create' / 'Change' / 'Delete'

	strcpy(slwr,s);
	strlwr(slwr);

    	sprintf(slask,"%s Database",s);
    	header0(slask,1,cs);

	fprintf(out,"<table><tr><td valign=top>");
//	left_frame(db,sdb,stbl,sfld,user,cs);
	fprintf(out,"</td><td valign=top>");

	fprintf(out,"<form action=/cgi-bin/dbd/dbd method=post target=_top>");
	fprintf(out,"<input type=hidden name=%sdb value=1>",slwr);
	if (sdb)
		fprintf(out,"<input type=hidden name=num value=%ld>",sdb -> num);

	fprintf(out,"<table cellpadding=0 cellspacing=0><tr><td valign=top>");
	fprintf(out,"Database name<br><input type=text name=name value=\"%s\"><br>",sdb ? sdb -> name.c_str() : "");
	fprintf(out,"</td><td valign=top>");
	fprintf(out,"Description<br><input type=text name=description size=40 value=\"%s\"><br>",
	 sdb ? sdb -> description.c_str() : "");
	fprintf(out,"</td></tr></table>");

// group select
	fprintf(out,"In group<br><select name=grpnum>");
	if (sdb)
	{
		sprintf(sql,"select grpnum from grplinks where usernum=%ld and dbnum=%ld",user -> num,sdb -> num);
		l = qd -> get_count(sql);
		sprintf(sql,"select name from grps where num=%ld",l);
		fprintf(out,"<option value=%ld>%s",l,qd -> get_string(sql));
	}
	else
	{
		l = 0;
	}
	sprintf(sql,"select num,name from grps where (usernum=0 or usernum=%ld) and num<>%ld",user -> num,l);
	q.get_result(sql);
	while (q.fetch_row())
		fprintf(out,"<option value=%ld>%s",q.getval(0),q.getstr(1));
	q.free_result();
	fprintf(out,"</select>");
	fprintf(out,"<br>");

	fprintf(out,"Comment<br>");
	fprintf(out,"<textarea name=kommentar rows=8 cols=60 wrap=soft>");
	fprintf(out,"</textarea>");
	if (!ok && !strcmp(s,"Create"))
		fprintf(out,"<h3>Database will not be created - user limit reached</h3>");
	fprintf(out,"<table><tr><td valign=top>");
	fprintf(out,"<input type=submit name=submit value=\" %s \">",s);
	fprintf(out,"</form>");
	fprintf(out,"<form action=/cgi-bin/dbd/dbd method=post>");
//	fprintf(out,"<input type=hidden name=seldb value=0>");
//	fprintf(out,"<input type=hidden name=seltbl value=0>");
//	fprintf(out,"<input type=hidden name=selfld value=0>");
	fprintf(out,"</td><td valign=top>");
	fprintf(out,"<input type=submit name=submit value=\" Cancel \">");
	fprintf(out,"</td></tr></table>");
	fprintf(out,"</form>");

	fprintf(out,"</td></tr></table>");
    	footer();

	delete qd;
}

/*
 * create table
 */

void page_2(Database& db,db::Dbs *sdb,db::Tbls *stbl,db::Flds *sfld,db::Users *user,Cookies *cs,char *s,short ok)
{
	Query q(db),q2(db);
	db::Dbs *tempdb;
	long tblgrpnum;
	char slwr[20];
	char slask[200];
	char sql[200];
	char tblgrpname[40];

	strcpy(slwr,s);	// 'create' / 'change' / 'delete'
	strlwr(slwr);

    	sprintf(slask,"%s Table",s);
    	header0(slask,1,cs);

	fprintf(out,"<table><tr><td valign=top>");
//	left_frame(db,sdb,stbl,sfld,user,cs);
	fprintf(out,"</td><td valign=top>");

	fprintf(out,"<form action=/cgi-bin/dbd/dbd method=post target=_top>");
//	fprintf(out,"<form action=/cgi-bin/dbd/dbd method=post>");
	fprintf(out,"<input type=hidden name=%stbl value=1>",slwr);
	if (stbl)
		fprintf(out,"<input type=hidden name=num value=%ld>",stbl -> num);
	fprintf(out,"<table cellpadding=0 cellspacing=0><tr><td valign=top>");
	fprintf(out,"Table name<br><input type=text name=name value=\"%s\"><br>",stbl ? stbl -> name.c_str() : "");
	fprintf(out,"</td><td valign=top>");
	fprintf(out,"Description<br><input type=text name=description size=40 value=\"%s\"><br>",
	 stbl ? stbl -> description.c_str() : "");
	fprintf(out,"</td></tr></table>");
	fprintf(out,"In database<br><select name=dbnum><option value=%ld>%s",sdb -> num,sdb -> name.c_str());

	// select database
	sprintf(sql,"select dbnum from access where usernum=%ld and c<>0 and dbnum<>%ld",user -> num,sdb -> num);
	q.get_result(sql);
	while (q.fetch_row())
	{
		tempdb = new db::Dbs(db,q.getval());
		if (!tempdb -> deleted)
			fprintf(out,"<option value=%ld>%s",tempdb -> num,tempdb -> name.c_str());
		delete tempdb;
	}
	q.free_result();
	fprintf(out,"</select><br>");
	// select tblgrp
	if (stbl)
	{
		sprintf(sql,"select num,name from tblgrps where dbnum=%ld order by name",sdb -> num);
		q.get_result(sql);
		if (q.num_rows())
		{
			sprintf(sql,"select name from tblgrps where num=%ld",stbl -> tblgrpnum);
			fprintf(out,"Table group<br><select name=tblgrpnum><option value=%ld>%s",stbl -> tblgrpnum,q2.get_string(sql));
		}
		else
		{
			fprintf(out,"<input type=hidden name=tblgrpnum value=0>");
		}
		while (q.fetch_row())
		{
			tblgrpnum = q.getval();
			strcpy(tblgrpname,q.getstr());
			if (tblgrpnum != stbl -> tblgrpnum)
				fprintf(out,"<option value=%ld>%s",tblgrpnum,tblgrpname);
		}
		if (q.num_rows())
		{
			if (stbl -> tblgrpnum)
				fprintf(out,"<option value=0>");
			fprintf(out,"</select><br>");
		}
		q.free_result();
	}
	else
	{
		sprintf(sql,"select num,name from tblgrps where dbnum=%ld order by name",sdb -> num);
		q.get_result(sql);
		if (q.num_rows())
			fprintf(out,"Table group<br><select name=tblgrpnum><option value=0>");
		else
			fprintf(out,"<input type=hidden name=tblgrpnum value=0>");
		while (q.fetch_row())
		{
			tblgrpnum = q.getval();
			strcpy(tblgrpname,q.getstr());
			fprintf(out,"<option value=%ld>%s",tblgrpnum,tblgrpname);
		}
		if (q.num_rows())
			fprintf(out,"</select><br>");
		q.free_result();
	}

	fprintf(out,"Comment<br>");
	fprintf(out,"<textarea name=kommentar rows=8 cols=60 wrap=soft>");
	fprintf(out,"</textarea>");
	if (!ok && !strcmp(s,"Create"))
		fprintf(out,"<h3>Table will not be created - user limit reached</h3>");
	fprintf(out,"<table><tr><td valign=top>");
	fprintf(out,"<input type=submit name=submit value=\" %s \">",s);
	fprintf(out,"</form>");
	fprintf(out,"<form action=/cgi-bin/dbd/dbd method=post>");
//	fprintf(out,"<input type=hidden name=seltbl value=0>");
//	fprintf(out,"<input type=hidden name=selfld value=0>");
	fprintf(out,"</td><td valign=top>");
	fprintf(out,"<input type=submit name=submit value=\" Cancel \">");
	fprintf(out,"</td></tr></table>");
	fprintf(out,"</form>");

	fprintf(out,"</td></tr></table>");
    	footer();
}


/*
 *
 */

void fieldselect(int num,const std::string& tmp)
{
	std::string s = tmp;
	cgi::Parse *pa;
	char slask[500];
	char ord[20];

	switch (num)
	{
		case 1: // char but not char / varchar
			strcpy(slask,"tinytext text mediumtext longtext tinyblob blob mediumblob longblob");
			break;
		case 2: // int
			strcpy(slask,"int tinyint smallint mediumint bigint");
			break;
		case 3: // time
			strcpy(slask,"datetime date timestamp time year");
			break;
		case 6: // number
			strcpy(slask,"float double decimal");
			break;
		default:
			*slask = 0;
	}
	strupr(slask);

	fprintf(out,"<select name=fieldstr%d>",num);

	if (s.size())
	{
		strupr(s);
		pa = new cgi::Parse(slask);
		pa -> getword(ord);
		while (*ord)
		{
			if (!strcmp(ord,s.c_str()))
				break;
			pa -> getword(ord);
		}
		delete pa;
		if (*ord)
			fprintf(out,"<option>%s",s.c_str());
		else
			fprintf(out,"<option>");
	}
	pa = new cgi::Parse(slask);
	pa -> getword(slask);
	while (*slask)
	{
		if (strcmp(slask,s.c_str()))
			fprintf(out,"<option>%s",slask);
		pa -> getword(slask);
	}
	delete pa;
	fprintf(out,"</select>");
}

/*
 * create field
 */

void page_3(Database& db,db::Dbs *sdb,db::Tbls *stbl,db::Flds *sfld,db::Users *user,Cookies *cs,char *s,short ok,db::Applications *sapp)
{
	Query q(db),*qd = new Query(db);
	db::Appfields *tempaf;
	char *typenames[8] = {"",
	 "<b>string/binary column</b>",
	 "<b>integer column</b>",
	 "<b>time column</b>",
	 "<b>enum column</b>",
	 "",
	 "<b>number column</b>",
	 "<b>set column</b>"};
	long l;
	short visa_status = 0;
	char sql[200];
	char slwr[20];
	char slask[200];

	strcpy(slwr,s);	// 'create' / 'change' / 'delete'
	strlwr(slwr);

    	sprintf(slask,"%s Field",s);
    	header0(slask,1,cs);

	if (sapp && strcmp(slwr,"create"))
	{
		sprintf(sql,"select checked from apptables where appnum=%ld and tblnum=%ld",sapp -> num,stbl -> num);
		visa_status = qd -> get_count(sql);
	}

	if (sfld)
	{
		sprintf(sql,"select num from appfields where fldnum=%ld",sfld -> num);
		q.get_result(sql);
		if (q.num_rows())
			fprintf(out,"<table><tr><td align=right>Application:</td>");
		while (q.fetch_row())
		{
			tempaf = new db::Appfields(db,q.getval());
			sprintf(sql,"select name from applications where num=%ld",tempaf -> appnum);
			fprintf(out,"<th align=middle> %s </th>",qd -> get_string(sql));
			delete tempaf;
		}
		q.free_result();

		sprintf(sql,"select num from appfields where fldnum=%ld",sfld -> num);
		q.get_result(sql);
		if (q.num_rows())
			fprintf(out,"</tr><tr><td align=right>Field status:</td>");
		while (q.fetch_row())
		{
			tempaf = new db::Appfields(db,q.getval());
			if (!strncmp(tempaf -> status.c_str(),"Plan",4))
				fprintf(out,"<td bgcolor=\"#ffff80\" align=middle><font size=-1>%s</font></td>",tempaf -> status.c_str());
			else
			if (!strncmp(tempaf -> status.c_str(),"Impl",4))
				fprintf(out,"<td bgcolor=\"#80ff80\" align=middle><font size=-1>%s</font></td>",tempaf -> status.c_str());
			else // Hold
				fprintf(out,"<td bgcolor=\"#ff8080\" align=middle><font size=-1>%s</font></td>",tempaf -> status.c_str());
			delete tempaf;
		}
		if (q.num_rows())
			fprintf(out,"</tr></table>");
		q.free_result();
	}

	fprintf(out,"<table><tr><td valign=top>");
//	left_frame(db,sdb,stbl,sfld,user,cs);
	fprintf(out,"</td><td valign=top>");

//	printf("<form action=/cgi-bin/dbd/dbd method=post target=_top>");
	fprintf(out,"<form action=/cgi-bin/dbd/dbd method=post>");
	fprintf(out,"<input type=hidden name=%sfld value=1>",slwr);
	if (sfld)
		fprintf(out,"<input type=hidden name=num value=%ld>",sfld -> num);
	fprintf(out,"<table cellpadding=0 cellspacing=0><tr><td valign=top>");
	fprintf(out,"<u>Field name</u><br>&nbsp;<input type=text name=name value=\"%s\"><br>",sfld ? sfld -> name.c_str() : "");
	fprintf(out,"</td><td valign=top colspan=2>");
	fprintf(out,"<u>Description</u><br>&nbsp;<input type=text name=description size=40 value=\"%s\"><br>",
	 sfld ? sfld -> description.c_str() : "");
//	fprintf(out,"</td></tr></table>");
	fprintf(out,"</td></tr><tr><td valign=top>");
	fprintf(out,"<u>In table</u><br>&nbsp;<select name=tblnum><option value=%ld>%s",stbl -> num,stbl -> name.c_str());
	sprintf(sql,"select num,name from tbls where num<>%ld and dbnum=%ld and deleted=0",stbl -> num,sdb -> num);
	q.get_result(sql);
	while (q.fetch_row())
		fprintf(out,"<option value=%ld>%s",q.getval(0),q.getstr(1));
	q.free_result();
	fprintf(out,"</select>");

	fprintf(out,"</td><td valign=top>");
	if (visa_status)
	{
		sprintf(sql,"select num from appfields where appnum=%ld and fldnum=%ld",sapp -> num,sfld -> num);
		l = qd -> get_count(sql);
		if (!l)
		{
			tempaf = new db::Appfields(&db);
			tempaf -> appnum = sapp -> num;
			tempaf -> fldnum = sfld -> num;
			tempaf -> status = "Planned"; //strcpy(tempaf -> status,"Planned");
			tempaf -> tblnum = stbl -> num;
			tempaf -> save();
		}
		else
		{
			tempaf = new db::Appfields(db,l);
		}

		fprintf(out,"<u>Status (%s)</u><br>&nbsp;<select name=status><option>%s",sapp -> name.c_str(),tempaf -> status.c_str());
		if (strcmp(tempaf -> status.c_str(),"Planned"))
			fprintf(out,"<option>Planned");
		if (strcmp(tempaf -> status.c_str(),"Implemented"))
			fprintf(out,"<option>Implemented");
		if (strcmp(tempaf -> status.c_str(),"Hold"))
			fprintf(out,"<option>Hold");
		fprintf(out,"</select>");

		delete tempaf;
	} // if (visa_status)
	fprintf(out,"</td><td valign=bottom>");
	fprintf(out,"<input type=submit name=submit value=\" %s \">",s);
	fprintf(out,"</td></tr></table>");


// Database field types:
//  o 1) Char (number of chars [xxx])
//  o 2) Integer (number of digits [xxx] - default 11)
//     		[minvalue]  [maxvalue]	(no values: minvalue=0, maxvalue=-1)
//  o 3) Datetime
//  o 4) Enum field
//     		[options]
//  o 5) Ptr to other table (integer ptr to primary key)
//     		[table]
//  o 6) NUMBER
//  o 7) SET

// fieldtype 1-char,2-int,3-datetime,4-enum/options,5-ptr,6-number,7-set
// * fieldstr - type string (var/varchar etc)
// * fieldflags - bit 0 NULL, bit 1...
// charlength
// integerlength
// * decimallength
// minvalue
// maxvalue
// options
// ptrtotable

//	printf("<br>");
//	printf("<br>");

	fprintf(out,"<u>Field type</u><br>");

	fprintf(out,"<table cellpadding=\"0\" cellspacing=\"0\" width=\"100%%\">");
	if (sfld)	// edit field
	{
	// 1: char
		fprintf(out,"<tr bgcolor=\"#ffffe0\"><td valign=top>");
		fprintf(out,"<input type=radio name=fieldtype value=101%s></td><td valign=top>CHAR\n",
		 (sfld -> fieldtype == 1 && !strcmp(sfld -> fieldstr.c_str(),"CHAR")) ? " CHECKED" : "");
		fprintf(out,"<input type=radio name=fieldtype value=102%s>VARCHAR\n",
		 (sfld -> fieldtype == 1 && !strcmp(sfld -> fieldstr.c_str(),"VARCHAR")) ? " CHECKED" : "");
		fprintf(out,"(number of characters <input type=text name=charlength size=4 value=%ld> max 255",
		 sfld -> charlength);
		fprintf(out,"<input type=checkbox name=cvc_binary value=1%s>Binary)<br>",((sfld -> fieldflags & FF_BINARY) != 0) ? " CHECKED" : "");
		fprintf(out,"</td></tr>");
		// text / blob
		fprintf(out,"<tr><td valign=top>");
		fprintf(out,"<input type=radio name=fieldtype value=1%s></td><td valign=top>%s\n",
		 (sfld -> fieldtype == 1 && strcmp(sfld -> fieldstr.c_str(),"CHAR") && strcmp(sfld -> fieldstr.c_str(),"VARCHAR") ) ? " CHECKED" : "",typenames[1]);
		fieldselect(1,sfld -> fieldstr.c_str());
		fprintf(out,"</td></tr>");

	// 2: int
		fprintf(out,"<tr bgcolor=\"#ffffe0\"><td valign=top>");
		fprintf(out,"<input type=radio name=fieldtype value=2%s></td><td valign=top>%s\n",
		 (sfld -> fieldtype == 2) ? " CHECKED" : "",typenames[2]);
		fieldselect(2,sfld -> fieldstr.c_str());
		fprintf(out,"(number of digits <input type=text name=integerlength size=4 value=%ld> - default 11)<br>",
		 sfld -> integerlength);
		if (sfld -> minvalue > sfld -> maxvalue)
		{
			fprintf(out,"Integer min. value <input type=text name=minvalue size=12>\n");
			fprintf(out,"Integer max. value <input type=text name=maxvalue size=12><br>");
		}
		else
		{
			fprintf(out,"Integer min. value <input type=text name=minvalue size=12 value=%ld>\n",
			 sfld -> minvalue);
			fprintf(out,"Integer max. value <input type=text name=maxvalue size=12 value=%ld><br>",
			 sfld -> maxvalue);
		}
		fprintf(out,"<input type=checkbox name=autoincr value=1%s>Auto increment&nbsp;\n",((sfld -> fieldflags & FF_AUTO_INCREMENT) != 0) ? " CHECKED" : "");
		fprintf(out,"<input type=checkbox name=int_uns value=1%s>Unsigned&nbsp;\n",(sfld -> fieldtype == 2 && (sfld -> fieldflags & FF_UNSIGNED) != 0) ? " CHECKED" : "");
		fprintf(out,"<input type=checkbox name=int_zf value=1%s>Zerofill&nbsp;\n",((sfld -> fieldtype == 2 && sfld -> fieldflags & FF_ZEROFILL) != 0) ? " CHECKED" : "");
		fprintf(out,"</td></tr>");

	// 6: number
		fprintf(out,"<tr><td valign=top>");
		fprintf(out,"<input type=radio name=fieldtype value=6%s></td><td valign=top>%s\n",
		 (sfld -> fieldtype == 6) ? " CHECKED" : "",typenames[6]);
		fieldselect(6,sfld -> fieldstr.c_str());
		fprintf(out,"( <input type=text name=numberlength size=4 value=%ld> . <input type=text name=decimallength size=4 value=%ld> )\n",
		 sfld -> integerlength,sfld -> decimallength);
		fprintf(out,"<br>");
		fprintf(out,"<input type=checkbox name=num_uns value=1%s>Unsigned&nbsp;\n",(sfld -> fieldtype == 6 && (sfld -> fieldflags & FF_UNSIGNED) != 0) ? " CHECKED" : "");
		fprintf(out,"<input type=checkbox name=num_zf value=1%s>Zerofill&nbsp;\n",(sfld -> fieldtype == 6 && (sfld -> fieldflags & FF_ZEROFILL) != 0) ? " CHECKED" : "");
		fprintf(out,"</td></tr>");

	// 3: datetime
		fprintf(out,"<tr bgcolor=\"#ffffe0\"><td valign=top>");
		fprintf(out,"<input type=radio name=fieldtype value=3%s></td><td valign=top>%s\n",
		 (sfld -> fieldtype == 3) ? " CHECKED" : "",typenames[3]);
		fieldselect(3,sfld -> fieldstr.c_str());
		fprintf(out,"<br>");
		fprintf(out,"</td></tr>");

	// 4: enum
		fprintf(out,"<tr><td valign=top>");
		fprintf(out,"<input type=radio name=fieldtype value=4%s></td><td valign=top>%s (options = OPTION1 / OPTION2 / OPTION3 etc)\n",
		 (sfld -> fieldtype == 4) ? " CHECKED" : "",typenames[4]);
		fprintf(out,"<br>");
		fprintf(out,"</td></tr>");

	// 7: set
		fprintf(out,"<tr bgcolor=\"#ffffe0\"><td valign=top>");
		fprintf(out,"<input type=radio name=fieldtype value=7%s></td><td valign=top>%s\n",
		 (sfld -> fieldtype == 7) ? " CHECKED" : "",typenames[7]);
		fprintf(out,"<br>");
		fprintf(out,"<textarea name=options rows=3 cols=60 wrap=soft>\n");
		fprintf(out,"%s\n",sfld -> options.c_str());
		fprintf(out,"</textarea>\n");
		fprintf(out,"<br>");
		fprintf(out,"</td></tr>");

	// 5: ptr to table
		fprintf(out,"<tr><td valign=top>");
		fprintf(out,"<input type=radio name=fieldtype value=5%s></td><td valign=top><b>ptr</b> to other table (integer ptr to primary key)<br>",
		 (sfld -> fieldtype == 5) ? " CHECKED" : "");
		sprintf(sql,"select num,name from tbls where dbnum=%ld and deleted=0 order by name",sdb -> num);
		q.get_result(sql);
		if (q.num_rows())
		{
			fprintf(out,"<select name=ptrtotable>");
			if (sfld -> ptrtotblnum)
			{
				sprintf(sql,"select name from tbls where num=%ld",sfld -> ptrtotblnum);
				fprintf(out,"<option value=%ld>%s\n",sfld -> ptrtotblnum,qd -> get_string(sql));
			}
			else
			{
				fprintf(out,"<option value=0>\n");
			}
			while (q.fetch_row())
				if (q.getval(0) != sfld -> ptrtotblnum)
					fprintf(out,"<option value=%ld>%s\n",q.getval(0),q.getstr(1));
			if (sfld -> ptrtotblnum)
				fprintf(out,"<option value=0>\n");
			fprintf(out,"</select>\n");
		}
		else
		{
			fprintf(out,"<h3>no other tables in database</h3>\n");
			fprintf(out,"<input type=hidden name=ptrtotable value=0>\n");
		}
		q.free_result();
		fprintf(out,"<br>");
		fprintf(out,"</td></tr>");

	}
	else		// new field
	{
	// 1: char
		fprintf(out,"<tr bgcolor=\"#ffffe0\"><td valign=top>");
		fprintf(out,"<input type=radio name=fieldtype value=101></td><td valign=top>CHAR\n");
		fprintf(out,"<input type=radio name=fieldtype value=102 CHECKED>VARCHAR\n");
		fprintf(out,"(number of characters <input type=text name=charlength size=4>");
		fprintf(out,"<input type=checkbox name=cvc_binary value=1>Binary)<br>");
		fprintf(out,"</td></tr>");
		fprintf(out,"<tr><td valign=top>");
		fprintf(out,"<input type=radio name=fieldtype value=1></td><td valign=top>%s\n",typenames[1]);
		fieldselect(1,"");
		fprintf(out,"</td></tr>");

	// 2: int
		fprintf(out,"<tr bgcolor=\"#ffffe0\"><td valign=top>");
		fprintf(out,"<input type=radio name=fieldtype value=2></td><td valign=top>%s\n",typenames[2]);
		fieldselect(2,"");
		fprintf(out,"(number of digits <input type=text name=integerlength size=4 value=11> - default 11)<br>");
		fprintf(out,"Integer min. value <input type=text name=minvalue size=12>\n");
		fprintf(out,"Integer max. value <input type=text name=maxvalue size=12><br>");
		fprintf(out,"<input type=checkbox name=autoincr value=1>Auto increment&nbsp;\n");
		fprintf(out,"<input type=checkbox name=int_uns value=1>Unsigned&nbsp;\n");
		fprintf(out,"<input type=checkbox name=int_zf value=1>Zerofill&nbsp;\n");
		fprintf(out,"</td></tr>");

	// 6: number
		fprintf(out,"<tr><td valign=top>");
		fprintf(out,"<input type=radio name=fieldtype value=6></td><td valign=top>%s\n",typenames[6]);
		fieldselect(6,"");
		fprintf(out,"( <input type=text name=numberlength size=4> . <input type=text name=decimallength size=4> )\n");
		fprintf(out,"<br>");
		fprintf(out,"<input type=checkbox name=num_uns value=1>Unsigned&nbsp;\n");
		fprintf(out,"<input type=checkbox name=num_zf value=1>Zerofill&nbsp;\n");
		fprintf(out,"</td></tr>");

	// 3: datetime
		fprintf(out,"<tr bgcolor=\"#ffffe0\"><td valign=top>");
		fprintf(out,"<input type=radio name=fieldtype value=3></td><td valign=top>%s\n",typenames[3]);
		fieldselect(3,"");
		fprintf(out,"<br>");
		fprintf(out,"</td></tr>");

	// 4: enum
		fprintf(out,"<tr><td valign=top>");
		fprintf(out,"<input type=radio name=fieldtype value=4></td><td valign=top>%s (options = OPTION1 / OPTION2 / OPTION3 etc)\n",typenames[4]);
		fprintf(out,"<br>");
		fprintf(out,"</td></tr>");

	// 7: set
		fprintf(out,"<tr bgcolor=\"#ffffe0\"><td valign=top>");
		fprintf(out,"<input type=radio name=fieldtype value=7></td><td valign=top>%s\n",typenames[7]);
		fprintf(out,"<br>");
		fprintf(out,"<textarea name=options rows=3 cols=60 wrap=soft>\n");
		fprintf(out,"</textarea>\n");
		fprintf(out,"<br>");
		fprintf(out,"</td></tr>");

	// 5: ptr to table
		fprintf(out,"<tr><td valign=top>");
		fprintf(out,"<input type=radio name=fieldtype value=5></td><td valign=top><b>ptr</b> to other table (integer ptr to primary key)<br>");
		sprintf(sql,"select num,name from tbls where dbnum=%ld and deleted=0 order by name",sdb -> num);
		q.get_result(sql);
		if (q.num_rows())
		{
			fprintf(out,"<select name=ptrtotable>");
			if (sfld && sfld -> ptrtotblnum)
			{
				sprintf(sql,"select name from tbls where num=%ld",sfld -> ptrtotblnum);
				fprintf(out,"<option value=%ld>%s\n",sfld -> ptrtotblnum,qd -> get_string(sql));
			}
			else
			{
				fprintf(out,"<option value=0>\n");
			}
			while (q.fetch_row())
				if (!sfld || q.getval(0) != sfld -> ptrtotblnum)
					fprintf(out,"<option value=%ld>%s\n",q.getval(0),q.getstr(1));
			if (sfld && sfld -> ptrtotblnum)
				fprintf(out,"<option value=0>\n");
			fprintf(out,"</select>\n");
		}
		else
		{
			fprintf(out,"<h3>no other tables in database</h3>\n");
			fprintf(out,"<input type=hidden name=ptrtotable value=0>\n");
		}
		q.free_result();
		fprintf(out,"<br>");
		fprintf(out,"</td></tr>");

	}
//	fprintf(out,"<br>");

	fprintf(out,"<tr bgcolor=\"#ffffe0\"><td colspan=2>");
	fprintf(out,"<u>Default value</u><br>&nbsp;<input type=text name=defaultvalue size=40 value=\"%s\"><br>",sfld ? sfld -> defaultvalue.c_str() : "");

	fprintf(out,"<input type=checkbox name=nullok value=1%s>Allow NULL<br>",sfld ? ((sfld && ((sfld -> fieldflags & FF_ALLOWNULL) != 0)) ? " CHECKED" : "") : "");
	fprintf(out,"</td></tr>");
	fprintf(out,"</table>");

	fprintf(out,"<u>Comment</u><br>");
	fprintf(out,"&nbsp;<textarea name=kommentar rows=8 cols=60 wrap=soft>\n");
	fprintf(out,"</textarea>\n");
	if (!ok && !strcmp(s,"Create"))
		fprintf(out,"<h3>Field will not be created - user limit reached</h3>\n");
	fprintf(out,"<table><tr><td valign=top>");
	fprintf(out,"<input type=submit name=submit value=\" %s \">\n",s);
	fprintf(out,"</form>\n");
	fprintf(out,"<form action=/cgi-bin/dbd/dbd method=post>\n");
//	fprintf(out,"<input type=hidden name=selfld value=0>\n");
	fprintf(out,"</td><td valign=top>");
	fprintf(out,"<input type=submit name=submit value=\" Cancel \">\n");
	fprintf(out,"</td></tr></table>");
	fprintf(out,"</form>\n");

	fprintf(out,"</td></tr></table>");
    	footer();
    
    	delete qd;
}


/*
 * create index
 */

void page_4(Database& db,db::Dbs *sdb,db::Tbls *stbl,db::Indexs *sindex,db::Users *user,Cookies *cs,char *s,short ok)
{
	Query q(db),*qd = new Query(db);
	db::Indexlist *il;
	db::Flds *tempfld;
	long l;
	int j;
	char sql[200];
	char slwr[20];
	char slask[200];

	strcpy(slwr,s);	// 'create' / 'change' / 'delete'
	strlwr(slwr);

    	sprintf(slask,"%s Index",s);
    	header0(slask,1,cs);

	fprintf(out,"<table><tr><td valign=top>");
	fprintf(out,"</td><td valign=top>\n");

//	fprintf(out,"<form action=/cgi-bin/dbd/dbd method=post target=_top>\n");
	fprintf(out,"<form action=/cgi-bin/dbd/dbd method=post>\n");
	fprintf(out,"<input type=hidden name=%sindex value=1>\n",slwr);
	if (sindex)
		fprintf(out,"<input type=hidden name=num value=%ld>",sindex -> num);
	fprintf(out,"<table cellpadding=0 cellspacing=0><tr><td valign=top>");
	fprintf(out,"Index name<br><input type=text name=name value=\"%s\"><br>",sindex ? sindex -> name.c_str() : "");
	fprintf(out,"</td><td valign=top>");
	fprintf(out,"Description<br><input type=text name=description size=40 value=\"%s\"><br>",
	 sindex ? sindex -> description.c_str() : "");
	fprintf(out,"</td></tr></table>");
	fprintf(out,"<input type=hidden name=tblnum value=%ld>\n",stbl -> num);
	fprintf(out,"Index type<br>");
	if (sindex)
	{
		fprintf(out,"<select name=typ><option>%s\n",sindex -> typ.c_str());
		if (strcmp(sindex -> typ.c_str(),"INDEX"))
			fprintf(out,"<option>INDEX\n");
		if (strcmp(sindex -> typ.c_str(),"PRIMARY"))
			fprintf(out,"<option>PRIMARY\n");
		if (strcmp(sindex -> typ.c_str(),"UNIQUE"))
			fprintf(out,"<option>UNIQUE\n");
		if (strcmp(sindex -> typ.c_str(),"FULLTEXT"))
			fprintf(out,"<option>FULLTEXT\n");
	}
	else
	{
		fprintf(out,"<select name=typ><option>INDEX\n");
		fprintf(out,"<option>PRIMARY\n");
		fprintf(out,"<option>UNIQUE\n");
		fprintf(out,"<option>FULLTEXT\n");
	}
	fprintf(out,"</select>\n");
	fprintf(out,"<br>");

	if (!sindex)
	{
		fprintf(out,"<table><tr><td valign=top>");
		fprintf(out,"Field<br><select name=fldnum>\n");
		sprintf(sql,"select num,name from flds where tblnum=%ld and deleted=0 order by ordning",stbl -> num);
		q.get_result(sql);
		while (q.fetch_row())
			fprintf(out,"<option value=%ld>%s\n",q.getval(0),q.getstr(1));
		q.free_result();
		fprintf(out,"</select>\n");
		fprintf(out,"</td><td valign=top>");
		fprintf(out,"Length<br><input type=text name=length size=4>\n");
		fprintf(out,"</td></tr></table>");
	}

	fprintf(out,"Comment<br>");
	fprintf(out,"<textarea name=kommentar rows=8 cols=60 wrap=soft>\n");
	fprintf(out,"</textarea>\n");
	if (!ok && !strcmp(s,"Create"))
		fprintf(out,"<h3>Index will not be created - user limit reached</h3>\n");
	fprintf(out,"<table><tr><td valign=top>");
	fprintf(out,"<input type=submit name=submit value=\" %s \">\n",s);
	fprintf(out,"</form>\n");
	fprintf(out,"<form action=/cgi-bin/dbd/dbd method=post>\n");
//	fprintf(out,"<input type=hidden name=selindex value=0>\n");
	fprintf(out,"</td><td valign=top>");
	fprintf(out,"<input type=submit name=submit value=\" Cancel \">\n");
	fprintf(out,"</td></tr></table>");

	if (sindex)
	{
		fprintf(out,"<br>");
		fprintf(out,"<h3>Fields in index</h3>\n");

		fprintf(out,"<table>");
		fprintf(out,"<tr><th bgcolor=\"#e0e0e0\"> Field </th>");
		fprintf(out,"<th bgcolor=\"#e0e0e0\"> Type </th>\n");
		fprintf(out,"<th bgcolor=\"#e0e0e0\"> Length </th>\n");
		fprintf(out,"<th bgcolor=\"#e0e0e0\"> Delete </th>\n");
		fprintf(out,"<th bgcolor=\"#e0e0e0\"> Change </th>\n");
		fprintf(out,"</tr>");
		sprintf(sql,"select num from indexlist where indexnum=%ld",sindex -> num);
		q.get_result(sql);
		l = q.num_rows();	// antal flds i index
		while (q.fetch_row())
		{
			fprintf(out,"<tr>");
			il = new db::Indexlist(db,q.getval());
			tempfld = new db::Flds(db,il -> fldnum);
			sprintf(sql,"select name from flds where num=%ld",il -> fldnum);
			strcpy(slask,qd -> get_string(sql));
			fprintf(out,"<td class=tab>%s</td>",slask);

				// type string
				fprintf(out,"<td class=tab>");
				if (tempfld -> fieldtype == 4)
					fprintf(out,"ENUM ...</td>");
				else
				if (tempfld -> fieldtype == 7)
					fprintf(out,"SET ...</td>");
				else
				if (tempfld -> fieldtype == 5)
					fprintf(out,"ptr to table</td>");
				else
				{
					strcpy(slask,typestring(tempfld));
					for (j = 1; j < (int)strlen(slask); j++)
						if (slask[j] == ' ')
							slask[j] = 0;
					fprintf(out,"%s</td>",slask);
				}

			if (il -> length == -1)
				fprintf(out,"<td class=tab><input type=text name=length%ld size=4></td>",il -> num);
			else
				fprintf(out,"<td class=tab><input type=text name=length%ld value=%ld size=4></td>",il -> num,il -> length);
			if (l > 1)
				fprintf(out,"<td class=tab><input type=submit name=delete%ld value=\" Delete \"></td>",il -> num);
			else
				fprintf(out,"<td class=tab></td>");
			fprintf(out,"<td class=tab><input type=submit name=change%ld value=\" Change \"></td>",il -> num);
			delete tempfld;
			delete il;
			fprintf(out,"</tr>");
		}
		q.free_result();
		fprintf(out,"</table>");

	// add field
		fprintf(out,"<br>");
		fprintf(out,"<h3>Add field</h3>\n");

		fprintf(out,"<table><tr><td valign=top>");
		fprintf(out,"Field<br><select name=fldnum>\n");
		sprintf(sql,"select num,name from flds where tblnum=%ld and deleted=0 order by ordning",stbl -> num);
		q.get_result(sql);
		while (q.fetch_row())
		{
			sprintf(sql,"select num from indexlist where indexnum=%ld and fldnum=%ld",sindex -> num,q.getval(0));
			if (!qd -> get_count(sql))
				fprintf(out,"<option value=%ld>%s\n",q.getval(0),q.getstr(1));
		}
		q.free_result();
		fprintf(out,"</select>\n");
		fprintf(out,"</td><td valign=top>");
		fprintf(out,"Length<br><input type=text name=length size=4>\n");
		fprintf(out,"</td><td>");
		fprintf(out,"Add<br><input type=submit name=add value=\" Add \">\n");
		fprintf(out,"</td>");
		fprintf(out,"</tr></table>");
	}
	else
	{
	}

	fprintf(out,"</form>\n");

	fprintf(out,"</td></tr></table>");
    	footer();
    
    	delete qd;
}


/*
 * create app
 */

void page_5(Database& db,db::Dbs *sdb,db::Applications *sapp,db::Users *user,Cookies *cs,char *s,short ok)
{
	Query q(db),q2(db);
	db::Dbs *tempdb;
	char slwr[20];
	char slask[200];
	char sql[200];

	strcpy(slwr,s);	// 'create' / 'change' / 'delete'
	strlwr(slwr);

    	sprintf(slask,"%s Application",s);
    	header0(slask,1,cs);

	fprintf(out,"<table><tr><td valign=top>");
//	left_frame(db,sdb,stbl,sfld,user,cs);
	fprintf(out,"</td><td valign=top>\n");

	fprintf(out,"<form action=/cgi-bin/dbd/dbd method=post target=_top>\n");
//	fprintf(out,"<form action=/cgi-bin/dbd/dbd method=post>\n");
	fprintf(out,"<input type=hidden name=%sapp value=1>\n",slwr);
	if (sapp)
		fprintf(out,"<input type=hidden name=num value=%ld>",sapp -> num);
	fprintf(out,"<table cellpadding=0 cellspacing=0><tr><td valign=top>");
	fprintf(out,"Application name<br><input type=text name=name value=\"%s\"><br>",sapp ? sapp -> name.c_str() : "");
	fprintf(out,"</td><td valign=top>");
	fprintf(out,"Description<br><input type=text name=description size=40 value=\"%s\"><br>",
	 sapp ? sapp -> description.c_str() : "");
	fprintf(out,"</td></tr></table>");
	fprintf(out,"In database<br><select name=dbnum><option value=%ld>%s\n",sdb -> num,sdb -> name.c_str());

	// select database
	sprintf(sql,"select dbnum from access where usernum=%ld and c<>0 and dbnum<>%ld",user -> num,sdb -> num);
	q.get_result(sql);
	while (q.fetch_row())
	{
		tempdb = new db::Dbs(db,q.getval());
		if (!tempdb -> deleted)
			fprintf(out,"<option value=%ld>%s\n",tempdb -> num,tempdb -> name.c_str());
		delete tempdb;
	}
	q.free_result();
	fprintf(out,"</select><br>");

	fprintf(out,"Comment<br>");
	fprintf(out,"<textarea name=kommentar rows=8 cols=60 wrap=soft>\n");
	fprintf(out,"</textarea>\n");
	if (!ok && !strcmp(s,"Create"))
		fprintf(out,"<h3>Application will not be created - user limit reached</h3>\n");
	fprintf(out,"<table><tr><td valign=top>");
	fprintf(out,"<input type=submit name=submit value=\" %s \">\n",s);
	fprintf(out,"</form>\n");
	fprintf(out,"<form action=/cgi-bin/dbd/dbd method=post>\n");
	fprintf(out,"</td><td valign=top>");
	fprintf(out,"<input type=submit name=submit value=\" Cancel \">\n");
	fprintf(out,"</td></tr></table>");
	fprintf(out,"</form>\n");

	fprintf(out,"</td></tr></table>");
    	footer();
}


/*
 * login
 */

void page_4(char *handle)
{
	nullheader("Login",0);
	fprintf(out,"<hr>\n");
	fprintf(out,"<form action=/cgi-bin/dbd/dbd method=post>\n");
	fprintf(out,"Login<br><input type=text name=handle value=\"%s\"><br>",handle);
	fprintf(out,"Password<br><input type=password name=password><br>");
	fprintf(out,"<input type=submit name=submit value=\" Log in \">\n");
	fprintf(out,"</form>\n");
	fprintf(out,"<br>");
	fprintf(out,"[\n");
	fprintf(out,"<a href=\"/\">Home</a>\n|\n");
	fprintf(out,"<a href=\"/cgi-bin/dbd/dbd?createuser=0\">Create a new user</a> ]<br>");
//	footer();
	fprintf(out,"<br><br>Please send bug reports to <a href=\"mailto:grymse@alhem.net\">Grymse</a>.\n");
//	fprintf(out,"If you have a problem, please make sure that Grymse has access to your database.\n");
	fprintf(out,"</body></html>\n");
}

/*
 * create a new user
 */

void page_17(char *handle)
{
	nullheader("Create a new user",0);
	fprintf(out,"<hr>\n");
	fprintf(out,"<form action=/cgi-bin/dbd/dbd method=post>\n");
	fprintf(out,"<input type=hidden name=createuser value=1>\n");
	fprintf(out,"Your name / handle (optional)<br><input type=text name=name><br>");
	fprintf(out,"New Login *<br><input type=text name=handle value=\"%s\"><br>",handle);
	fprintf(out,"Password *<br><input type=password name=password><br>");
	fprintf(out,"Repeat password *<br><input type=password name=password2><br>");
	fprintf(out,"Your Email (optional)<br><input type=text name=email><br>");
	fprintf(out,"Your ICQ# (optional)<br><input type=text name=icq><br>");
	fprintf(out,"&nbsp;&nbsp;&nbsp;*) Required<br>\n");
	fprintf(out,"<table><tr><td valign=top>");
	fprintf(out,"<input type=submit name=submit value=\" Create user \">\n");
	fprintf(out,"</form>\n");
	fprintf(out,"<form action=/cgi-bin/dbd/dbd method=post>\n");
	fprintf(out,"</td><td valign=top>");
	fprintf(out,"<input type=submit name=submit value=\" Cancel \">\n");
	fprintf(out,"</td></tr></table>");
	fprintf(out,"</form>\n");
//	footer();
	fprintf(out,"<br><br>Please send bug reports to <a href=\"mailto:grymse@alhem.net\">Grymse</a>.\n");
//	fprintf(out,"If you have a problem, please make sure that Grymse has access to your database.\n");
	fprintf(out,"</body></html>\n");
}


/*
 * page_18(): update personal info
 */

void page_18(Database& db,db::Dbs *sdb,db::Tbls *stbl,db::Flds *sfld,db::Users *user,Cookies *cs)
{
	Query *qd = new Query(db);
	Query q(db);
	db::Users *tempuser;
	long qdb,qtbl,qfld,qindex,qapp;
	long usernum = user -> num;
	char sql[200];
	char slask[200];

	header0("User info",3,cs);
	fprintf(out,"<table><tr><td valign=top>");
//	left_frame(db,sdb,stbl,sfld,user,cs);
	fprintf(out,"</td><td valign=top>\n");

	fprintf(out,"<form action=/cgi-bin/dbd/dbd method=post>\n");

	if (user -> superuser)
	{
		if (cs -> getvalue("valduser",slask,20) && *slask)
			usernum = atol(slask);
		sprintf(sql,"select name from users where num=%ld",usernum);
		fprintf(out,"<select name=valduser><option value=%ld>%s\n",usernum,qd -> get_string(sql));
		sprintf(sql,"select num,name from users where num<>%ld",usernum);
		q.get_result(sql);
		while (q.fetch_row())
			fprintf(out,"<option value=%ld>%s\n",q.getval(0),q.getstr(1));
		q.free_result();
		fprintf(out,"</select>\n");
		fprintf(out,"<input type=submit name=valjuser value=\" Select \"><br>");
	}
	tempuser = new db::Users(db,usernum);
	fprintf(out,"<input type=hidden name=ui value=1>\n");
	fprintf(out,"<input type=hidden name=usernum value=%ld>\n",usernum);

	sprintf(sql,"select count(*) from dbs where owner=%ld and deleted=0",usernum);
	qdb = qd -> get_count(sql);
	sprintf(sql,"select count(*) from tbls where owner=%ld and deleted=0",usernum);
	qtbl = qd -> get_count(sql);
	sprintf(sql,"select count(*) from flds where owner=%ld and deleted=0",usernum);
	qfld = qd -> get_count(sql);
	sprintf(sql,"select count(*) from indexs where owner=%ld and deleted=0",usernum);
	qindex = qd -> get_count(sql);
	sprintf(sql,"select count(*) from applications where owner=%ld and deleted=0",usernum);
	qapp = qd -> get_count(sql);

	fprintf(out,"<h3>Personal info</h3>\n");
	fprintf(out,"<center><table width=\"95%%\">");

	// OBS! tempuser->.... inte user->....
	fprintf(out,"<tr><td>Your login</td><td><b>%s</b></td></tr>",tempuser -> handle.c_str());
	fprintf(out,"<tr><td>Name</td><td><input type=text name=name size=40 value=\"%s\"></td></tr>",tempuser -> name.c_str());
	fprintf(out,"<tr><td>Old password</td><td><input type=password name=oldpassword></td></tr>");
	fprintf(out,"<tr><td>New password</td><td><input type=password name=newpassword></td></tr>");
	fprintf(out,"<tr><td>Repeat password</td><td><input type=password name=repeatpassword></td></tr>");
	fprintf(out,"<tr><td>Email</td><td><input type=text name=email size=40 value=\"%s\"></td></tr>",tempuser -> email.c_str());
	fprintf(out,"<tr><td>ICQ#</td><td><input type=text name=icq value=\"%s\"></td></tr>",tempuser -> icq.c_str());
	if (user -> superuser)
	{
		fprintf(out,"<tr><td>Max databases</td><td><input type=text name=maxdbs size=10 value=%ld></td></tr>",tempuser -> maxdbs);
		fprintf(out,"<tr><td>Max tables</td><td><input type=text name=maxtbls size=10 value=%ld></td></tr>",tempuser -> maxtbls);
		fprintf(out,"<tr><td>Max fields</td><td><input type=text name=maxflds size=10 value=%ld></td></tr>",tempuser -> maxflds);
		fprintf(out,"<tr><td>Max indexes</td><td><input type=text name=maxindexs size=10 value=%ld></td></tr>",tempuser -> maxindexs);
		fprintf(out,"<tr><td>Max applications</td><td><input type=text name=maxapps size=10 value=%ld></td></tr>",tempuser -> maxapps);
	}
	fprintf(out,"<tr><td>Autocreate \"num\" field</td><td><input type=checkbox name=flag0%s value=1></td></tr>",(tempuser -> flags & UF_AUTOCREATENUM) ? " CHECKED" : "");
//	fprintf(out,"<tr><td>Show linked tables</td><td><input type=checkbox name=flag1%s value=1></td></tr>",(tempuser -> flags & UF_SHOWLINKED) ? " CHECKED" : "");
	fprintf(out,"<tr><td>Lines of data to show</td><td><input type=text name=steps size=10 value=%ld></td></tr>",tempuser -> steps);
	fprintf(out,"<tr><td>Line cutoff length</td><td><input type=text name=cutoff size=10 value=%ld></td></tr>",tempuser -> cutoff);
	fprintf(out,"</table></center>\n");

	fprintf(out,"<table><tr><td valign=top>");
	fprintf(out,"<input type=submit name=submit value=\" Update personal info \">\n");
	fprintf(out,"</td><td valign=top>\n");
	fprintf(out,"<input type=submit name=submit value=\" Cancel \">\n");
	fprintf(out,"</td></tr></table>");

	fprintf(out,"</form>\n");

	fprintf(out,"<h3>Account info</h3>\n");
	fprintf(out,"<center><table width=\"95%%\">");
	fprintf(out,"<tr><td>Databases</td>");
	fprintf(out,"<td align=right>%ld</td>",qdb);
	fprintf(out,"<td>/</td>");
	fprintf(out,"<td align=right>%ld</td>",tempuser -> maxdbs);
	fprintf(out,"</tr>");
	fprintf(out,"<tr><td>Tables</td>");
	fprintf(out,"<td align=right>%ld</td>",qtbl);
	fprintf(out,"<td>/</td>");
	fprintf(out,"<td align=right>%ld</td>",tempuser -> maxtbls);
	fprintf(out,"</tr>");
	fprintf(out,"<tr><td>Fields</td>");
	fprintf(out,"<td align=right>%ld</td>",qfld);
	fprintf(out,"<td>/</td>");
	fprintf(out,"<td align=right>%ld</td>",tempuser -> maxflds);
	fprintf(out,"</tr>");
	fprintf(out,"<tr><td>Indexes</td>");
	fprintf(out,"<td align=right>%ld</td>",qindex);
	fprintf(out,"<td>/</td>");
	fprintf(out,"<td align=right>%ld</td>",tempuser -> maxindexs);
	fprintf(out,"</tr>");
	fprintf(out,"<tr><td>Applications</td>");
	fprintf(out,"<td align=right>%ld</td>",qapp);
	fprintf(out,"<td>/</td>");
	fprintf(out,"<td align=right>%ld</td>",tempuser -> maxapps);
	fprintf(out,"</tr>");
	fprintf(out,"</table></center>\n");

	fprintf(out,"</td></tr></table>");
	footer();

	delete qd;
	delete tempuser;
}

/*
 * database access
 */

void page_19(Database& db,db::Dbs *sdb,db::Tbls *stbl,db::Flds *sfld,db::Users *user,Cookies *cs)
{
	Query *qd = new Query(db);
	Query q(db),q2(db);
	db::Dbs *tempdb;
	db::Users *tempuser;
	db::Access *a;
	long dbnum;
	long l;
	char sql[200];

	header0("Database access",2,cs);
	fprintf(out,"<table><tr><td valign=top>");
//	left_frame(db,sdb,stbl,sfld,user,cs);
//	fprintf(out,"</td><td valign=top>\n");

	fprintf(out,"<h3>Your databases</h3>\n");
	fprintf(out,"<table>");
//	sprintf(sql,"select num from dbs where owner=%ld and deleted=0 order by name",user -> num);
//	q.get_result(sql);
//	while (q.fetch_row())
  if (sdb)
	{
		dbnum = sdb -> num; //q.getval();
		tempdb = new db::Dbs(db,dbnum);
		fprintf(out,"<tr>");
		fprintf(out,"<td valign=top><b>%s</b></td>",tempdb -> name.c_str());

// dba=0 view page
// dba=1 add usernum,dbnum to access
// dba=2 change access for usernum,dbnum
// dba=3 remove usernum,dbnum from access

		// add users here
		fprintf(out,"<td valign=top align=right>");
		fprintf(out,"<form action=/cgi-bin/dbd/dbd method=post>\n");
		fprintf(out,"<input type=hidden name=dba value=1>\n");
		fprintf(out,"<input type=hidden name=dbnum value=%ld>\n",dbnum);
		fprintf(out,"<select name=usernum><option value=0>&lt;select user&gt;\n");
		sprintf(sql,"select num,name from users where num<>%ld order by name",user -> num);
		q2.get_result(sql);
		while (q2.fetch_row())
		{
			l = q2.getval();
			sprintf(sql,"select num from access where usernum=%ld and dbnum=%ld",l,dbnum);
			if (!qd -> get_count(sql))
				fprintf(out,"<option value=%ld>%s\n",l,q2.getstr(1));
		}
		q2.free_result();
		fprintf(out,"</select>");
		fprintf(out,"</td>");
		fprintf(out,"<td valign=top>");
		fprintf(out,"<input type=submit name=submit value=\" Add access for user \">\n");
		fprintf(out,"</form>\n");
		fprintf(out,"</td>");

		sprintf(sql,"select num from access where dbnum=%ld and usernum<>%ld",dbnum,user -> num);
		q2.get_result(sql);
		while (q2.fetch_row())
		{
			a = new db::Access(db,q2.getval());
			tempuser = new db::Users(db,a -> usernum);
			fprintf(out,"<tr>");
			fprintf(out,"<td valign=top>");
			showuser(tempuser);
			fprintf(out,"</td>");
			fprintf(out,"<td valign=top>");
			fprintf(out,"<form action=/cgi-bin/dbd/dbd method=post>");
			fprintf(out,"<input type=hidden name=dba value=2>\n");
			fprintf(out,"<input type=hidden name=usernum value=%ld>\n",tempuser -> num);
			fprintf(out,"<input type=hidden name=dbnum value=%ld>\n",dbnum);
			fprintf(out,"<input type=checkbox name=r%s value=1>Copy\n",a -> r ? " CHECKED" : "");
			fprintf(out,"<input type=checkbox name=w%s value=1>Edit\n",a -> w ? " CHECKED" : "");
			fprintf(out,"<input type=checkbox name=c%s value=1>Create\n",a -> c ? " CHECKED" : "");
			fprintf(out,"<input type=checkbox name=d%s value=1>Delete\n",a -> d ? " CHECKED" : "");
			fprintf(out,"<input type=checkbox name=rdata%s value=1>Edit data\n",a -> rdata ? " CHECKED" : "");
			fprintf(out,"<input type=checkbox name=wdata%s value=1>Change data\n",a -> wdata ? " CHECKED" : "");
			fprintf(out,"</td><td valign=top align=middle>");
			fprintf(out,"<input type=submit name=submit value=\" Change access \">\n");
			fprintf(out,"</form>\n");
			fprintf(out,"</td>");

			// remove user here
			fprintf(out,"<td valign=top>");
			fprintf(out,"[<a href=\"/cgi-bin/dbd/dbd?usernum=%ld&dbnum=%ld&dba=3\">remove</a>]",tempuser -> num,dbnum);
			fprintf(out,"</td>");

			fprintf(out,"</tr>");
			delete tempuser;
			delete a;
		}
		q2.free_result();
		delete tempdb;
		fprintf(out,"<tr><td>&nbsp;</td></tr>");
	}
//	q.free_result();
	fprintf(out,"</table>");


	fprintf(out,"<h3>Other databases</h3>\n");
	fprintf(out,"<ul>");
	sprintf(sql,"select num from access where usernum=%ld",user -> num);
	q.get_result(sql);
	if (q.num_rows())
	{
		fprintf(out,"<table><tr>\n");
		fprintf(out,"<th bgcolor=\"#e0e0e0\" align=left> Database </th>");
		fprintf(out,"<th bgcolor=\"#e0e0e0\" align=left> Owner </th>");
		fprintf(out,"<th bgcolor=\"#e0e0e0\" align=left> Your access </th>");
		fprintf(out,"</tr>");
	while (q.fetch_row())
	{
		a = new db::Access(db,q.getval());
		dbnum = a -> dbnum;
		tempdb = new db::Dbs(db,dbnum);
		if (!tempdb -> deleted && tempdb -> owner != user -> num)
		{
			fprintf(out,"<tr>");
			fprintf(out,"<td>%s</td>",tempdb -> name.c_str());
			fprintf(out,"<td>");
			showuser(db,tempdb -> owner);
			fprintf(out,"</td>");
			fprintf(out,"<td>");
			if (a -> r)
				fprintf(out," Copy ");
			if (a -> w)
				fprintf(out," Edit ");
			if (a -> c)
				fprintf(out," Create ");
			if (a -> d)
				fprintf(out," Delete ");
			if (a -> rdata)
				fprintf(out," ReadData ");
			if (a -> wdata)
				fprintf(out," ChangeData ");
			fprintf(out,"</td>");
			fprintf(out,"</tr>");
		}
		delete tempdb;
		delete a;
	}
		fprintf(out,"</table>");
	}
	q.free_result();
	fprintf(out,"</ul>\n");


	fprintf(out,"<form action=/cgi-bin/dbd/dbd method=post>\n");
	fprintf(out,"<input type=hidden name=dba value=1>\n");

	fprintf(out,"<input type=submit name=submit value=\" Cancel \">\n");
	fprintf(out,"</form>\n");

	fprintf(out,"</td></tr></table>");
	footer();

	delete qd;
}

void read_comments(Database& db,db::Dbs *sdb,db::Tbls *stbl,db::Applications *sapp,db::Flds *sfld,db::Indexs *sindex,db::Users *user,Cookies *cs)
{
	Query q(db);
	db::Kommentar *k;
	char sql[500];

	header0("Read comments",1,cs);

	fprintf(out,"<table><tr><td valign=top>");
//	left_frame(db,sdb,stbl,sfld,user,cs);
	fprintf(out,"</td><td valign=top>\n");

	if (sapp)
		fprintf(out,"<h3>Application '%s' in %s</h3>\n",sapp -> name.c_str(),sdb -> name.c_str());
	else
	if (sindex)
		fprintf(out,"<h3>Index '%s' in %s.%s</h3>\n",sindex -> name.c_str(),sdb -> name.c_str(),stbl -> name.c_str());
	else
	if (sfld)
		fprintf(out,"<h3>Field '%s' in %s.%s</h3>\n",sfld -> name.c_str(),sdb -> name.c_str(),stbl -> name.c_str());
	else
	if (stbl)
		fprintf(out,"<h3>Table '%s' in %s</h3>\n",stbl -> name.c_str(),sdb -> name.c_str());
	else
	if (sdb)
		fprintf(out,"<h3>Database '%s'</h3>\n",sdb -> name.c_str());

	fprintf(out,"<form action=/cgi-bin/dbd/dbd method=post>\n");
	fprintf(out,"<input type=submit name=submit value=\" Go back \">\n");
	fprintf(out,"</form>\n");

	fprintf(out,"<table>");
	sprintf(sql,"select num from kommentar where");
	if (sapp)
		sprintf(sql + strlen(sql)," appnum=%ld",sapp -> num);
	else
	if (sindex)
		sprintf(sql + strlen(sql)," indexnum=%ld",sindex -> num);
	else
	if (sfld)
		sprintf(sql + strlen(sql)," fldnum=%ld",sfld -> num);
	else
	if (stbl)
		sprintf(sql + strlen(sql)," tblnum=%ld",stbl -> num);
	else
	if (sdb)
		sprintf(sql + strlen(sql)," dbnum=%ld",sdb -> num);
	sprintf(sql + strlen(sql)," order by dateposted desc");
	q.get_result(sql);
	while (q.fetch_row())
	{
/*
CREATE TABLE kommentar (
  num int(11) DEFAULT '0' NOT NULL auto_increment,
  dbnum int(11) DEFAULT '0' NOT NULL,
  tblnum int(11) DEFAULT '0' NOT NULL,
  fldnum int(11) DEFAULT '0' NOT NULL,
  usernum int(11) DEFAULT '0' NOT NULL,
  dateposted datetime DEFAULT '0000-00-00 00:00:00' NOT NULL,
  reason varchar(80) DEFAULT '' NOT NULL,
  kommentar text NOT NULL,
  PRIMARY KEY (num)
);
*/
		k = new db::Kommentar(db,q.getval());
		fprintf(out,"<tr><td><b>%s\n",k -> dateposted.c_str());
		if (strcmp(k -> dateposted.c_str(),user -> prevdatum.c_str()) > 0)
			fprintf(out,"<img src=\"/image/new.gif\" alt=\"New!\">\n");
		fprintf(out,":: %s by\n",k -> reason.c_str());
		showuser(db,k -> usernum);
		fprintf(out,"</b></td></tr>");
		fprintf(out,"<tr><td>%s</td></tr>",k -> kommentar.c_str());
		delete k;
	}
	q.free_result();
	fprintf(out,"</table>");

	fprintf(out,"</td></tr></table>");
	footer();
}

void write_comment(Database& db,db::Dbs *sdb,db::Tbls *stbl,db::Applications *sapp,db::Flds *sfld,db::Indexs *sindex,db::Users *user,Cookies *cs,char *typ)
{
	header0("Write comment",1,cs);

	fprintf(out,"<table><tr><td valign=top>");
//	left_frame(db,sdb,stbl,sfld,user,cs);
	fprintf(out,"</td><td valign=top>\n");

	if (sapp)
		fprintf(out,"<h3>Application '%s' in %s</h3>\n",sapp -> name.c_str(),sdb -> name.c_str());
	else
	if (sindex)
		fprintf(out,"<h3>Index '%s' in %s.%s</h3>\n",sindex -> name.c_str(),sdb -> name.c_str(),stbl -> name.c_str());
	else
	if (sfld)
		fprintf(out,"<h3>Field '%s' in %s.%s</h3>\n",sfld -> name.c_str(),sdb -> name.c_str(),stbl -> name.c_str());
	else
	if (stbl)
		fprintf(out,"<h3>Table '%s' in %s</h3>\n",stbl -> name.c_str(),sdb -> name.c_str());
	else
	if (sdb)
		fprintf(out,"<h3>Database '%s'</h3>\n",sdb -> name.c_str());

/*
CREATE TABLE kommentar (
  num int(11) DEFAULT '0' NOT NULL auto_increment,
  dbnum int(11) DEFAULT '0' NOT NULL,
  tblnum int(11) DEFAULT '0' NOT NULL,
  fldnum int(11) DEFAULT '0' NOT NULL,
  usernum int(11) DEFAULT '0' NOT NULL,
  dateposted datetime DEFAULT '0000-00-00 00:00:00' NOT NULL,
  reason varchar(80) DEFAULT '' NOT NULL,
  kommentar text NOT NULL,
  PRIMARY KEY (num)
);
*/
	fprintf(out,"<form action=/cgi-bin/dbd/dbd method=post>\n");
	fprintf(out,"<input type=hidden name=write%s value=1>\n",typ);

	fprintf(out,"%s :: A comment by\n",datetime());
	showuser(user);
	fprintf(out,"<br>");
	fprintf(out,"<textarea name=kommentar rows=8 cols=60 wrap=soft>\n");
	fprintf(out,"</textarea>\n");

	fprintf(out,"<table><tr><td valign=top>");
	fprintf(out,"<input type=submit name=submit value=\" Post \">\n");
	fprintf(out,"</form>\n");

	fprintf(out,"</td><td valign=top>");
	fprintf(out,"<form action=/cgi-bin/dbd/dbd method=post>\n");
	fprintf(out,"<input type=submit name=submit value=\" Go back \">\n");
	fprintf(out,"</form>\n");
	fprintf(out,"</td></tr></table>");

	fprintf(out,"</td></tr></table>");
	footer();
}

void warningsync(Database& db,db::Dbs *sdb,db::Tbls *stbl,db::Flds *sfld,db::Users *user,Cookies *cs)
{
	header0("Live database sync",1,cs);

	fprintf(out,"<table><tr><td valign=top>");
//	left_frame(db,sdb,stbl,sfld,user,cs);
	fprintf(out,"</td><td valign=top>\n");

	fprintf(out,"<h3>Warning! Live sync will remove all live data from the database</h3>\n");
	fprintf(out,"<p>Only use if database is broken or unreadable - and remember to do your backups</p>\n");

	fprintf(out,"<form action=/cgi-bin/dbd/dbd method=post>\n");
	fprintf(out,"<input type=hidden name=ls value=1>\n");
	fprintf(out,"<input type=submit name=submit value=\" Live sync \">\n");
	fprintf(out,"<input type=submit name=submit value=\" Go back \">\n");
	fprintf(out,"</form>\n");

	fprintf(out,"</td></tr></table>");
	footer();
}


/*
 * Add group
 */

void page_26(Database& db,db::Users *user,db::Dbs *sdb,Cookies *cs)
{
	header0("Add group",1,cs);

	fprintf(out,"<form action=/cgi-bin/dbd/dbd method=post target=_top>\n");
	fprintf(out,"<input type=hidden name=ag value=1>\n");
	if (sdb)
	{
		fprintf(out,"Type of group<br>");
		fprintf(out,"<input type=radio name=typ value=1 CHECKED>Database group<br>");
		fprintf(out,"<input type=radio name=typ value=2>Table group in database '%s'<br>",sdb -> name.c_str());
	}
	else
	{
		fprintf(out,"<input type=hidden name=typ value=1>\n");
	}
	fprintf(out,"<br>");
	fprintf(out,"New group name<br><input type=text name=newname><br>");
	fprintf(out,"<table><tr><td valign=top>");
	fprintf(out,"<input type=submit name=submit value=\" Add new group \">\n");
	fprintf(out,"</form>\n");
	fprintf(out,"</td><td valign=top>\n");
	fprintf(out,"<form action=/cgi-bin/dbd/dbd method=post>\n");
	fprintf(out,"<input type=submit name=submit value=\" Cancel \">\n");
	fprintf(out,"</form>\n");
	fprintf(out,"</td></tr></table>");

	footer();
}


/*
 * Remove group
 */

void page_27(Database& db,db::Users *user,Cookies *cs)
{
	header0("Remove group",1,cs);
	footer();
}


void import_form(Database& db,Query& q,char *sql,db::Dbs *sdb,Cookies *cs,long usernum)
{
	header0("Import database from .sql file",1,cs);
	fflush(out);

	fprintf(out,"<form action='/cgi-bin/dbd/dbd' method=post enctype='multipart/form-data'>");
	fprintf(out,"<input type=hidden name=import value=1>");
	fprintf(out,"<p>.sql file<br>"
		"<input type=file name=the_file value='%s'></p>", import_filename.c_str());
	fprintf(out,"<p><input type=submit name=submit value=' Import '></p>");
	fprintf(out,"</form>");
	if (import_filename.size() && usernum)
	{
		fprintf(out,"<h3>Import results</h3>");
		fprintf(out,"<div style='background: #c0c0c0; color: #ff0000;'>");
		import(db, import_filename, usernum);
		fprintf(out,"</div>");
	}
	//
	footer();
}



