// reserved.cpp
/*
Copyright (C) 2001-2004  Anders Hedstrom (grymse@alhem.net)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
#include <stdio.h>
#include <string.h>
#include <string>
#include <libcgi++.h>
#ifdef WIN32
#define strcasecmp stricmp
#endif

#include "reserved.h"

static	char *words = "action\n"
"add\n"
"aggregate\n"
"all\n"
"alter\n"
"after\n"
"and\n"
"as\n"
"asc\n"
"avg\n"
"avg_row_length\n"
"auto_increment\n"
"between\n"
"bigint\n"
"bit\n"
"binary\n"
"blob\n"
"bool\n"
"both\n"
"by\n"
"cascade\n"
"case\n"
"char\n"
"character\n"
"change\n"
"check\n"
"checksum\n"
"column\n"
"columns\n"
"comment\n"
"constraint\n"
"create\n"
"cross\n"
"current_date\n"
"current_time\n"
"current_timestamp\n"
"data\n"
"database\n"
"databases\n"
"date\n"
"datetime\n"
"day\n"
"day_hour\n"
"day_minute\n"
"day_second\n"
"dayofmonth\n"
"dayofweek\n"
"dayofyear\n"
"dec\n"
"decimal\n"
"default\n"
"delayed\n"
"delay_key_write\n"
"delete\n"
"desc\n"
"describe\n"
"distinct\n"
"distinctrow\n"
"double\n"
"drop\n"
"end\n"
"else\n"
"escape\n"
"escaped\n"
"enclosed\n"
"enum\n"
"explain\n"
"exists\n"
"fields\n"
"file\n"
"first\n"
"float\n"
"float4\n"
"float8\n"
"flush\n"
"foreign\n"
"from\n"
"for\n"
"full\n"
"function\n"
"global\n"
"grant\n"
"grants\n"
"group\n"
"having\n"
"heap\n"
"high_priority\n"
"hour\n"
"hour_minute\n"
"hour_second\n"
"hosts\n"
"identified\n"
"ignore\n"
"in\n"
"index\n"
"infile\n"
"inner\n"
"insert\n"
"insert_id\n"
"int\n"
"integer\n"
"interval\n"
"int1\n"
"int2\n"
"int3\n"
"int4\n"
"int8\n"
"into\n"
"if\n"
"is\n"
"isam\n"
"join\n"
"key\n"
"keys\n"
"kill\n"
"last_insert_id\n"
"leading\n"
"left\n"
"length\n"
"like\n"
"lines\n"
"limit\n"
"load\n"
"local\n"
"lock\n"
"logs\n"
"long\n"
"longblob\n"
"longtext\n"
"low_priority\n"
"max\n"
"max_rows\n"
"match\n"
"mediumblob\n"
"mediumtext\n"
"mediumint\n"
"middleint\n"
"min_rows\n"
"minute\n"
"minute_second\n"
"modify\n"
"month\n"
"monthname\n"
"myisam\n"
"natural\n"
"numeric\n"
"no\n"
"not\n"
"null\n"
"on\n"
"optimize\n"
"option\n"
"optionally\n"
"or\n"
"order\n"
"outer\n"
"outfile\n"
"pack_keys\n"
"partial\n"
"password\n"
"precision\n"
"primary\n"
"procedure\n"
"process\n"
"processlist\n"
"privileges\n"
"read\n"
"real\n"
"references\n"
"reload\n"
"regexp\n"
"rename\n"
"replace\n"
"restrict\n"
"returns\n"
"revoke\n"
"rlike\n"
"row\n"
"rows\n"
"second\n"
"select\n"
"set\n"
"show\n"
"shutdown\n"
"smallint\n"
"soname\n"
"sql_big_tables\n"
"sql_big_selects\n"
"sql_low_priority_updates\n"
"sql_log_off\n"
"sql_log_update\n"
"sql_select_limit\n"
"sql_small_result\n"
"sql_big_result\n"
"sql_warnings\n"
"straight_join\n"
"starting\n"
"status\n"
"string\n"
"table\n"
"tables\n"
"temporary\n"
"terminated\n"
"text\n"
"then\n"
"time\n"
"timestamp\n"
"tinyblob\n"
"tinytext\n"
"tinyint\n"
"trailing\n"
"to\n"
"type\n"
"use\n"
"using\n"
"unique\n"
"unlock\n"
"unsigned\n"
"update\n"
"usage\n"
"values\n"
"varchar\n"
"variables\n"
"varying\n"
"varbinary\n"
"with\n"
"write\n"
"when\n"
"where\n"
"year\n"
"year_month\n"
"zerofill\n"
"\n"
"";

short is_reserved(char *s)
{
	cgi::Parse *pa;
	char slask[40];

	pa = new cgi::Parse(words);
	pa -> getword(slask);
	while (*slask)
	{
		if (!strcasecmp(s,slask))
		{
			delete pa;
			return 1;
		}
		pa -> getword(slask);
	}
	delete pa;
	return 0;	// ok
}

