/*
 *	 /usr/devel/include/libdbd.h
 *	 Generated by sql2class v1.8.1 by (C) AH 2000-2006
 *	  using command line
 *	  $ sql2class -build -global -stl -lib libdbd -database dbd str-dbd -overwrite -namespace db -getset
 *	 Date: Thu Apr 20 20:58:57 2006
 */

/*
Copyright (C) 2001-2006  Anders Hedstrom (grymse@alhem.net)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <mysql/mysql.h>
#include <libmysqlwrapped.h>
#include <map>

#include <vector>
#include <string>

#ifndef _LIBDBD_H
#define _LIBDBD_H

#ifdef _WIN32
#define strncasecmp strnicmp
#define strcasecmp stricmp
#endif // _WIN32

/**
 **  Class 'Access' and 'cAccess'
 **/

namespace db
{
class Access {
public:
	Access(Database *);
	Access(Database *,const std::string& );
	Access(Database *,Query *,int = 0 /* offset */);
	Access(Database&,long num);
	~Access();
	unsigned long long int insert();
	void update();
	void save();
	void erase();
	std::string xml();
	std::string xml(const std::string& ,const std::string& );
	size_t num_cols();

	// table columns
	long                     num; // int(11)
	long                     usernum; // int(11)
	long                     dbnum; // int(11)
	char                     r; // tinyint(1)
	char                     w; // tinyint(1)
	char                     c; // tinyint(1)
	char                     d; // tinyint(1)
	char                     rdata; // tinyint(1)
	char                     wdata; // tinyint(1)
	//
private:
	void clear();
	void spawn(const std::string& );
	void spawn(Query *,int = 0 /* offset */);
	void select(const std::string& );
	void update(long num);
	//
	Database *database;
	short new_object;
}; // End of class 'Access'

} // end of namespace

/**
 **  Class 'Appfields' and 'cAppfields'
 **/

namespace db
{
class Appfields {
	// map for ENUM column status
	std::map<std::string, uint64_t> mmap_status;

public:
	Appfields(Database *);
	Appfields(Database *,const std::string& );
	Appfields(Database *,Query *,int = 0 /* offset */);
	Appfields(Database&,long num);
	~Appfields();
	unsigned long long int insert();
	void update();
	void save();
	void erase();
	std::string xml();
	std::string xml(const std::string& ,const std::string& );
	size_t num_cols();

	// table columns
	long                     num; // int(11)
	long                     appnum; // int(11)
	long                     fldnum; // int(11)
	enum_t                   status; // enum('Planned','Implemented','Hold')
	long                     tblnum; // int(11)
	//
private:
	void clear();
	void spawn(const std::string& );
	void spawn(Query *,int = 0 /* offset */);
	void select(const std::string& );
	void update(long num);
	//
	Database *database;
	short new_object;
}; // End of class 'Appfields'

} // end of namespace

/**
 **  Class 'Applications' and 'cApplications'
 **/

namespace db
{
class Applications {
public:
	Applications(Database *);
	Applications(Database *,const std::string& );
	Applications(Database *,Query *,int = 0 /* offset */);
	Applications(Database&,long num);
	~Applications();
	unsigned long long int insert();
	void update();
	void save();
	void erase();
	std::string xml();
	std::string xml(const std::string& ,const std::string& );
	size_t num_cols();

	// table columns
	long                     num; // int(11)
	long                     owner; // int(11)
	std::string              createdate; // datetime
	long                     changedby; // int(11)
	std::string              changedate; // datetime
	char                     deleted; // tinyint(1)
	long                     deletedby; // int(11)
	std::string              deletedate; // datetime
	std::string              name; // char(40)
	long                     version; // int(11)
	long                     dbnum; // int(11)
	std::string              description; // char(40)
	//
private:
	void clear();
	void spawn(const std::string& );
	void spawn(Query *,int = 0 /* offset */);
	void select(const std::string& );
	void update(long num);
	//
	Database *database;
	short new_object;
}; // End of class 'Applications'

} // end of namespace

/**
 **  Class 'Apptables' and 'cApptables'
 **/

namespace db
{
class Apptables {
public:
	Apptables(Database *);
	Apptables(Database *,const std::string& );
	Apptables(Database *,Query *,int = 0 /* offset */);
	Apptables(Database&,long num);
	~Apptables();
	unsigned long long int insert();
	void update();
	void save();
	void erase();
	std::string xml();
	std::string xml(const std::string& ,const std::string& );
	size_t num_cols();

	// table columns
	long                     num; // int(11)
	long                     appnum; // int(11)
	long                     tblnum; // int(11)
	char                     checked; // tinyint(1)
	//
private:
	void clear();
	void spawn(const std::string& );
	void spawn(Query *,int = 0 /* offset */);
	void select(const std::string& );
	void update(long num);
	//
	Database *database;
	short new_object;
}; // End of class 'Apptables'

} // end of namespace

/**
 **  Class 'Appusers' and 'cAppusers'
 **/

namespace db
{
class Appusers {
	// map for ENUM column status
	std::map<std::string, uint64_t> mmap_status;

public:
	Appusers(Database *);
	Appusers(Database *,const std::string& );
	Appusers(Database *,Query *,int = 0 /* offset */);
	Appusers(Database&,long num);
	~Appusers();
	unsigned long long int insert();
	void update();
	void save();
	void erase();
	std::string xml();
	std::string xml(const std::string& ,const std::string& );
	size_t num_cols();

	// table columns
	long                     num; // int(11)
	long                     appnum; // int(11)
	long                     usernum; // int(11)
	enum_t                   status; // enum('Developer','Tester')
	//
private:
	void clear();
	void spawn(const std::string& );
	void spawn(Query *,int = 0 /* offset */);
	void select(const std::string& );
	void update(long num);
	//
	Database *database;
	short new_object;
}; // End of class 'Appusers'

} // end of namespace

/**
 **  Class 'Dbs' and 'cDbs'
 **/

namespace db
{
class Dbs {
public:
	Dbs(Database *);
	Dbs(Database *,const std::string& );
	Dbs(Database *,Query *,int = 0 /* offset */);
	Dbs(Database&,long num);
	~Dbs();
	unsigned long long int insert();
	void update();
	void save();
	void erase();
	std::string xml();
	std::string xml(const std::string& ,const std::string& );
	size_t num_cols();

	// table columns
	long                     num; // int(11)
	long                     owner; // int(11)
	std::string              createdate; // datetime
	long                     changedby; // int(11)
	std::string              changedate; // datetime
	char                     deleted; // tinyint(1)
	long                     deletedby; // int(11)
	std::string              deletedate; // datetime
	std::string              name; // char(40)
	long                     version; // int(11)
	std::string              description; // char(80)
	//
private:
	void clear();
	void spawn(const std::string& );
	void spawn(Query *,int = 0 /* offset */);
	void select(const std::string& );
	void update(long num);
	//
	Database *database;
	short new_object;
}; // End of class 'Dbs'

} // end of namespace

/**
 **  Class 'Flds' and 'cFlds'
 **/

namespace db
{
class Flds {
public:
	Flds(Database *);
	Flds(Database *,const std::string& );
	Flds(Database *,Query *,int = 0 /* offset */);
	Flds(Database&,long num);
	~Flds();
	unsigned long long int insert();
	void update();
	void save();
	void erase();
	std::string xml();
	std::string xml(const std::string& ,const std::string& );
	size_t num_cols();

	// table columns
	long                     num; // int(11)
	long                     tblnum; // int(11)
	long                     owner; // int(11)
	std::string              createdate; // datetime
	long                     changedby; // int(11)
	std::string              changedate; // datetime
	char                     deleted; // tinyint(1)
	long                     deletedby; // int(11)
	std::string              deletedate; // datetime
	std::string              name; // varchar(40)
	long                     version; // int(11)
	char                     fieldtype; // tinyint(1)
	long                     charlength; // int(11)
	long                     minvalue; // int(11)
	long                     maxvalue; // int(11)
	std::string              options; // text
	long                     ptrtotblnum; // int(11)
	long                     ordning; // int(11)
	long                     integerlength; // int(11)
	std::string              description; // varchar(80)
	std::string              fieldstr; // varchar(20)
	char                     fieldflags; // tinyint(3)
	long                     decimallength; // int(11)
	std::string              defaultvalue; // varchar(40)
	//
private:
	void clear();
	void spawn(const std::string& );
	void spawn(Query *,int = 0 /* offset */);
	void select(const std::string& );
	void update(long num);
	//
	Database *database;
	short new_object;
}; // End of class 'Flds'

} // end of namespace

/**
 **  Class 'Grplinks' and 'cGrplinks'
 **/

namespace db
{
class Grplinks {
public:
	Grplinks(Database *);
	Grplinks(Database *,const std::string& );
	Grplinks(Database *,Query *,int = 0 /* offset */);
	Grplinks(Database&,long num);
	~Grplinks();
	unsigned long long int insert();
	void update();
	void save();
	void erase();
	std::string xml();
	std::string xml(const std::string& ,const std::string& );
	size_t num_cols();

	// table columns
	long                     num; // int(11)
	long                     usernum; // int(11)
	long                     grpnum; // int(11)
	long                     dbnum; // int(11)
	//
private:
	void clear();
	void spawn(const std::string& );
	void spawn(Query *,int = 0 /* offset */);
	void select(const std::string& );
	void update(long num);
	//
	Database *database;
	short new_object;
}; // End of class 'Grplinks'

} // end of namespace

/**
 **  Class 'Grps' and 'cGrps'
 **/

namespace db
{
class Grps {
public:
	Grps(Database *);
	Grps(Database *,const std::string& );
	Grps(Database *,Query *,int = 0 /* offset */);
	Grps(Database&,long num);
	~Grps();
	unsigned long long int insert();
	void update();
	void save();
	void erase();
	std::string xml();
	std::string xml(const std::string& ,const std::string& );
	size_t num_cols();

	// table columns
	long                     num; // int(11)
	std::string              name; // char(40)
	long                     usernum; // int(11)
	//
private:
	void clear();
	void spawn(const std::string& );
	void spawn(Query *,int = 0 /* offset */);
	void select(const std::string& );
	void update(long num);
	//
	Database *database;
	short new_object;
}; // End of class 'Grps'

} // end of namespace

/**
 **  Class 'Indexlist' and 'cIndexlist'
 **/

namespace db
{
class Indexlist {
public:
	Indexlist(Database *);
	Indexlist(Database *,const std::string& );
	Indexlist(Database *,Query *,int = 0 /* offset */);
	Indexlist(Database&,long num);
	~Indexlist();
	unsigned long long int insert();
	void update();
	void save();
	void erase();
	std::string xml();
	std::string xml(const std::string& ,const std::string& );
	size_t num_cols();

	// table columns
	long                     num; // int(11)
	long                     indexnum; // int(11)
	long                     fldnum; // int(11)
	long                     length; // int(11)
	//
private:
	void clear();
	void spawn(const std::string& );
	void spawn(Query *,int = 0 /* offset */);
	void select(const std::string& );
	void update(long num);
	//
	Database *database;
	short new_object;
}; // End of class 'Indexlist'

} // end of namespace

/**
 **  Class 'Indexs' and 'cIndexs'
 **/

namespace db
{
class Indexs {
	// map for ENUM column typ
	std::map<std::string, uint64_t> mmap_typ;

public:
	Indexs(Database *);
	Indexs(Database *,const std::string& );
	Indexs(Database *,Query *,int = 0 /* offset */);
	Indexs(Database&,long num);
	~Indexs();
	unsigned long long int insert();
	void update();
	void save();
	void erase();
	std::string xml();
	std::string xml(const std::string& ,const std::string& );
	size_t num_cols();

	// table columns
	long                     num; // int(11)
	long                     owner; // int(11)
	std::string              createdate; // datetime
	long                     changedby; // int(11)
	std::string              changedate; // datetime
	char                     deleted; // tinyint(1)
	long                     deletedby; // int(11)
	std::string              deletedate; // datetime
	std::string              name; // char(40)
	long                     version; // int(11)
	long                     tblnum; // int(11)
	enum_t                   typ; // enum('INDEX','PRIMARY','UNIQUE','FULLTEXT')
	std::string              description; // char(40)
	//
private:
	void clear();
	void spawn(const std::string& );
	void spawn(Query *,int = 0 /* offset */);
	void select(const std::string& );
	void update(long num);
	//
	Database *database;
	short new_object;
}; // End of class 'Indexs'

} // end of namespace

/**
 **  Class 'Kommentar' and 'cKommentar'
 **/

namespace db
{
class Kommentar {
public:
	Kommentar(Database *);
	Kommentar(Database *,const std::string& );
	Kommentar(Database *,Query *,int = 0 /* offset */);
	Kommentar(Database&,long num);
	~Kommentar();
	unsigned long long int insert();
	void update();
	void save();
	void erase();
	std::string xml();
	std::string xml(const std::string& ,const std::string& );
	size_t num_cols();

	// table columns
	long                     num; // int(11)
	long                     dbnum; // int(11)
	long                     tblnum; // int(11)
	long                     fldnum; // int(11)
	long                     usernum; // int(11)
	std::string              dateposted; // datetime
	std::string              reason; // varchar(80)
	std::string              kommentar; // text
	long                     indexnum; // int(11)
	long                     appnum; // int(11)
	//
private:
	void clear();
	void spawn(const std::string& );
	void spawn(Query *,int = 0 /* offset */);
	void select(const std::string& );
	void update(long num);
	//
	Database *database;
	short new_object;
}; // End of class 'Kommentar'

} // end of namespace

/**
 **  Class 'Tblgrps' and 'cTblgrps'
 **/

namespace db
{
class Tblgrps {
public:
	Tblgrps(Database *);
	Tblgrps(Database *,const std::string& );
	Tblgrps(Database *,Query *,int = 0 /* offset */);
	Tblgrps(Database&,long num);
	~Tblgrps();
	unsigned long long int insert();
	void update();
	void save();
	void erase();
	std::string xml();
	std::string xml(const std::string& ,const std::string& );
	size_t num_cols();

	// table columns
	long                     num; // int(11)
	std::string              name; // char(40)
	long                     dbnum; // int(11)
	//
private:
	void clear();
	void spawn(const std::string& );
	void spawn(Query *,int = 0 /* offset */);
	void select(const std::string& );
	void update(long num);
	//
	Database *database;
	short new_object;
}; // End of class 'Tblgrps'

} // end of namespace

/**
 **  Class 'Tbls' and 'cTbls'
 **/

namespace db
{
class Tbls {
public:
	Tbls(Database *);
	Tbls(Database *,const std::string& );
	Tbls(Database *,Query *,int = 0 /* offset */);
	Tbls(Database&,long num);
	~Tbls();
	unsigned long long int insert();
	void update();
	void save();
	void erase();
	std::string xml();
	std::string xml(const std::string& ,const std::string& );
	size_t num_cols();

	// table columns
	long                     num; // int(11)
	long                     dbnum; // int(11)
	long                     owner; // int(11)
	std::string              createdate; // datetime
	long                     changedby; // int(11)
	std::string              changedate; // datetime
	char                     deleted; // tinyint(1)
	long                     deletedby; // int(11)
	std::string              deletedate; // datetime
	std::string              name; // char(40)
	long                     version; // int(11)
	std::string              description; // char(80)
	long                     tblgrpnum; // int(11)
	//
private:
	void clear();
	void spawn(const std::string& );
	void spawn(Query *,int = 0 /* offset */);
	void select(const std::string& );
	void update(long num);
	//
	Database *database;
	short new_object;
}; // End of class 'Tbls'

} // end of namespace

/**
 **  Class 'Users' and 'cUsers'
 **/

namespace db
{
class Users {
public:
	Users(Database *);
	Users(Database *,const std::string& );
	Users(Database *,Query *,int = 0 /* offset */);
	Users(Database&,long num);
	~Users();
	unsigned long long int insert();
	void update();
	void save();
	void erase();
	std::string xml();
	std::string xml(const std::string& ,const std::string& );
	size_t num_cols();

	// table columns
	long                     num; // int(11)
	std::string              handle; // char(20)
	std::string              name; // char(40)
	std::string              password; // char(20)
	char                     superuser; // tinyint(1)
	std::string              email; // char(60)
	std::string              icq; // char(20)
	std::string              prevdatum; // datetime
	std::string              thisdatum; // datetime
	long                     maxdbs; // int(11)
	long                     maxtbls; // int(11)
	long                     maxflds; // int(11)
	long                     flags; // int(11)
	long                     steps; // int(11)
	long                     maxindexs; // int(11)
	long                     maxapps; // int(11)
	long                     cutoff; // int(11)
	//
private:
	void clear();
	void spawn(const std::string& );
	void spawn(Query *,int = 0 /* offset */);
	void select(const std::string& );
	void update(long num);
	//
	Database *database;
	short new_object;
}; // End of class 'Users'

} // end of namespace

/**
 **  Class 'Valid' and 'cValid'
 **/

namespace db
{
class Valid {
public:
	Valid(Database *);
	Valid(Database *,const std::string& );
	Valid(Database *,Query *,int = 0 /* offset */);
	Valid(Database&,long num);
	~Valid();
	unsigned long long int insert();
	void update();
	void save();
	void erase();
	std::string xml();
	std::string xml(const std::string& ,const std::string& );
	size_t num_cols();

	// table columns
	long                     num; // int(11)
	long                     usernum; // int(11)
	long                     valid; // int(11)
	//
private:
	void clear();
	void spawn(const std::string& );
	void spawn(Query *,int = 0 /* offset */);
	void select(const std::string& );
	void update(long num);
	//
	Database *database;
	short new_object;
}; // End of class 'Valid'

} // end of namespace
#endif // _LIBDBD_H
